/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.42.0-dev-20230911(51ba6777fc7bab43da4091e4a42220960836ca23)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arrays","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(T){for(var n=[],A=0,D=T.length;A<D;A++)n[A]=X[T[A]];return n};const Ee=this,Re=typeof global=="object"?global:{};var oe;(function(T){T.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}T.Environment=n})(oe||(oe={}));var oe;(function(T){class n{constructor(h,g,_){this.type=h,this.detail=g,this.timestamp=_}}T.LoaderEvent=n;class A{constructor(h){this._events=[new n(1,"",h)]}record(h,g){this._events.push(new n(h,g,T.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}T.LoaderEventRecorder=A;class D{record(h,g){}getEvents(){return[]}}D.INSTANCE=new D,T.NullLoaderEventRecorder=D})(oe||(oe={}));var oe;(function(T){class n{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let h;for(h in D)D.hasOwnProperty(h)&&i(h,D[h])}}static isEmpty(D){let i=!0;return n.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return n.forEachProperty(D,(h,g)=>{g&&typeof g=="object"?i[h]=n.recursiveClone(g):i[h]=g}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return n.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,T.Utilities=n})(oe||(oe={}));var oe;(function(T){function n(i){if(i instanceof Error)return i;const h=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(h.stack=i.stack),h}T.ensureError=n;class A{static validateConfigurationOptions(h){function g(_){if(_.phase==="loading"){console.error('Loading "'+_.moduleId+'" failed'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}if(_.phase==="factory"){console.error('The factory function of "'+_.moduleId+'" has thrown an exception'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=g),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(T.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const _=n(new Error("INVALID cached data configuration, 'path' MUST be set"));_.phase="configuration",h.onError(_),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,g=null){let _=T.Utilities.recursiveClone(g||{});return T.Utilities.forEachProperty(h,(l,o)=>{l==="ignoreDuplicateModules"&&typeof _.ignoreDuplicateModules<"u"?_.ignoreDuplicateModules=_.ignoreDuplicateModules.concat(o):l==="paths"&&typeof _.paths<"u"?T.Utilities.forEachProperty(o,(v,e)=>_.paths[v]=e):l==="config"&&typeof _.config<"u"?T.Utilities.forEachProperty(o,(v,e)=>_.config[v]=e):_[l]=T.Utilities.recursiveClone(o)}),A.validateConfigurationOptions(_)}}T.ConfigurationOptionsUtil=A;class D{constructor(h,g){if(this._env=h,this.options=A.mergeConfigurationOptions(g),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let _=this.options.nodeRequire.main.filename,l=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,(h,g)=>{Array.isArray(g)?this.sortedPathsRules.push({from:h,to:g}):this.sortedPathsRules.push({from:h,to:[g]})}),this.sortedPathsRules.sort((h,g)=>g.from.length-h.from.length)}cloneAndMerge(h){return new D(this._env,A.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let g;for(let _=0,l=this.sortedPathsRules.length;_<l;_++)if(g=this.sortedPathsRules[_],T.Utilities.startsWith(h,g.from)){let o=[];for(let v=0,e=g.to.length;v<e;v++)o.push(g.to[v]+h.substr(g.from.length));return o}return[h]}_addUrlArgsToUrl(h){return T.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let g=0,_=h.length;g<_;g++)h[g]=this._addUrlArgsToUrl(h[g]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let g=h,_;if(!T.Utilities.endsWith(g,".js")&&!T.Utilities.isAbsolutePath(g)){_=this._applyPaths(g);for(let l=0,o=_.length;l<o;l++)this.isBuild()&&_[l]==="empty:"||(T.Utilities.isAbsolutePath(_[l])||(_[l]=this.options.baseUrl+_[l]),!T.Utilities.endsWith(_[l],".js")&&!T.Utilities.containsQueryString(_[l])&&(_[l]=_[l]+".js"))}else!T.Utilities.endsWith(g,".js")&&!T.Utilities.containsQueryString(g)&&(g=g+".js"),_=[g];return this._addUrlArgsIfNecessaryToUrls(_)}requireToUrl(h){let g=h;return T.Utilities.isAbsolutePath(g)||(g=this._applyPaths(g)[0],T.Utilities.isAbsolutePath(g)||(g=this.options.baseUrl+g)),this._addUrlArgsIfNecessaryToUrl(g)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||T.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}T.Configuration=D})(oe||(oe={}));var oe;(function(T){class n{constructor(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}load(o,v,e,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:f}=o.getConfig().getOptionsLiteral();f?this._scriptLoader=new A:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new A;let u={callback:e,errorback:b};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(u);return}this._callbackMap[v]=[u],this._scriptLoader.load(o,v,()=>this.triggerCallback(v),f=>this.triggerErrorback(v,f))}triggerCallback(o){let v=this._callbackMap[o];delete this._callbackMap[o];for(let e=0;e<v.length;e++)v[e].callback()}triggerErrorback(o,v){let e=this._callbackMap[o];delete this._callbackMap[o];for(let b=0;b<e.length;b++)e[b].errorback(v)}}class A{attachListeners(o,v,e){let b=()=>{o.removeEventListener("load",u),o.removeEventListener("error",f)},u=m=>{b(),v()},f=m=>{b(),e(m)};o.addEventListener("load",u),o.addEventListener("error",f)}load(o,v,e,b){if(/^node\|/.test(v)){let u=o.getConfig().getOptionsLiteral(),f=g(o.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=v.split("|"),c=null;try{c=f(m[1])}catch(N){b(N);return}o.enqueueDefineAnonymousModule([],()=>c),e()}else{let u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript"),this.attachListeners(u,e,b);const{trustedTypesPolicy:f}=o.getConfig().getOptionsLiteral();f&&(v=f.createScriptURL(v)),u.setAttribute("src",v);const{cspNonce:m}=o.getConfig().getOptionsLiteral();m&&u.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(u)}}}function D(l){const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();try{return(o?self.eval(o.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(o)),this._cachedCanUseEval}load(o,v,e,b){if(/^node\|/.test(v)){const u=o.getConfig().getOptionsLiteral(),f=g(o.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=v.split("|");let c=null;try{c=f(m[1])}catch(N){b(N);return}o.enqueueDefineAnonymousModule([],function(){return c}),e()}else{const{trustedTypesPolicy:u}=o.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(o)){fetch(v).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${v}`,(u?self.eval(u.createScript("",m)):new Function(m)).call(self),e()}).then(void 0,b);return}try{u&&(v=u.createScriptURL(v)),importScripts(v),e()}catch(m){b(m)}}}}class h{constructor(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))}_initNodeRequire(o,v){const{nodeCachedData:e}=v.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,u=o("module");function f(m){const c=m.constructor;let N=function(y){try{return m.require(y)}finally{}};return N.resolve=function(y,p){return c._resolveFilename(y,m,!1,p)},N.resolve.paths=function(y){return c._resolveLookupPaths(y,m)},N.main=process.mainModule,N.extensions=c._extensions,N.cache=c._cache,N}u.prototype._compile=function(m,c){const N=u.wrap(m.replace(/^#!.*/,"")),C=v.getRecorder(),y=b._getCachedDataPath(e,c),p={filename:c};let S;try{const R=b._fs.readFileSync(y);S=R.slice(0,16),p.cachedData=R.slice(16),C.record(60,y)}catch{C.record(61,y)}const r=new b._vm.Script(N,p),s=r.runInThisContext(p),a=b._path.dirname(c),L=f(this),d=[this.exports,L,this,c,a,process,Re,Buffer],w=s.apply(this.exports,d);return b._handleCachedData(r,N,y,!p.cachedData,v),b._verifyCachedData(r,N,y,S,v),w}}load(o,v,e,b){const u=o.getConfig().getOptionsLiteral(),f=g(o.getRecorder(),u.nodeRequire||T.global.nodeRequire),m=u.nodeInstrumenter||function(N){return N};this._init(f),this._initNodeRequire(f,o);let c=o.getRecorder();if(/^node\|/.test(v)){let N=v.split("|"),C=null;try{C=f(N[1])}catch(y){b(y);return}o.enqueueDefineAnonymousModule([],()=>C),e()}else{v=T.Utilities.fileUriToFilePath(this._env.isWindows,v);const N=this._path.normalize(v),C=this._getElectronRendererScriptPathOrUri(N),y=!!u.nodeCachedData,p=y?this._getCachedDataPath(u.nodeCachedData,v):void 0;this._readSourceAndCachedData(N,p,c,(S,r,s,a)=>{if(S){b(S);return}let L;r.charCodeAt(0)===h._BOM?L=h._PREFIX+r.substring(1)+h._SUFFIX:L=h._PREFIX+r+h._SUFFIX,L=m(L,N);const d={filename:C,cachedData:s},w=this._createAndEvalScript(o,L,d,e,b);this._handleCachedData(w,L,p,y&&!s,o),this._verifyCachedData(w,L,p,a,o)})}}_createAndEvalScript(o,v,e,b,u){const f=o.getRecorder();f.record(31,e.filename);const m=new this._vm.Script(v,e),c=m.runInThisContext(e),N=o.getGlobalAMDDefineFunc();let C=!1;const y=function(){return C=!0,N.apply(null,arguments)};return y.amd=N.amd,c.call(T.global,o.getGlobalAMDRequireFunc(),y,e.filename,this._path.dirname(e.filename)),f.record(32,e.filename),C?b():u(new Error(`Didn't receive define call in ${e.filename}!`)),m}_getElectronRendererScriptPathOrUri(o){if(!this._env.isElectronRenderer)return o;let v=o.match(/^([a-z])\:(.*)/i);return v?`file:///${(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/")}`:`file://${o}`}_getCachedDataPath(o,v){const e=this._crypto.createHash("md5").update(v,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(v).replace(/\.js$/,"");return this._path.join(o.path,`${b}-${e}.code`)}_handleCachedData(o,v,e,b,u){o.cachedDataRejected?this._fs.unlink(e,f=>{u.getRecorder().record(62,e),this._createAndWriteCachedData(o,v,e,u),f&&u.getConfig().onError(f)}):b&&this._createAndWriteCachedData(o,v,e,u)}_createAndWriteCachedData(o,v,e,b){let u=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),f=-1,m=0,c;const N=()=>{setTimeout(()=>{c||(c=this._crypto.createHash("md5").update(v,"utf8").digest());const C=o.createCachedData();if(!(C.length===0||C.length===f||m>=5)){if(C.length<f){N();return}f=C.length,this._fs.writeFile(e,Buffer.concat([c,C]),y=>{y&&b.getConfig().onError(y),b.getRecorder().record(63,e),N()})}},u*Math.pow(4,m++))};N()}_readSourceAndCachedData(o,v,e,b){if(!v)this._fs.readFile(o,{encoding:"utf8"},b);else{let u,f,m,c=2;const N=C=>{C?b(C):--c===0&&b(void 0,u,f,m)};this._fs.readFile(o,{encoding:"utf8"},(C,y)=>{u=y,N(C)}),this._fs.readFile(v,(C,y)=>{!C&&y&&y.length>0?(m=y.slice(0,16),f=y.slice(16),e.record(60,v)):e.record(61,v),N()})}}_verifyCachedData(o,v,e,b,u){b&&(o.cachedDataRejected||setTimeout(()=>{const f=this._crypto.createHash("md5").update(v,"utf8").digest();b.equals(f)||(u.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,m=>{m&&u.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function g(l,o){if(o.__$__isRecorded)return o;const v=function(b){l.record(33,b);try{return o(b)}finally{l.record(34,b)}};return v.__$__isRecorded=!0,v}T.ensureRecordedNodeRequire=g;function _(l){return new n(l)}T.createScriptLoader=_})(oe||(oe={}));var oe;(function(T){class n{constructor(l){let o=l.lastIndexOf("/");o!==-1?this.fromModulePath=l.substr(0,o+1):this.fromModulePath=""}static _normalizeModuleId(l){let o=l,v;for(v=/\/\.\//;v.test(o);)o=o.replace(v,"/");for(o=o.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(o);)o=o.replace(v,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o}resolveModule(l){let o=l;return T.Utilities.isAbsolutePath(o)||(T.Utilities.startsWith(o,"./")||T.Utilities.startsWith(o,"../"))&&(o=n._normalizeModuleId(this.fromModulePath+o)),o}}n.ROOT=new n(""),T.ModuleIdResolver=n;class A{constructor(l,o,v,e,b,u){this.id=l,this.strId=o,this.dependencies=v,this._callback=e,this._errorback=b,this.moduleIdResolver=u,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,o){try{return{returnedValue:l.apply(T.global,o),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}}static _invokeFactory(l,o,v,e){return l.shouldInvokeFactory(o)?l.shouldCatchError()?this._safeInvokeFunction(v,e):{returnedValue:v.apply(T.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(l,o,v,e){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let u=A._invokeFactory(o,this.strId,this._callback,v);b=u.producedError,l.record(22,this.strId),!b&&typeof u.returnedValue<"u"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=u.returnedValue)}else this.exports=this._callback;if(b){let u=T.ensureError(b);u.phase="factory",u.moduleId=this.strId,u.neededBy=e(this.id),this.error=u,o.onError(u)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}T.Module=A;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let o=this._strModuleIdToIntModuleId.get(l);return typeof o>"u"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(l,o),this._intModuleIdToStrModuleId[o]=l),o}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class i{constructor(l){this.id=l}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),T.RegularDependency=i;class h{constructor(l,o,v){this.id=l,this.pluginId=o,this.pluginParam=v}}T.PluginDependency=h;class g{constructor(l,o,v,e,b=0){this._env=l,this._scriptLoader=o,this._loaderAvailableTimestamp=b,this._defineFunc=v,this._requireFunc=e,this._moduleIdProvider=new D,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new g(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,o){let v=u=>u.replace(/\\/g,"/"),e=v(l),b=o.split(/\n/);for(let u=0;u<b.length;u++){let f=b[u].match(/(.*):(\d+):(\d+)\)?$/);if(f){let m=f[1],c=f[2],N=f[3],C=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(C),m=v(m),m===e){let y={line:parseInt(c,10),col:parseInt(N,10)};return y.line===1&&(y.col-=53),y}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],o=0;for(let v=0,e=this._modules2.length;v<e;v++){let b=this._modules2[v];if(!b)continue;let u=this._buildInfoPath[b.id]||null,f=this._buildInfoDefineStack[b.id]||null,m=this._buildInfoDependencies[b.id];l[o++]={id:b.strId,path:u,defineLocation:u&&f?g._findRelevantLocationInStack(u,f):null,dependencies:m,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:l,callback:o}}defineModule(l,o,v,e,b,u=new n(l)){let f=this._moduleIdProvider.getModuleId(l);if(this._modules2[f]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let m=new A(f,l,this._normalizeDependencies(o,u),v,e,u);this._modules2[f]=m,this._config.isBuild()&&(this._buildInfoDefineStack[f]=b,this._buildInfoDependencies[f]=(m.dependencies||[]).map(c=>this._moduleIdProvider.getStrModuleId(c.id))),this._resolve(m)}_normalizeDependency(l,o){if(l==="exports")return i.EXPORTS;if(l==="module")return i.MODULE;if(l==="require")return i.REQUIRE;let v=l.indexOf("!");if(v>=0){let e=o.resolveModule(l.substr(0,v)),b=o.resolveModule(l.substr(v+1)),u=this._moduleIdProvider.getModuleId(e+"!"+b),f=this._moduleIdProvider.getModuleId(e);return new h(u,f,b)}return new i(this._moduleIdProvider.getModuleId(o.resolveModule(l)))}_normalizeDependencies(l,o){let v=[],e=0;for(let b=0,u=l.length;b<u;b++)v[e++]=this._normalizeDependency(l[b],o);return v}_relativeRequire(l,o,v,e){if(typeof o=="string")return this.synchronousRequire(o,l);this.defineModule(T.Utilities.generateAnonymousModule(),o,v,e,null,l)}synchronousRequire(l,o=new n(l)){let v=this._normalizeDependency(l,o),e=this._modules2[v.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(l,o){let v=this._config.shouldRecordStats();o?this._config=new T.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!v&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),o.dependencies,o.callback,null,o.stack)}}_createLoadError(l,o){let v=this._moduleIdProvider.getStrModuleId(l),e=(this._inverseDependencies2[l]||[]).map(u=>this._moduleIdProvider.getStrModuleId(u));const b=T.ensureError(o);return b.phase="loading",b.moduleId=v,b.neededBy=e,b}_onLoadError(l,o){const v=this._createLoadError(l,o);this._modules2[l]||(this._modules2[l]=new A(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let e=[];for(let f=0,m=this._moduleIdProvider.getMaxModuleId();f<m;f++)e[f]=!1;let b=!1,u=[];for(u.push(l),e[l]=!0;u.length>0;){let f=u.shift(),m=this._modules2[f];m&&(b=m.onDependencyError(v)||b);let c=this._inverseDependencies2[f];if(c)for(let N=0,C=c.length;N<C;N++){let y=c[N];e[y]||(u.push(y),e[y]=!0)}}b||this._config.onError(v)}_hasDependencyPath(l,o){let v=this._modules2[l];if(!v)return!1;let e=[];for(let u=0,f=this._moduleIdProvider.getMaxModuleId();u<f;u++)e[u]=!1;let b=[];for(b.push(v),e[l]=!0;b.length>0;){let f=b.shift().dependencies;if(f)for(let m=0,c=f.length;m<c;m++){let N=f[m];if(N.id===o)return!0;let C=this._modules2[N.id];C&&!e[N.id]&&(e[N.id]=!0,b.push(C))}}return!1}_findCyclePath(l,o,v){if(l===o||v===50)return[l];let e=this._modules2[l];if(!e)return null;let b=e.dependencies;if(b)for(let u=0,f=b.length;u<f;u++){let m=this._findCyclePath(b[u].id,o,v+1);if(m!==null)return m.push(l),m}return null}_createRequire(l){let o=(v,e,b)=>this._relativeRequire(l,v,e,b);return o.toUrl=v=>this._config.requireToUrl(l.resolveModule(v)),o.getStats=()=>this.getLoaderEvents(),o.hasDependencyCycle=()=>this._hasDependencyCycle,o.config=(v,e=!1)=>{this.configure(v,e)},o.__$__nodeRequire=T.global.nodeRequire,o}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let o=this._moduleIdProvider.getStrModuleId(l),v=this._config.moduleIdToPaths(o),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(o.indexOf("/")===-1||e.test(o))&&v.push("node|"+o);let b=-1,u=f=>{if(b++,b>=v.length)this._onLoadError(l,f);else{let m=v[b],c=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[l]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}c.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=m),c.record(11,m),this._onLoad(l)},N=>{c.record(12,m),u(N)})}};u(null)}_loadPluginDependency(l,o){if(this._modules2[o.id]||this._knownModules2[o.id])return;this._knownModules2[o.id]=!0;let v=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(o.id),[],e,null,null)};v.error=e=>{this._config.onError(this._createLoadError(o.id,e))},l.load(o.pluginParam,this._createRequire(n.ROOT),v,this._config.getOptionsLiteral())}_resolve(l){let o=l.dependencies;if(o)for(let v=0,e=o.length;v<e;v++){let b=o[v];if(b===i.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===i.MODULE){l.unresolvedDependenciesCount--;continue}if(b===i.REQUIRE){l.unresolvedDependenciesCount--;continue}let u=this._modules2[b.id];if(u&&u.isComplete()){if(u.error){l.onDependencyError(u.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let f=this._findCyclePath(b.id,l.id,0)||[];f.reverse(),f.push(b.id),console.warn(f.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof h){let f=this._modules2[b.pluginId];if(f&&f.isComplete()){this._loadPluginDependency(f.exports,b);continue}let m=this._inversePluginDependencies2.get(b.pluginId);m||(m=[],this._inversePluginDependencies2.set(b.pluginId,m)),m.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let o=this.getRecorder();if(l.isComplete())return;let v=l.dependencies,e=[];if(v)for(let m=0,c=v.length;m<c;m++){let N=v[m];if(N===i.EXPORTS){e[m]=l.exports;continue}if(N===i.MODULE){e[m]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(N===i.REQUIRE){e[m]=this._createRequire(l.moduleIdResolver);continue}let C=this._modules2[N.id];if(C){e[m]=C.exports;continue}e[m]=null}const b=m=>(this._inverseDependencies2[m]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));l.complete(o,this._config,e,b);let u=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,u)for(let m=0,c=u.length;m<c;m++){let N=u[m],C=this._modules2[N];C.unresolvedDependenciesCount--,C.unresolvedDependenciesCount===0&&this._onModuleComplete(C)}let f=this._inversePluginDependencies2.get(l.id);if(f){this._inversePluginDependencies2.delete(l.id);for(let m=0,c=f.length;m<c;m++)this._loadPluginDependency(l.exports,f[m])}}}T.ModuleManager=g})(oe||(oe={}));var Y,oe;(function(T){const n=new T.Environment;let A=null;const D=function(_,l,o){typeof _!="string"&&(o=l,l=_,_=null),(typeof l!="object"||!Array.isArray(l))&&(o=l,l=null),l||(l=["require","exports","module"]),_?A.defineModule(_,l,o,null,null):A.enqueueDefineAnonymousModule(l,o)};D.amd={jQuery:!0};const i=function(_,l=!1){A.configure(_,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=i,h.getConfig=function(){return A.getConfig().getOptionsLiteral()},h.reset=function(){A=A.reset()},h.getBuildInfo=function(){return A.getBuildInfo()},h.getStats=function(){return A.getLoaderEvents()},h.define=D;function g(){if(typeof T.global.require<"u"||typeof require<"u"){const _=T.global.require||require;if(typeof _=="function"&&typeof _.resolve=="function"){const l=T.ensureRecordedNodeRequire(A.getRecorder(),_);T.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=h:(n.isElectronRenderer||(T.global.define=D),T.global.require=h)}T.init=g,(typeof T.global.define!="function"||!T.global.define.amd)&&(A=new T.ModuleManager(n,T.createScriptLoader(n),D,h,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require<"u"&&typeof T.global.require!="function"&&h.config(T.global.require),Y=function(){return D.apply(null,arguments)},Y.amd=D.amd,typeof doNotInitLoader>"u"&&g())})(oe||(oe={}));var le=this&&this.__awaiter||function(T,n,A,D){function i(h){return h instanceof A?h:new A(function(g){g(h)})}return new(A||(A=Promise))(function(h,g){function _(v){try{o(D.next(v))}catch(e){g(e)}}function l(v){try{o(D.throw(v))}catch(e){g(e)}}function o(v){v.done?h(v.value):i(v.value).then(_,l)}o((D=D.apply(T,n||[])).next())})};Y(X[19],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(f,m){let c;return m.length===0?c=f:c=f.replace(/\{(\d+)\}/g,(N,C)=>{const y=C[0],p=m[y];let S=N;return typeof p=="string"?S=p:(typeof p=="number"||typeof p=="boolean"||p===void 0||p===null)&&(S=String(p)),S}),A&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function h(f,m){let c=f[m];return c||(c=f["*"],c)?c:null}function g(f){return f.charAt(f.length-1)==="/"?f:f+"/"}function _(f,m,c){return le(this,void 0,void 0,function*(){const N=g(f)+g(m)+"vscode/"+g(c),C=yield fetch(N);if(C.ok)return yield C.json();throw new Error(`${C.status} - ${C.statusText}`)})}function l(f){return function(m,c){const N=Array.prototype.slice.call(arguments,2);return i(f[m],N)}}function o(f,m,...c){return i(m,c)}n.localize=o;function v(f){}n.getConfiguredDefaultLocale=v;function e(f){A=f}n.setPseudoTranslation=e;function b(f,m){var c;return{localize:l(m[f]),getConfiguredDefaultLocale:(c=m.getConfiguredDefaultLocale)!==null&&c!==void 0?c:N=>{}}}n.create=b;function u(f,m,c,N){var C;const y=(C=N["vs/nls"])!==null&&C!==void 0?C:{};if(!f||f.length===0)return c({localize:o,getConfiguredDefaultLocale:()=>{var a;return(a=y.availableLanguages)===null||a===void 0?void 0:a["*"]}});const p=y.availableLanguages?h(y.availableLanguages,f):null,S=p===null||p===D;let r=".nls";S||(r=r+"."+p);const s=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[f]),a.getConfiguredDefaultLocale=()=>{var L;return(L=y.availableLanguages)===null||L===void 0?void 0:L["*"]},c(a)};typeof y.loadBundle=="function"?y.loadBundle(f,p,(a,L)=>{a?m([f+".nls"],s):s(L)}):y.translationServiceUrl&&!S?le(this,void 0,void 0,function*(){var a;try{const L=yield _(y.translationServiceUrl,p,f);return s(L)}catch(L){if(!p.includes("-"))return console.error(L),m([f+".nls"],s);try{const d=p.split("-")[0],w=yield _(y.translationServiceUrl,d,f);return(a=y.availableLanguages)!==null&&a!==void 0||(y.availableLanguages={}),y.availableLanguages["*"]=d,s(w)}catch(d){return console.error(d),m([f+".nls"],s)}}}):m([f+r],s,a=>{if(r===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${p}. Falling back to the default language:`,a),m([f+".nls"],s)})}n.load=u}),function(){const T=globalThis.MonacoEnvironment,n=T&&T.baseUrl?T.baseUrl:"../../../";function A(v,e){var b;if(T?.createTrustedTypesPolicy)try{return T.createTrustedTypesPolicy(v,e)}catch(u){console.warn(u);return}try{return(b=self.trustedTypes)===null||b===void 0?void 0:b.createPolicy(v,e)}catch(u){console.warn(u);return}}const D=A("amdLoader",{createScriptURL:v=>v,createScript:(v,...e)=>{const b=e.slice(0,-1).join(","),u=e.pop().toString();return`(function anonymous(${b}) { ${u}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((v,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return v();const b=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(b).then(f=>{if(f.status!==200)throw new Error(f.statusText);return f.text()}).then(f=>{f=`${f}
//# sourceURL=${b}`,(D?globalThis.eval(D.createScript("",f)):new Function(f)).call(globalThis),v()}).then(void 0,e);return}D?importScripts(D.createScriptURL(b)):importScripts(b),v()})}function g(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function _(v){h().then(()=>{g(),require([v],function(e){setTimeout(function(){const b=e.create((u,f)=>{globalThis.postMessage(u,f)},null);for(globalThis.onmessage=u=>b.onmessage(u.data,u.ports);o.length>0;){const u=o.shift();b.onmessage(u.data,u.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&g();let l=!0;const o=[];globalThis.onmessage=v=>{if(!l){o.push(v);return}l=!1,_(v.data)}}(),Y(X[8],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.forEachAdjacent=n.groupAdjacentBy=n.groupBy=n.quickSelect=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function A(k,x=0){return k[k.length-(1+x)]}n.tail=A;function D(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=D;function i(k,x,q=(W,z)=>W===z){if(k===x)return!0;if(!k||!x||k.length!==x.length)return!1;for(let W=0,z=k.length;W<z;W++)if(!q(k[W],x[W]))return!1;return!0}n.equals=i;function h(k,x){const q=k.length-1;x<q&&(k[x]=k[q]),k.pop()}n.removeFastWithoutKeepingOrder=h;function g(k,x,q){return _(k.length,W=>q(k[W],x))}n.binarySearch=g;function _(k,x){let q=0,W=k-1;for(;q<=W;){const z=(q+W)/2|0,G=x(z);if(G<0)q=z+1;else if(G>0)W=z-1;else return z}return-(q+1)}n.binarySearch2=_;function l(k,x,q){if(k=k|0,k>=x.length)throw new TypeError("invalid index");const W=x[Math.floor(x.length*Math.random())],z=[],G=[],t=[];for(const ne of x){const se=q(ne,W);se<0?z.push(ne):se>0?G.push(ne):t.push(ne)}return k<z.length?l(k,z,q):k<z.length+t.length?t[0]:l(k-(z.length+t.length),G,q)}n.quickSelect=l;function o(k,x){const q=[];let W;for(const z of k.slice(0).sort(x))!W||x(W[0],z)!==0?(W=[z],q.push(W)):W.push(z);return q}n.groupBy=o;function*v(k,x){let q,W;for(const z of k)W!==void 0&&x(W,z)?q.push(z):(q&&(yield q),q=[z]),W=z;q&&(yield q)}n.groupAdjacentBy=v;function e(k,x){for(let q=0;q<=k.length;q++)x(q===0?void 0:k[q-1],q===k.length?void 0:k[q])}n.forEachAdjacent=e;function b(k){return k.filter(x=>!!x)}n.coalesce=b;function u(k){let x=0;for(let q=0;q<k.length;q++)k[q]&&(k[x]=k[q],x+=1);k.length=x}n.coalesceInPlace=u;function f(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=f;function m(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=m;function c(k,x=q=>q){const q=new Set;return k.filter(W=>{const z=x(W);return q.has(z)?!1:(q.add(z),!0)})}n.distinct=c;function N(k,x){return k.length>0?k[0]:x}n.firstOrDefault=N;function C(k,x){let q=typeof x=="number"?k:0;typeof x=="number"?q=k:(q=0,x=k);const W=[];if(q<=x)for(let z=q;z<x;z++)W.push(z);else for(let z=q;z>x;z--)W.push(z);return W}n.range=C;function y(k,x,q){const W=k.slice(0,x),z=k.slice(x);return W.concat(q,z)}n.arrayInsert=y;function p(k,x){const q=k.indexOf(x);q>-1&&(k.splice(q,1),k.unshift(x))}n.pushToStart=p;function S(k,x){const q=k.indexOf(x);q>-1&&(k.splice(q,1),k.push(x))}n.pushToEnd=S;function r(k,x){for(const q of x)k.push(q)}n.pushMany=r;function s(k){return Array.isArray(k)?k:[k]}n.asArray=s;function a(k,x,q){const W=d(k,x),z=k.length,G=q.length;k.length=z+G;for(let t=z-1;t>=W;t--)k[t+G]=k[t];for(let t=0;t<G;t++)k[t+W]=q[t]}n.insertInto=a;function L(k,x,q,W){const z=d(k,x);let G=k.splice(z,q);return G===void 0&&(G=[]),a(k,z,W),G}n.splice=L;function d(k,x){return x<0?Math.max(x+k.length,0):Math.min(x,k.length)}var w;(function(k){function x(G){return G<0}k.isLessThan=x;function q(G){return G<=0}k.isLessThanOrEqual=q;function W(G){return G>0}k.isGreaterThan=W;function z(G){return G===0}k.isNeitherLessOrGreaterThan=z,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(w||(n.CompareResult=w={}));function R(k,x){return(q,W)=>x(k(q),k(W))}n.compareBy=R;function E(...k){return(x,q)=>{for(const W of k){const z=W(x,q);if(!w.isNeitherLessOrGreaterThan(z))return z}return w.neitherLessOrGreaterThan}}n.tieBreakComparators=E;const M=(k,x)=>k-x;n.numberComparator=M;const F=(k,x)=>(0,n.numberComparator)(k?1:0,x?1:0);n.booleanComparator=F;function B(k){return(x,q)=>-k(x,q)}n.reverseOrder=B;class I{constructor(x){this.items=x,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(x){let q=this.firstIdx;for(;q<this.items.length&&x(this.items[q]);)q++;const W=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,W}takeFromEndWhile(x){let q=this.lastIdx;for(;q>=0&&x(this.items[q]);)q--;const W=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const x=this.items[this.firstIdx];return this.firstIdx++,x}takeCount(x){const q=this.items.slice(this.firstIdx,this.firstIdx+x);return this.firstIdx+=x,q}}n.ArrayQueue=I;class U{constructor(x){this.iterate=x}toArray(){const x=[];return this.iterate(q=>(x.push(q),!0)),x}filter(x){return new U(q=>this.iterate(W=>x(W)?q(W):!0))}map(x){return new U(q=>this.iterate(W=>q(x(W))))}findLast(x){let q;return this.iterate(W=>(x(W)&&(q=W),!0)),q}findLastMaxBy(x){let q,W=!0;return this.iterate(z=>((W||w.isGreaterThan(x(z,q)))&&(W=!1,q=z),!0)),q}}n.CallbackIterable=U,U.empty=new U(k=>{})}),Y(X[11],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.mapFindFirst=n.findMaxIdxBy=n.findFirstMinBy=n.findLastMaxBy=n.findFirstMaxBy=n.MonotonousArray=n.findFirstIdxMonotonousOrArrLen=n.findFirstMonotonous=n.findLastIdxMonotonous=n.findLastMonotonous=n.findLastIdx=n.findLast=void 0;function A(f,m,c){const N=D(f,m);if(N!==-1)return f[N]}n.findLast=A;function D(f,m,c=f.length-1){for(let N=c;N>=0;N--){const C=f[N];if(m(C))return N}return-1}n.findLastIdx=D;function i(f,m){const c=h(f,m);return c===-1?void 0:f[c]}n.findLastMonotonous=i;function h(f,m,c=0,N=f.length){let C=c,y=N;for(;C<y;){const p=Math.floor((C+y)/2);m(f[p])?C=p+1:y=p}return C-1}n.findLastIdxMonotonous=h;function g(f,m){const c=_(f,m);return c===f.length?void 0:f[c]}n.findFirstMonotonous=g;function _(f,m,c=0,N=f.length){let C=c,y=N;for(;C<y;){const p=Math.floor((C+y)/2);m(f[p])?y=p:C=p+1}return C}n.findFirstIdxMonotonousOrArrLen=_;class l{constructor(m){this._array=m,this._findLastMonotonousLastIdx=0}findLastMonotonous(m){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const N of this._array)if(this._prevFindLastPredicate(N)&&!m(N))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=m}const c=h(this._array,m,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=c+1,c===-1?void 0:this._array[c]}}n.MonotonousArray=l,l.assertInvariants=!1;function o(f,m){if(f.length===0)return;let c=f[0];for(let N=1;N<f.length;N++){const C=f[N];m(C,c)>0&&(c=C)}return c}n.findFirstMaxBy=o;function v(f,m){if(f.length===0)return;let c=f[0];for(let N=1;N<f.length;N++){const C=f[N];m(C,c)>=0&&(c=C)}return c}n.findLastMaxBy=v;function e(f,m){return o(f,(c,N)=>-m(c,N))}n.findFirstMinBy=e;function b(f,m){if(f.length===0)return-1;let c=0;for(let N=1;N<f.length;N++){const C=f[N];m(C,f[c])>0&&(c=N)}return c}n.findMaxIdxBy=b;function u(f,m){for(const c of f){const N=m(c);if(N!==void 0)return N}}n.mapFindFirst=u}),Y(X[32],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class A{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const g=JSON.stringify(h);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=A;class D{get cachedValues(){return this._map}constructor(h){this.fn=h,this._map=new Map}get(h){if(this._map.has(h))return this._map.get(h);const g=this.fn(h);return this._map.set(h,g),g}}n.CachedFunction=D}),Y(X[33],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.diffSets=void 0;function A(i,h){const g=[],_=[];for(const l of i)h.has(l)||g.push(l);for(const l of h)i.has(l)||_.push(l);return{removed:g,added:_}}n.diffSets=A;class D{constructor(){this.map=new Map}add(h,g){let _=this.map.get(h);_||(_=new Set,this.map.set(h,_)),_.add(g)}delete(h,g){const _=this.map.get(h);_&&(_.delete(g),_.size===0&&this.map.delete(h))}forEach(h,g){const _=this.map.get(h);_&&_.forEach(g)}get(h){const g=this.map.get(h);return g||new Set}}n.SetMap=D}),Y(X[34],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function A(_,l){const o=Math.pow(10,l);return Math.round(_*o)/o}class D{constructor(l,o,v,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,o))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.r===o.r&&l.g===o.g&&l.b===o.b&&l.a===o.a}}n.RGBA=D;class i{constructor(l,o,v,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=A(Math.max(Math.min(1,o),0),3),this.l=A(Math.max(Math.min(1,v),0),3),this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.h===o.h&&l.s===o.s&&l.l===o.l&&l.a===o.a}static fromRGBA(l){const o=l.r/255,v=l.g/255,e=l.b/255,b=l.a,u=Math.max(o,v,e),f=Math.min(o,v,e);let m=0,c=0;const N=(f+u)/2,C=u-f;if(C>0){switch(c=Math.min(N<=.5?C/(2*N):C/(2-2*N),1),u){case o:m=(v-e)/C+(v<e?6:0);break;case v:m=(e-o)/C+2;break;case e:m=(o-v)/C+4;break}m*=60,m=Math.round(m)}return new i(m,c,N,b)}static _hue2rgb(l,o,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?l+(o-l)*6*v:v<1/2?o:v<2/3?l+(o-l)*(2/3-v)*6:l}static toRGBA(l){const o=l.h/360,{s:v,l:e,a:b}=l;let u,f,m;if(v===0)u=f=m=e;else{const c=e<.5?e*(1+v):e+v-e*v,N=2*e-c;u=i._hue2rgb(N,c,o+1/3),f=i._hue2rgb(N,c,o),m=i._hue2rgb(N,c,o-1/3)}return new D(Math.round(u*255),Math.round(f*255),Math.round(m*255),b)}}n.HSLA=i;class h{constructor(l,o,v,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=A(Math.max(Math.min(1,o),0),3),this.v=A(Math.max(Math.min(1,v),0),3),this.a=A(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.h===o.h&&l.s===o.s&&l.v===o.v&&l.a===o.a}static fromRGBA(l){const o=l.r/255,v=l.g/255,e=l.b/255,b=Math.max(o,v,e),u=Math.min(o,v,e),f=b-u,m=b===0?0:f/b;let c;return f===0?c=0:b===o?c=((v-e)/f%6+6)%6:b===v?c=(e-o)/f+2:c=(o-v)/f+4,new h(Math.round(c*60),m,b,l.a)}static toRGBA(l){const{h:o,s:v,v:e,a:b}=l,u=e*v,f=u*(1-Math.abs(o/60%2-1)),m=e-u;let[c,N,C]=[0,0,0];return o<60?(c=u,N=f):o<120?(c=f,N=u):o<180?(N=u,C=f):o<240?(N=f,C=u):o<300?(c=f,C=u):o<=360&&(c=u,C=f),c=Math.round((c+m)*255),N=Math.round((N+m)*255),C=Math.round((C+m)*255),new D(c,N,C,b)}}n.HSVA=h;class g{static fromHex(l){return g.Format.CSS.parseHex(l)||g.red}static equals(l,o){return!l&&!o?!0:!l||!o?!1:l.equals(o)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:h.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof D)this.rgba=l;else if(l instanceof i)this._hsla=l,this.rgba=i.toRGBA(l);else if(l instanceof h)this._hsva=l,this.rgba=h.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&D.equals(this.rgba,l.rgba)&&i.equals(this.hsla,l.hsla)&&h.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=g._relativeLuminanceForComponent(this.rgba.r),o=g._relativeLuminanceForComponent(this.rgba.g),v=g._relativeLuminanceForComponent(this.rgba.b),e=.2126*l+.7152*o+.0722*v;return A(e,4)}static _relativeLuminanceForComponent(l){const o=l/255;return o<=.03928?o/12.92:Math.pow((o+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const o=this.getRelativeLuminance(),v=l.getRelativeLuminance();return o>v}isDarkerThan(l){const o=this.getRelativeLuminance(),v=l.getRelativeLuminance();return o<v}lighten(l){return new g(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new g(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:o,g:v,b:e,a:b}=this.rgba;return new g(new D(o,v,e,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new g(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:o,g:v,b:e,a:b}=this.rgba;return new g(new D(l.rgba.r-b*(l.rgba.r-o),l.rgba.g-b*(l.rgba.g-v),l.rgba.b-b*(l.rgba.b-e),1))}toString(){return this._toString||(this._toString=g.Format.CSS.format(this)),this._toString}static getLighterColor(l,o,v){if(l.isLighterThan(o))return l;v=v||.5;const e=l.getRelativeLuminance(),b=o.getRelativeLuminance();return v=v*(b-e)/b,l.lighten(v)}static getDarkerColor(l,o,v){if(l.isDarkerThan(o))return l;v=v||.5;const e=l.getRelativeLuminance(),b=o.getRelativeLuminance();return v=v*(e-b)/e,l.darken(v)}}n.Color=g,g.white=new g(new D(255,255,255,1)),g.black=new g(new D(0,0,0,1)),g.red=new g(new D(255,0,0,1)),g.blue=new g(new D(0,0,255,1)),g.green=new g(new D(0,255,0,1)),g.cyan=new g(new D(0,255,255,1)),g.lightgrey=new g(new D(211,211,211,1)),g.transparent=new g(new D(0,0,0,0)),function(_){let l;(function(o){let v;(function(e){function b(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:_.Format.CSS.formatRGBA(r)}e.formatRGB=b;function u(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=u;function f(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(r)}e.formatHSL=f;function m(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=m;function c(r){const s=r.toString(16);return s.length!==2?"0"+s:s}function N(r){return`#${c(r.rgba.r)}${c(r.rgba.g)}${c(r.rgba.b)}`}e.formatHex=N;function C(r,s=!1){return s&&r.rgba.a===1?_.Format.CSS.formatHex(r):`#${c(r.rgba.r)}${c(r.rgba.g)}${c(r.rgba.b)}${c(Math.round(r.rgba.a*255))}`}e.formatHexA=C;function y(r){return r.isOpaque()?_.Format.CSS.formatHex(r):_.Format.CSS.formatRGBA(r)}e.format=y;function p(r){const s=r.length;if(s===0||r.charCodeAt(0)!==35)return null;if(s===7){const a=16*S(r.charCodeAt(1))+S(r.charCodeAt(2)),L=16*S(r.charCodeAt(3))+S(r.charCodeAt(4)),d=16*S(r.charCodeAt(5))+S(r.charCodeAt(6));return new _(new D(a,L,d,1))}if(s===9){const a=16*S(r.charCodeAt(1))+S(r.charCodeAt(2)),L=16*S(r.charCodeAt(3))+S(r.charCodeAt(4)),d=16*S(r.charCodeAt(5))+S(r.charCodeAt(6)),w=16*S(r.charCodeAt(7))+S(r.charCodeAt(8));return new _(new D(a,L,d,w/255))}if(s===4){const a=S(r.charCodeAt(1)),L=S(r.charCodeAt(2)),d=S(r.charCodeAt(3));return new _(new D(16*a+a,16*L+L,16*d+d))}if(s===5){const a=S(r.charCodeAt(1)),L=S(r.charCodeAt(2)),d=S(r.charCodeAt(3)),w=S(r.charCodeAt(4));return new _(new D(16*a+a,16*L+L,16*d+d,(16*w+w)/255))}return null}e.parseHex=p;function S(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=o.CSS||(o.CSS={}))})(l=_.Format||(_.Format={}))}(g||(n.Color=g={}))}),Y(X[35],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class A{constructor(i,h,g,_){this.originalStart=i,this.originalLength=h,this.modifiedStart=g,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=A}),Y(X[5],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class A{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?u.isErrorNoTelemetry(c)?new u(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}emit(c){this.listeners.forEach(N=>{N(c)})}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}n.ErrorHandler=A,n.errorHandler=new A;function D(m){_(m)||n.errorHandler.onUnexpectedError(m)}n.onUnexpectedError=D;function i(m){_(m)||n.errorHandler.onUnexpectedExternalError(m)}n.onUnexpectedExternalError=i;function h(m){if(m instanceof Error){const{name:c,message:N}=m,C=m.stacktrace||m.stack;return{$isError:!0,name:c,message:N,stack:C,noTelemetry:u.isErrorNoTelemetry(m)}}return m}n.transformErrorForSerialization=h;const g="Canceled";function _(m){return m instanceof l?!0:m instanceof Error&&m.name===g&&m.message===g}n.isCancellationError=_;class l extends Error{constructor(){super(g),this.name=this.message}}n.CancellationError=l;function o(){const m=new Error(g);return m.name=m.message,m}n.canceled=o;function v(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}n.illegalArgument=v;function e(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}n.illegalState=e;class b extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}n.NotSupportedError=b;class u extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof u)return c;const N=new u;return N.message=c.message,N.stack=c.stack,N}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}n.ErrorNoTelemetry=u;class f extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}n.BugIndicatingError=f}),Y(X[12],J([0,1,5]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function D(_,l){if(!_)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}n.ok=D;function i(_,l="Unreachable"){throw new Error(l)}n.assertNever=i;function h(_){if(!_()){debugger;_(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}n.assertFn=h;function g(_,l){let o=0;for(;o<_.length-1;){const v=_[o],e=_[o+1];if(!l(v,e))return!1;o++}return!0}n.checkAdjacentItems=g}),Y(X[20],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function A(D){const i=this;let h=!1,g;return function(){return h||(h=!0,g=D.apply(i,arguments)),g}}n.once=A}),Y(X[21],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var A;(function(D){function i(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}D.is=i;const h=Object.freeze([]);function g(){return h}D.empty=g;function*_(p){yield p}D.single=_;function l(p){return i(p)?p:_(p)}D.wrap=l;function o(p){return p||h}D.from=o;function v(p){return!p||p[Symbol.iterator]().next().done===!0}D.isEmpty=v;function e(p){return p[Symbol.iterator]().next().value}D.first=e;function b(p,S){for(const r of p)if(S(r))return!0;return!1}D.some=b;function u(p,S){for(const r of p)if(S(r))return r}D.find=u;function*f(p,S){for(const r of p)S(r)&&(yield r)}D.filter=f;function*m(p,S){let r=0;for(const s of p)yield S(s,r++)}D.map=m;function*c(...p){for(const S of p)for(const r of S)yield r}D.concat=c;function N(p,S,r){let s=r;for(const a of p)s=S(s,a);return s}D.reduce=N;function*C(p,S,r=p.length){for(S<0&&(S+=p.length),r<0?r+=p.length:r>p.length&&(r=p.length);S<r;S++)yield p[S]}D.slice=C;function y(p,S=Number.POSITIVE_INFINITY){const r=[];if(S===0)return[r,p];const s=p[Symbol.iterator]();for(let a=0;a<S;a++){const L=s.next();if(L.done)return[r,D.empty()];r.push(L.value)}return[r,{[Symbol.iterator](){return s}}]}D.consume=y})(A||(n.Iterable=A={}))}),Y(X[36],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,u){this._keyCodeToStr[b]=u,this._strToKeyCode[u.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||0}}const D=new A,i=new A,h=new A;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],_=Object.create(null),l=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",b=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],u=[],f=[];for(const m of b){const[c,N,C,y,p,S,r,s,a]=m;if(f[N]||(f[N]=!0,g[N]=C,_[C]=N,l[C.toLowerCase()]=N,c&&(n.IMMUTABLE_CODE_TO_KEY_CODE[N]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[y]=N))),!u[y]){if(u[y]=!0,!p)throw new Error(`String representation missing for key code ${y} around scan code ${C}`);D.define(y,p),i.define(y,s||p),h.define(y,a||s||p)}S&&(n.EVENT_KEY_CODE_MAP[S]=y),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=y)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var o;(function(e){function b(C){return D.keyCodeToStr(C)}e.toString=b;function u(C){return D.strToKeyCode(C)}e.fromString=u;function f(C){return i.keyCodeToStr(C)}e.toUserSettingsUS=f;function m(C){return h.keyCodeToStr(C)}e.toUserSettingsGeneral=m;function c(C){return i.strToKeyCode(C)||h.strToKeyCode(C)}e.fromUserSettings=c;function N(C){if(C>=98&&C<=113)return null;switch(C){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(C)}e.toElectronAccelerator=N})(o||(n.KeyCodeUtils=o={}));function v(e,b){const u=(b&65535)<<16>>>0;return(e|u)>>>0}n.KeyChord=v}),Y(X[37],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class A{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=A}),Y(X[13],J([0,1,20,21]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.markAsDisposed=n.trackDisposable=n.setDisposableTracker=void 0;const i=!1;let h=null;function g(r){h=r}if(n.setDisposableTracker=g,i){const r="__is_disposable_tracked__";g(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==N.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==N.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function _(r){return h?.trackDisposable(r),r}n.trackDisposable=_;function l(r){h?.markAsDisposed(r)}n.markAsDisposed=l;function o(r,s){h?.setParent(r,s)}function v(r,s){if(h)for(const a of r)h.setParent(a,s)}function e(r){return h?.markAsSingleton(r),r}n.markAsSingleton=e;function b(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=b;function u(r){if(D.Iterable.is(r)){const s=[];for(const a of r)if(a)try{a.dispose()}catch(L){s.push(L)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=u;function f(...r){const s=m(()=>u(r));return v(r,s),s}n.combinedDisposable=f;function m(r){const s=_({dispose:(0,A.once)(()=>{l(s),r()})});return s}n.toDisposable=m;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return o(s,this),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}n.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class N{constructor(){this._store=new c,_(this),o(this._store,this)}dispose(){l(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}n.Disposable=N,N.None=Object.freeze({dispose(){}});class C{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var a;this._isDisposed||s===this._value||((a=this._value)===null||a===void 0||a.dispose(),s&&o(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,l(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}n.MutableDisposable=C;class y{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=y;class p{constructor(s){this.object=s}dispose(){}}n.ImmortalReference=p;class S{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}get(s){return this._store.get(s)}set(s,a,L=!1){var d;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||(d=this._store.get(s))===null||d===void 0||d.dispose(),this._store.set(s,a)}deleteAndDispose(s){var a;(a=this._store.get(s))===null||a===void 0||a.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=S}),Y(X[22],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class A{constructor(h){this.element=h,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class D{constructor(){this._first=A.Undefined,this._last=A.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===A.Undefined}clear(){let h=this._first;for(;h!==A.Undefined;){const g=h.next;h.prev=A.Undefined,h.next=A.Undefined,h=g}this._first=A.Undefined,this._last=A.Undefined,this._size=0}unshift(h){return this._insert(h,!1)}push(h){return this._insert(h,!0)}_insert(h,g){const _=new A(h);if(this._first===A.Undefined)this._first=_,this._last=_;else if(g){const o=this._last;this._last=_,_.prev=o,o.next=_}else{const o=this._first;this._first=_,_.next=o,o.prev=_}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(_))}}shift(){if(this._first!==A.Undefined){const h=this._first.element;return this._remove(this._first),h}}pop(){if(this._last!==A.Undefined){const h=this._last.element;return this._remove(this._last),h}}_remove(h){if(h.prev!==A.Undefined&&h.next!==A.Undefined){const g=h.prev;g.next=h.next,h.next.prev=g}else h.prev===A.Undefined&&h.next===A.Undefined?(this._first=A.Undefined,this._last=A.Undefined):h.next===A.Undefined?(this._last=this._last.prev,this._last.next=A.Undefined):h.prev===A.Undefined&&(this._first=this._first.next,this._first.prev=A.Undefined);this._size-=1}*[Symbol.iterator](){let h=this._first;for(;h!==A.Undefined;)yield h.element,h=h.next}}n.LinkedList=D}),Y(X[23],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(h){return new D(h)}constructor(h){this._now=A&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=D}),Y(X[9],J([0,1,5,20,13,22,23]),function(T,n,A,D,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const _=!1,l=!1;var o;(function(d){d.None=()=>i.Disposable.None;function w(Z){if(l){const{onDidAddListener:H}=Z,$=u.create();let Q=0;Z.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),H?.()}}}function R(Z,H){return W(Z,()=>{},0,void 0,!0,void 0,H)}d.defer=R;function E(Z){return(H,$=null,Q)=>{let K=!1,te;return te=Z(P=>{if(!K)return te?te.dispose():K=!0,H.call($,P)},null,Q),K&&te.dispose(),te}}d.once=E;function M(Z,H,$){return x((Q,K=null,te)=>Z(P=>Q.call(K,H(P)),null,te),$)}d.map=M;function F(Z,H,$){return x((Q,K=null,te)=>Z(P=>{H(P),Q.call(K,P)},null,te),$)}d.forEach=F;function B(Z,H,$){return x((Q,K=null,te)=>Z(P=>H(P)&&Q.call(K,P),null,te),$)}d.filter=B;function I(Z){return Z}d.signal=I;function U(...Z){return(H,$=null,Q)=>{const K=(0,i.combinedDisposable)(...Z.map(te=>te(P=>H.call($,P))));return q(K,Q)}}d.any=U;function k(Z,H,$,Q){let K=$;return M(Z,te=>(K=H(K,te),K),Q)}d.reduce=k;function x(Z,H){let $;const Q={onWillAddFirstListener(){$=Z(K.fire,K)},onDidRemoveLastListener(){$?.dispose()}};H||w(Q);const K=new N(Q);return H?.add(K),K.event}function q(Z,H){return H instanceof Array?H.push(Z):H&&H.add(Z),Z}function W(Z,H,$=100,Q=!1,K=!1,te,P){let O,V,j,ee=0,ie;const ae={leakWarningThreshold:te,onWillAddFirstListener(){O=Z(fe=>{ee++,V=H(V,fe),Q&&!j&&(ce.fire(V),V=void 0),ie=()=>{const re=V;V=void 0,j=void 0,(!Q||ee>1)&&ce.fire(re),ee=0},typeof $=="number"?(clearTimeout(j),j=setTimeout(ie,$)):j===void 0&&(j=0,queueMicrotask(ie))})},onWillRemoveListener(){K&&ee>0&&ie?.()},onDidRemoveLastListener(){ie=void 0,O.dispose()}};P||w(ae);const ce=new N(ae);return P?.add(ce),ce.event}d.debounce=W;function z(Z,H=0,$){return d.debounce(Z,(Q,K)=>Q?(Q.push(K),Q):[K],H,void 0,!0,void 0,$)}d.accumulate=z;function G(Z,H=(Q,K)=>Q===K,$){let Q=!0,K;return B(Z,te=>{const P=Q||!H(te,K);return Q=!1,K=te,P},$)}d.latch=G;function t(Z,H,$){return[d.filter(Z,H,$),d.filter(Z,Q=>!H(Q),$)]}d.split=t;function ne(Z,H=!1,$=[]){let Q=$.slice(),K=Z(O=>{Q?Q.push(O):P.fire(O)});const te=()=>{Q?.forEach(O=>P.fire(O)),Q=null},P=new N({onWillAddFirstListener(){K||(K=Z(O=>P.fire(O)))},onDidAddFirstListener(){Q&&(H?setTimeout(te):te())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return P.event}d.buffer=ne;function se(Z,H){return(Q,K,te)=>{const P=H(new me);return Z(function(O){const V=P.evaluate(O);V!==ue&&Q.call(K,V)},void 0,te)}}d.chain=se;const ue=Symbol("HaltChainable");class me{constructor(){this.steps=[]}map(H){return this.steps.push(H),this}forEach(H){return this.steps.push($=>(H($),$)),this}filter(H){return this.steps.push($=>H($)?$:ue),this}reduce(H,$){let Q=$;return this.steps.push(K=>(Q=H(Q,K),Q)),this}latch(H=($,Q)=>$===Q){let $=!0,Q;return this.steps.push(K=>{const te=$||!H(K,Q);return $=!1,Q=K,te?K:ue}),this}evaluate(H){for(const $ of this.steps)if(H=$(H),H===ue)break;return H}}function Le(Z,H,$=Q=>Q){const Q=(...O)=>P.fire($(...O)),K=()=>Z.on(H,Q),te=()=>Z.removeListener(H,Q),P=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromNodeEventEmitter=Le;function pe(Z,H,$=Q=>Q){const Q=(...O)=>P.fire($(...O)),K=()=>Z.addEventListener(H,Q),te=()=>Z.removeEventListener(H,Q),P=new N({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromDOMEventEmitter=pe;function Ce(Z){return new Promise(H=>E(Z)(H))}d.toPromise=Ce;function be(Z){const H=new N;return Z.then($=>{H.fire($)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}d.fromPromise=be;function we(Z,H){return H(void 0),Z($=>H($))}d.runAndSubscribe=we;function Se(Z,H){let $=null;function Q(te){$?.dispose(),$=new i.DisposableStore,H(te,$)}Q(void 0);const K=Z(te=>Q(te));return(0,i.toDisposable)(()=>{K.dispose(),$?.dispose()})}d.runAndSubscribeWithStore=Se;class ye{constructor(H,$){this._observable=H,this._counter=0,this._hasChanged=!1;const Q={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};$||w(Q),this.emitter=new N(Q),$&&$.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,$){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function _e(Z,H){return new ye(Z,H).emitter.event}d.fromObservable=_e;function de(Z){return H=>{let $=0,Q=!1;const K={beginUpdate(){$++},endUpdate(){$--,$===0&&(Z.reportChanges(),Q&&(Q=!1,H()))},handlePossibleChange(){},handleChange(){Q=!0}};return Z.addObserver(K),Z.reportChanges(),{dispose(){Z.removeObserver(K)}}}}d.fromObservableLight=de})(o||(n.Event=o={}));class v{constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${v._idPool++}`,v.all.add(this)}start(w){this._stopWatch=new g.StopWatch,this.listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=v,v.all=new Set,v._idPool=0;let e=-1;class b{constructor(w,R=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=R,this._warnCountdown=0}dispose(){var w;(w=this._stacks)===null||w===void 0||w.clear()}check(w,R){const E=this.threshold;if(E<=0||R<E)return;this._stacks||(this._stacks=new Map);const M=this._stacks.get(w.value)||0;if(this._stacks.set(w.value,M+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let F,B=0;for(const[I,U]of this._stacks)(!F||B<U)&&(F=I,B=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${R} listeners already. MOST frequent listener (${B}):`),console.warn(F)}return()=>{const F=this._stacks.get(w.value)||0;this._stacks.set(w.value,F-1)}}}class u{static create(){var w;return new u((w=new Error().stack)!==null&&w!==void 0?w:"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(w){this.value=w}}const m=2,c=(d,w)=>{if(d instanceof f)w(d);else for(let R=0;R<d.length;R++){const E=d[R];E&&w(E)}};class N{constructor(w){var R,E,M,F,B;this._size=0,this._options=w,this._leakageMon=e>0||!((R=this._options)===null||R===void 0)&&R.leakWarningThreshold?new b((M=(E=this._options)===null||E===void 0?void 0:E.leakWarningThreshold)!==null&&M!==void 0?M:e):void 0,this._perfMon=!((F=this._options)===null||F===void 0)&&F._profName?new v(this._options._profName):void 0,this._deliveryQueue=(B=this._options)===null||B===void 0?void 0:B.deliveryQueue}dispose(){var w,R,E,M;if(!this._disposed){if(this._disposed=!0,((w=this._deliveryQueue)===null||w===void 0?void 0:w.current)===this&&this._deliveryQueue.reset(),this._listeners){if(_){const F=this._listeners;queueMicrotask(()=>{c(F,B=>{var I;return(I=B.stack)===null||I===void 0?void 0:I.print()})})}this._listeners=void 0,this._size=0}(E=(R=this._options)===null||R===void 0?void 0:R.onDidRemoveLastListener)===null||E===void 0||E.call(R),(M=this._leakageMon)===null||M===void 0||M.dispose()}}get event(){var w;return(w=this._event)!==null&&w!==void 0||(this._event=(R,E,M)=>{var F,B,I,U,k;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;E&&(R=R.bind(E));const x=new f(R);let q,W;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(x.stack=u.create(),q=this._leakageMon.check(x.stack,this._size+1)),_&&(x.stack=W??u.create()),this._listeners?this._listeners instanceof f?((k=this._deliveryQueue)!==null&&k!==void 0||(this._deliveryQueue=new y),this._listeners=[this._listeners,x]):this._listeners.push(x):((B=(F=this._options)===null||F===void 0?void 0:F.onWillAddFirstListener)===null||B===void 0||B.call(F,this),this._listeners=x,(U=(I=this._options)===null||I===void 0?void 0:I.onDidAddFirstListener)===null||U===void 0||U.call(I,this)),this._size++;const z=(0,i.toDisposable)(()=>{q?.(),this._removeListener(x)});return M instanceof i.DisposableStore?M.add(z):Array.isArray(M)&&M.push(z),z}),this._event}_removeListener(w){var R,E,M,F;if((E=(R=this._options)===null||R===void 0?void 0:R.onWillRemoveListener)===null||E===void 0||E.call(R,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(F=(M=this._options)===null||M===void 0?void 0:M.onDidRemoveLastListener)===null||F===void 0||F.call(M,this),this._size=0;return}const B=this._listeners,I=B.indexOf(w);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,B[I]=void 0;const U=this._deliveryQueue.current===this;if(this._size*m<=B.length){let k=0;for(let x=0;x<B.length;x++)B[x]?B[k++]=B[x]:U&&(this._deliveryQueue.end--,k<this._deliveryQueue.i&&this._deliveryQueue.i--);B.length=k}}_deliver(w,R){var E;if(!w)return;const M=((E=this._options)===null||E===void 0?void 0:E.onListenerError)||A.onUnexpectedError;if(!M){w.value(R);return}try{w.value(R)}catch(F){M(F)}}_deliverQueue(w){const R=w.current._listeners;for(;w.i<w.end;)this._deliver(R[w.i++],w.value);w.reset()}fire(w){var R,E,M,F;if(!((R=this._deliveryQueue)===null||R===void 0)&&R.current&&(this._deliverQueue(this._deliveryQueue),(E=this._perfMon)===null||E===void 0||E.stop()),(M=this._perfMon)===null||M===void 0||M.start(this._size),this._listeners)if(this._listeners instanceof f)this._deliver(this._listeners,w);else{const B=this._deliveryQueue;B.enqueue(this,w,this._listeners.length),this._deliverQueue(B)}(F=this._perfMon)===null||F===void 0||F.stop()}hasListeners(){return this._size>0}}n.Emitter=N;const C=()=>new y;n.createEventDeliveryQueue=C;class y{constructor(){this.i=-1,this.end=0}enqueue(w,R,E){this.i=0,this.end=E,this.current=w,this.value=R}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class p extends N{constructor(w){super(w),this._isPaused=0,this._eventQueue=new h.LinkedList,this._mergeFn=w?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._size&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}n.PauseableEmitter=p;class S extends p{constructor(w){var R;super(w),this._delay=(R=w.delay)!==null&&R!==void 0?R:100}fire(w){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(w)}}n.DebounceEmitter=S;class r extends N{constructor(w){super(w),this._queuedEvents=[],this._mergeFn=w?.merge}fire(w){this.hasListeners()&&(this._queuedEvents.push(w),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(R=>super.fire(R)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const R={event:w,listener:null};this.events.push(R),this.hasListeners&&this.hook(R);const E=()=>{this.hasListeners&&this.unhook(R);const M=this.events.indexOf(R);this.events.splice(M,1)};return(0,i.toDisposable)((0,D.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(R=>this.emitter.fire(R))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=s;class a{constructor(){this.buffers=[]}wrapEvent(w){return(R,E,M)=>w(F=>{const B=this.buffers[this.buffers.length-1];B?B.push(()=>R.call(E,F)):R.call(E,F)},void 0,M)}bufferEvents(w){const R=[];this.buffers.push(R);const E=w();return this.buffers.pop(),R.forEach(M=>M()),E}}n.EventBufferer=a;class L{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=i.Disposable.None,this.emitter=new N({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=L}),Y(X[38],J([0,1,9]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const D=Object.freeze(function(_,l){const o=setTimeout(_.bind(l),0);return{dispose(){clearTimeout(o)}}});var i;(function(_){function l(o){return o===_.None||o===_.Cancelled||o instanceof h?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}_.isCancellationToken=l,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(n.CancellationToken=i={}));class h{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new A.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class g{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new h),this._token}cancel(){this._token?this._token instanceof h&&this._token.cancel():this._token=i.Cancelled}dispose(l=!1){var o;l&&this.cancel(),(o=this._parentListener)===null||o===void 0||o.dispose(),this._token?this._token instanceof h&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=g}),Y(X[6],J([0,1,32,37]),function(T,n,A,D){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function h(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=h;const g=/{(\d+)}/g;function _(P,...O){return O.length===0?P:P.replace(g,function(V,j){const ee=parseInt(j,10);return isNaN(ee)||ee<0||ee>=O.length?V:O[ee]})}n.format=_;function l(P){return P.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}n.escape=l;function o(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=o;function v(P,O=" "){const V=e(P,O);return b(V,O)}n.trim=v;function e(P,O){if(!P||!O)return P;const V=O.length;if(V===0||P.length===0)return P;let j=0;for(;P.indexOf(O,j)===j;)j=j+V;return P.substring(j)}n.ltrim=e;function b(P,O){if(!P||!O)return P;const V=O.length,j=P.length;if(V===0||j===0)return P;let ee=j,ie=-1;for(;ie=P.lastIndexOf(O,ee-1),!(ie===-1||ie+V!==ee);){if(ie===0)return"";ee=ie}return P.substring(0,ee)}n.rtrim=b;function u(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=u;function f(P){return P.replace(/\*/g,"")}n.stripWildcards=f;function m(P,O,V={}){if(!P)throw new Error("Cannot create regex from empty string");O||(P=o(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let j="";return V.global&&(j+="g"),V.matchCase||(j+="i"),V.multiline&&(j+="m"),V.unicode&&(j+="u"),new RegExp(P,j)}n.createRegExp=m;function c(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=c;function N(P){return P.split(/\r\n|\r|\n/)}n.splitLines=N;function C(P){for(let O=0,V=P.length;O<V;O++){const j=P.charCodeAt(O);if(j!==32&&j!==9)return O}return-1}n.firstNonWhitespaceIndex=C;function y(P,O=0,V=P.length){for(let j=O;j<V;j++){const ee=P.charCodeAt(j);if(ee!==32&&ee!==9)return P.substring(O,j)}return P.substring(O,V)}n.getLeadingWhitespace=y;function p(P,O=P.length-1){for(let V=O;V>=0;V--){const j=P.charCodeAt(V);if(j!==32&&j!==9)return V}return-1}n.lastNonWhitespaceIndex=p;function S(P,O){return P<O?-1:P>O?1:0}n.compare=S;function r(P,O,V=0,j=P.length,ee=0,ie=O.length){for(;V<j&&ee<ie;V++,ee++){const fe=P.charCodeAt(V),re=O.charCodeAt(ee);if(fe<re)return-1;if(fe>re)return 1}const ae=j-V,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstring=r;function s(P,O){return a(P,O,0,P.length,0,O.length)}n.compareIgnoreCase=s;function a(P,O,V=0,j=P.length,ee=0,ie=O.length){for(;V<j&&ee<ie;V++,ee++){let fe=P.charCodeAt(V),re=O.charCodeAt(ee);if(fe===re)continue;if(fe>=128||re>=128)return r(P.toLowerCase(),O.toLowerCase(),V,j,ee,ie);d(fe)&&(fe-=32),d(re)&&(re-=32);const he=fe-re;if(he!==0)return he}const ae=j-V,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstringIgnoreCase=a;function L(P){return P>=48&&P<=57}n.isAsciiDigit=L;function d(P){return P>=97&&P<=122}n.isLowerAsciiLetter=d;function w(P){return P>=65&&P<=90}n.isUpperAsciiLetter=w;function R(P,O){return P.length===O.length&&a(P,O)===0}n.equalsIgnoreCase=R;function E(P,O){const V=O.length;return O.length>P.length?!1:a(P,O,0,V)===0}n.startsWithIgnoreCase=E;function M(P,O){const V=Math.min(P.length,O.length);let j;for(j=0;j<V;j++)if(P.charCodeAt(j)!==O.charCodeAt(j))return j;return V}n.commonPrefixLength=M;function F(P,O){const V=Math.min(P.length,O.length);let j;const ee=P.length-1,ie=O.length-1;for(j=0;j<V;j++)if(P.charCodeAt(ee-j)!==O.charCodeAt(ie-j))return j;return V}n.commonSuffixLength=F;function B(P){return 55296<=P&&P<=56319}n.isHighSurrogate=B;function I(P){return 56320<=P&&P<=57343}n.isLowSurrogate=I;function U(P,O){return(P-55296<<10)+(O-56320)+65536}n.computeCodePoint=U;function k(P,O,V){const j=P.charCodeAt(V);if(B(j)&&V+1<O){const ee=P.charCodeAt(V+1);if(I(ee))return U(j,ee)}return j}n.getNextCodePoint=k;function x(P,O){const V=P.charCodeAt(O-1);if(I(V)&&O>1){const j=P.charCodeAt(O-2);if(B(j))return U(j,V)}return V}class q{get offset(){return this._offset}constructor(O,V=0){this._str=O,this._len=O.length,this._offset=V}setOffset(O){this._offset=O}prevCodePoint(){const O=x(this._str,this._offset);return this._offset-=O>=65536?2:1,O}nextCodePoint(){const O=k(this._str,this._len,this._offset);return this._offset+=O>=65536?2:1,O}eol(){return this._offset>=this._len}}n.CodePointIterator=q;class W{get offset(){return this._iterator.offset}constructor(O,V=0){this._iterator=new q(O,V)}nextGraphemeLength(){const O=de.getInstance(),V=this._iterator,j=V.offset;let ee=O.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ie=V.offset,ae=O.getGraphemeBreakType(V.nextCodePoint());if(_e(ee,ae)){V.setOffset(ie);break}ee=ae}return V.offset-j}prevGraphemeLength(){const O=de.getInstance(),V=this._iterator,j=V.offset;let ee=O.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ie=V.offset,ae=O.getGraphemeBreakType(V.prevCodePoint());if(_e(ae,ee)){V.setOffset(ie);break}ee=ae}return j-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=W;function z(P,O){return new W(P,O).nextGraphemeLength()}n.nextCharLength=z;function G(P,O){return new W(P,O).prevGraphemeLength()}n.prevCharLength=G;function t(P,O){O>0&&I(P.charCodeAt(O))&&O--;const V=O+z(P,O);return[V-G(P,V),V]}n.getCharContainingOffset=t;let ne;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ue(P){return ne||(ne=se()),ne.test(P)}n.containsRTL=ue;const me=/^[\t\n\r\x20-\x7E]*$/;function Le(P){return me.test(P)}n.isBasicASCII=Le,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=pe;function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=Ce;function be(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=be,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=we;function Se(P,O=!1){return P?(O&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Se;function ye(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=ye;function _e(P,O){return P===0?O!==5&&O!==7:P===2&&O===3?!1:P===4||P===2||P===3||O===4||O===2||O===3?!0:!(P===8&&(O===8||O===9||O===11||O===12)||(P===11||P===9)&&(O===9||O===10)||(P===12||P===10)&&O===10||O===5||O===13||O===7||P===1||P===13&&O===14||P===6&&O===6)}class de{static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}constructor(){this._data=Z()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const V=this._data,j=V.length/3;let ee=1;for(;ee<=j;)if(O<V[3*ee])ee=2*ee;else if(O>V[3*ee+1])ee=2*ee+1;else return V[3*ee+2];return 0}}de._INSTANCE=null;function Z(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function H(P,O){if(P===0)return 0;const V=$(P,O);if(V!==void 0)return V;const j=new q(O,P);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=H;function $(P,O){const V=new q(O,P);let j=V.prevCodePoint();for(;Q(j)||j===65039||j===8419;){if(V.offset===0)return;j=V.prevCodePoint()}if(!be(j))return;let ee=V.offset;return ee>0&&V.prevCodePoint()===8205&&(ee=V.offset),ee}function Q(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class K{static getInstance(O){return i.cache.get(Array.from(O))}static getLocales(){return i._locales.value}constructor(O){this.confusableDictionary=O}isAmbiguous(O){return this.confusableDictionary.has(O)}getPrimaryConfusable(O){return this.confusableDictionary.get(O)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=K,i=K,K.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),K.cache=new A.LRUCachedFunction(P=>{function O(re){const he=new Map;for(let ge=0;ge<re.length;ge+=2)he.set(re[ge],re[ge+1]);return he}function V(re,he){const ge=new Map(re);for(const[ve,Ne]of he)ge.set(ve,Ne);return ge}function j(re,he){if(!re)return he;const ge=new Map;for(const[ve,Ne]of re)he.has(ve)&&ge.set(ve,Ne);return ge}const ee=i.ambiguousCharacterData.value;let ie=P.filter(re=>!re.startsWith("_")&&re in ee);ie.length===0&&(ie=["_default"]);let ae;for(const re of ie){const he=O(ee[re]);ae=j(ae,he)}const ce=O(ee._common),fe=V(ce,ae);return new i(fe)}),K._locales=new D.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class te{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(te.getRawData())),this._data}static isInvisibleCharacter(O){return te.getData().has(O)}static get codePoints(){return te.getData()}}n.InvisibleCharacters=te,te._data=void 0}),Y(X[39],J([0,1,6]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function D(m){return i(m,0)}n.hash=D;function i(m,c){switch(typeof m){case"object":return m===null?h(349,c):Array.isArray(m)?l(m,c):o(m,c);case"string":return _(m,c);case"boolean":return g(m,c);case"number":return h(m,c);case"undefined":return h(937,c);default:return h(617,c)}}n.doHash=i;function h(m,c){return(c<<5)-c+m|0}n.numberHash=h;function g(m,c){return h(m?433:863,c)}function _(m,c){c=h(149417,c);for(let N=0,C=m.length;N<C;N++)c=h(m.charCodeAt(N),c);return c}n.stringHash=_;function l(m,c){return c=h(104579,c),m.reduce((N,C)=>i(C,N),c)}function o(m,c){return c=h(181387,c),Object.keys(m).sort().reduce((N,C)=>(N=_(C,N),i(m[C],N)),c)}function v(m,c,N=32){const C=N-c,y=~((1<<C)-1);return(m<<c|(y&m)>>>C)>>>0}function e(m,c=0,N=m.byteLength,C=0){for(let y=0;y<N;y++)m[c+y]=C}function b(m,c,N="0"){for(;m.length<c;)m=N+m;return m}function u(m,c=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(N=>N.toString(16).padStart(2,"0")).join(""):b((m>>>0).toString(16),c/4)}n.toHexString=u;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const N=c.length;if(N===0)return;const C=this._buff;let y=this._buffLen,p=this._leftoverHighSurrogate,S,r;for(p!==0?(S=p,r=-1,p=0):(S=c.charCodeAt(0),r=0);;){let s=S;if(A.isHighSurrogate(S))if(r+1<N){const a=c.charCodeAt(r+1);A.isLowSurrogate(a)?(r++,s=A.computeCodePoint(S,a)):s=65533}else{p=S;break}else A.isLowSurrogate(S)&&(s=65533);if(y=this._push(C,y,s),r++,r<N)S=c.charCodeAt(r);else break}this._buffLen=y,this._leftoverHighSurrogate=p}_push(c,N,C){return C<128?c[N++]=C:C<2048?(c[N++]=192|(C&1984)>>>6,c[N++]=128|(C&63)>>>0):C<65536?(c[N++]=224|(C&61440)>>>12,c[N++]=128|(C&4032)>>>6,c[N++]=128|(C&63)>>>0):(c[N++]=240|(C&1835008)>>>18,c[N++]=128|(C&258048)>>>12,c[N++]=128|(C&4032)>>>6,c[N++]=128|(C&63)>>>0),N>=64&&(this._step(),N-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),N}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=f._bigBlock32,N=this._buffDV;for(let d=0;d<64;d+=4)c.setUint32(d,N.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,v(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let C=this._h0,y=this._h1,p=this._h2,S=this._h3,r=this._h4,s,a,L;for(let d=0;d<80;d++)d<20?(s=y&p|~y&S,a=1518500249):d<40?(s=y^p^S,a=1859775393):d<60?(s=y&p|y&S|p&S,a=2400959708):(s=y^p^S,a=3395469782),L=v(C,5)+s+r+a+c.getUint32(d*4,!1)&4294967295,r=S,S=p,p=v(y,30),y=C,C=L;this._h0=this._h0+C&4294967295,this._h1=this._h1+y&4294967295,this._h2=this._h2+p&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[24],J([0,1,35,39]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,b=new Int32Array(e.length);for(let u=0,f=e.length;u<f;u++)b[u]=e.charCodeAt(u);return b}}n.StringDiffSequence=i;function h(v,e,b){return new o(new i(v),new i(e)).ComputeDiff(b).changes}n.stringDiff=h;class g{static Assert(e,b){if(!e)throw new Error(b)}}class _{static Copy(e,b,u,f,m){for(let c=0;c<m;c++)u[f+c]=e[b+c]}static Copy2(e,b,u,f,m){for(let c=0;c<m;c++)u[f+c]=e[b+c]}}class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new A.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,b){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(e,b){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class o{constructor(e,b,u=null){this.ContinueProcessingPredicate=u,this._originalSequence=e,this._modifiedSequence=b;const[f,m,c]=o._getElements(e),[N,C,y]=o._getElements(b);this._hasStrings=c&&y,this._originalStringElements=f,this._originalElementsOrHash=m,this._modifiedStringElements=N,this._modifiedElementsOrHash=C,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const b=e.getElements();if(o._isStringArray(b)){const u=new Int32Array(b.length);for(let f=0,m=b.length;f<m;f++)u[f]=(0,D.stringHash)(b[f],0);return[b,u,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(e,b){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(e,b){if(!this.ElementsAreEqual(e,b))return!1;const u=o._getStrictElement(this._originalSequence,e),f=o._getStrictElement(this._modifiedSequence,b);return u===f}static _getStrictElement(e,b){return typeof e.getStrictElement=="function"?e.getStrictElement(b):null}OriginalElementsAreEqual(e,b){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(e,b){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[b]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,b,u,f,m){const c=[!1];let N=this.ComputeDiffRecursive(e,b,u,f,c);return m&&(N=this.PrettifyChanges(N)),{quitEarly:c[0],changes:N}}ComputeDiffRecursive(e,b,u,f,m){for(m[0]=!1;e<=b&&u<=f&&this.ElementsAreEqual(e,u);)e++,u++;for(;b>=e&&f>=u&&this.ElementsAreEqual(b,f);)b--,f--;if(e>b||u>f){let S;return u<=f?(g.Assert(e===b+1,"originalStart should only be one more than originalEnd"),S=[new A.DiffChange(e,0,u,f-u+1)]):e<=b?(g.Assert(u===f+1,"modifiedStart should only be one more than modifiedEnd"),S=[new A.DiffChange(e,b-e+1,u,0)]):(g.Assert(e===b+1,"originalStart should only be one more than originalEnd"),g.Assert(u===f+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const c=[0],N=[0],C=this.ComputeRecursionPoint(e,b,u,f,c,N,m),y=c[0],p=N[0];if(C!==null)return C;if(!m[0]){const S=this.ComputeDiffRecursive(e,y,u,p,m);let r=[];return m[0]?r=[new A.DiffChange(y+1,b-(y+1)+1,p+1,f-(p+1)+1)]:r=this.ComputeDiffRecursive(y+1,b,p+1,f,m),this.ConcatenateChanges(S,r)}return[new A.DiffChange(e,b-e+1,u,f-u+1)]}WALKTRACE(e,b,u,f,m,c,N,C,y,p,S,r,s,a,L,d,w,R){let E=null,M=null,F=new l,B=b,I=u,U=s[0]-d[0]-f,k=-1073741824,x=this.m_forwardHistory.length-1;do{const q=U+e;q===B||q<I&&y[q-1]<y[q+1]?(S=y[q+1],a=S-U-f,S<k&&F.MarkNextChange(),k=S,F.AddModifiedElement(S+1,a),U=q+1-e):(S=y[q-1]+1,a=S-U-f,S<k&&F.MarkNextChange(),k=S-1,F.AddOriginalElement(S,a+1),U=q-1-e),x>=0&&(y=this.m_forwardHistory[x],e=y[0],B=1,I=y.length-1)}while(--x>=-1);if(E=F.getReverseChanges(),R[0]){let q=s[0]+1,W=d[0]+1;if(E!==null&&E.length>0){const z=E[E.length-1];q=Math.max(q,z.getOriginalEnd()),W=Math.max(W,z.getModifiedEnd())}M=[new A.DiffChange(q,r-q+1,W,L-W+1)]}else{F=new l,B=c,I=N,U=s[0]-d[0]-C,k=1073741824,x=w?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=U+m;q===B||q<I&&p[q-1]>=p[q+1]?(S=p[q+1]-1,a=S-U-C,S>k&&F.MarkNextChange(),k=S+1,F.AddOriginalElement(S+1,a+1),U=q+1-m):(S=p[q-1],a=S-U-C,S>k&&F.MarkNextChange(),k=S,F.AddModifiedElement(S+1,a+1),U=q-1-m),x>=0&&(p=this.m_reverseHistory[x],m=p[0],B=1,I=p.length-1)}while(--x>=-1);M=F.getChanges()}return this.ConcatenateChanges(E,M)}ComputeRecursionPoint(e,b,u,f,m,c,N){let C=0,y=0,p=0,S=0,r=0,s=0;e--,u--,m[0]=0,c[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=b-e+(f-u),L=a+1,d=new Int32Array(L),w=new Int32Array(L),R=f-u,E=b-e,M=e-u,F=b-f,I=(E-R)%2===0;d[R]=e,w[E]=b,N[0]=!1;for(let U=1;U<=a/2+1;U++){let k=0,x=0;p=this.ClipDiagonalBound(R-U,U,R,L),S=this.ClipDiagonalBound(R+U,U,R,L);for(let W=p;W<=S;W+=2){W===p||W<S&&d[W-1]<d[W+1]?C=d[W+1]:C=d[W-1]+1,y=C-(W-R)-M;const z=C;for(;C<b&&y<f&&this.ElementsAreEqual(C+1,y+1);)C++,y++;if(d[W]=C,C+y>k+x&&(k=C,x=y),!I&&Math.abs(W-E)<=U-1&&C>=w[W])return m[0]=C,c[0]=y,z<=w[W]&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,M,E,r,s,F,d,w,C,b,m,y,f,c,I,N):null}const q=(k-e+(x-u)-U)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(k,q))return N[0]=!0,m[0]=k,c[0]=x,q>0&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,M,E,r,s,F,d,w,C,b,m,y,f,c,I,N):(e++,u++,[new A.DiffChange(e,b-e+1,u,f-u+1)]);r=this.ClipDiagonalBound(E-U,U,E,L),s=this.ClipDiagonalBound(E+U,U,E,L);for(let W=r;W<=s;W+=2){W===r||W<s&&w[W-1]>=w[W+1]?C=w[W+1]-1:C=w[W-1],y=C-(W-E)-F;const z=C;for(;C>e&&y>u&&this.ElementsAreEqual(C,y);)C--,y--;if(w[W]=C,I&&Math.abs(W-R)<=U&&C<=d[W])return m[0]=C,c[0]=y,z>=d[W]&&1447>0&&U<=1447+1?this.WALKTRACE(R,p,S,M,E,r,s,F,d,w,C,b,m,y,f,c,I,N):null}if(U<=1447){let W=new Int32Array(S-p+2);W[0]=R-p+1,_.Copy2(d,p,W,1,S-p+1),this.m_forwardHistory.push(W),W=new Int32Array(s-r+2),W[0]=E-r+1,_.Copy2(w,r,W,1,s-r+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(R,p,S,M,E,r,s,F,d,w,C,b,m,y,f,c,I,N)}PrettifyChanges(e){for(let b=0;b<e.length;b++){const u=e[b],f=b<e.length-1?e[b+1].originalStart:this._originalElementsOrHash.length,m=b<e.length-1?e[b+1].modifiedStart:this._modifiedElementsOrHash.length,c=u.originalLength>0,N=u.modifiedLength>0;for(;u.originalStart+u.originalLength<f&&u.modifiedStart+u.modifiedLength<m&&(!c||this.OriginalElementsAreEqual(u.originalStart,u.originalStart+u.originalLength))&&(!N||this.ModifiedElementsAreEqual(u.modifiedStart,u.modifiedStart+u.modifiedLength));){const y=this.ElementsAreStrictEqual(u.originalStart,u.modifiedStart);if(this.ElementsAreStrictEqual(u.originalStart+u.originalLength,u.modifiedStart+u.modifiedLength)&&!y)break;u.originalStart++,u.modifiedStart++}const C=[null];if(b<e.length-1&&this.ChangesOverlap(e[b],e[b+1],C)){e[b]=C[0],e.splice(b+1,1),b--;continue}}for(let b=e.length-1;b>=0;b--){const u=e[b];let f=0,m=0;if(b>0){const S=e[b-1];f=S.originalStart+S.originalLength,m=S.modifiedStart+S.modifiedLength}const c=u.originalLength>0,N=u.modifiedLength>0;let C=0,y=this._boundaryScore(u.originalStart,u.originalLength,u.modifiedStart,u.modifiedLength);for(let S=1;;S++){const r=u.originalStart-S,s=u.modifiedStart-S;if(r<f||s<m||c&&!this.OriginalElementsAreEqual(r,r+u.originalLength)||N&&!this.ModifiedElementsAreEqual(s,s+u.modifiedLength))break;const L=(r===f&&s===m?5:0)+this._boundaryScore(r,u.originalLength,s,u.modifiedLength);L>y&&(y=L,C=S)}u.originalStart-=C,u.modifiedStart-=C;const p=[null];if(b>0&&this.ChangesOverlap(e[b-1],e[b],p)){e[b-1]=p[0],e.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,u=e.length;b<u;b++){const f=e[b-1],m=e[b],c=m.originalStart-f.originalStart-f.originalLength,N=f.originalStart,C=m.originalStart+m.originalLength,y=C-N,p=f.modifiedStart,S=m.modifiedStart+m.modifiedLength,r=S-p;if(c<5&&y<20&&r<20){const s=this._findBetterContiguousSequence(N,y,p,r,c);if(s){const[a,L]=s;(a!==f.originalStart+f.originalLength||L!==f.modifiedStart+f.modifiedLength)&&(f.originalLength=a-f.originalStart,f.modifiedLength=L-f.modifiedStart,m.originalStart=a+c,m.modifiedStart=L+c,m.originalLength=C-m.originalStart,m.modifiedLength=S-m.modifiedStart)}}}return e}_findBetterContiguousSequence(e,b,u,f,m){if(b<m||f<m)return null;const c=e+b-m+1,N=u+f-m+1;let C=0,y=0,p=0;for(let S=e;S<c;S++)for(let r=u;r<N;r++){const s=this._contiguousSequenceScore(S,r,m);s>0&&s>C&&(C=s,y=S,p=r)}return C>0?[y,p]:null}_contiguousSequenceScore(e,b,u){let f=0;for(let m=0;m<u;m++){if(!this.ElementsAreEqual(e+m,b+m))return 0;f+=this._originalStringElements[e+m].length}return f}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,b){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(b>0){const u=e+b;if(this._OriginalIsBoundary(u-1)||this._OriginalIsBoundary(u))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,b){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(b>0){const u=e+b;if(this._ModifiedIsBoundary(u-1)||this._ModifiedIsBoundary(u))return!0}return!1}_boundaryScore(e,b,u,f){const m=this._OriginalRegionIsBoundary(e,b)?1:0,c=this._ModifiedRegionIsBoundary(u,f)?1:0;return m+c}ConcatenateChanges(e,b){const u=[];if(e.length===0||b.length===0)return b.length>0?b:e;if(this.ChangesOverlap(e[e.length-1],b[0],u)){const f=new Array(e.length+b.length-1);return _.Copy(e,0,f,0,e.length-1),f[e.length-1]=u[0],_.Copy(b,1,f,e.length,b.length-1),f}else{const f=new Array(e.length+b.length);return _.Copy(e,0,f,0,e.length),_.Copy(b,0,f,e.length,b.length),f}}ChangesOverlap(e,b,u){if(g.Assert(e.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),g.Assert(e.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=b.originalStart||e.modifiedStart+e.modifiedLength>=b.modifiedStart){const f=e.originalStart;let m=e.originalLength;const c=e.modifiedStart;let N=e.modifiedLength;return e.originalStart+e.originalLength>=b.originalStart&&(m=b.originalStart+b.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=b.modifiedStart&&(N=b.modifiedStart+b.modifiedLength-e.modifiedStart),u[0]=new A.DiffChange(f,m,c,N),!0}else return u[0]=null,!1}ClipDiagonalBound(e,b,u,f){if(e>=0&&e<f)return e;const m=u,c=f-u-1,N=b%2===0;if(e<0){const C=m%2===0;return N===C?0:1}else{const C=c%2===0;return N===C?f-1:f-2}}}n.LcsDiff=o}),Y(X[25],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function A(c){return typeof c=="string"}n.isString=A;function D(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}n.isObject=D;function i(c){const N=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof N}n.isTypedArray=i;function h(c){return typeof c=="number"&&!isNaN(c)}n.isNumber=h;function g(c){return!!c&&typeof c[Symbol.iterator]=="function"}n.isIterable=g;function _(c){return c===!0||c===!1}n.isBoolean=_;function l(c){return typeof c>"u"}n.isUndefined=l;function o(c){return!v(c)}n.isDefined=o;function v(c){return l(c)||c===null}n.isUndefinedOrNull=v;function e(c,N){if(!c)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}n.assertType=e;function b(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}n.assertIsDefined=b;function u(c){return typeof c=="function"}n.isFunction=u;function f(c,N){const C=Math.min(c.length,N.length);for(let y=0;y<C;y++)m(c[y],N[y])}n.validateConstraints=f;function m(c,N){if(A(N)){if(typeof c!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(u(N)){try{if(c instanceof N)return}catch{}if(!v(c)&&c.constructor===N||N.length===1&&N.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=m}),Y(X[40],J([0,1,25]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const D=Object.create(null);function i(g,_){if((0,A.isString)(_)){const l=D[_];if(l===void 0)throw new Error(`${g} references an unknown codicon: ${_}`);_=l}return D[g]=_,{id:g}}function h(){return D}n.getCodiconFontCharacters=h,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[14],J([0,1,25]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const f=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([m,c])=>{f[m]=c&&typeof c=="object"?D(c):c}),f}n.deepClone=D;function i(u){if(!u||typeof u!="object")return u;const f=[u];for(;f.length>0;){const m=f.shift();Object.freeze(m);for(const c in m)if(h.call(m,c)){const N=m[c];typeof N=="object"&&!Object.isFrozen(N)&&!(0,A.isTypedArray)(N)&&f.push(N)}}return u}n.deepFreeze=i;const h=Object.prototype.hasOwnProperty;function g(u,f){return _(u,f,new Set)}n.cloneAndChange=g;function _(u,f,m){if((0,A.isUndefinedOrNull)(u))return u;const c=f(u);if(typeof c<"u")return c;if(Array.isArray(u)){const N=[];for(const C of u)N.push(_(C,f,m));return N}if((0,A.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const N={};for(const C in u)h.call(u,C)&&(N[C]=_(u[C],f,m));return m.delete(u),N}return u}function l(u,f,m=!0){return(0,A.isObject)(u)?((0,A.isObject)(f)&&Object.keys(f).forEach(c=>{c in u?m&&((0,A.isObject)(u[c])&&(0,A.isObject)(f[c])?l(u[c],f[c],m):u[c]=f[c]):u[c]=f[c]}),u):f}n.mixin=l;function o(u,f){if(u===f)return!0;if(u==null||f===null||f===void 0||typeof u!=typeof f||typeof u!="object"||Array.isArray(u)!==Array.isArray(f))return!1;let m,c;if(Array.isArray(u)){if(u.length!==f.length)return!1;for(m=0;m<u.length;m++)if(!o(u[m],f[m]))return!1}else{const N=[];for(c in u)N.push(c);N.sort();const C=[];for(c in f)C.push(c);if(C.sort(),!o(N,C))return!1;for(m=0;m<N.length;m++)if(!o(u[N[m]],f[N[m]]))return!1}return!0}n.equals=o;function v(u){let f=[];for(;Object.prototype!==u;)f=f.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return f}n.getAllPropertyNames=v;function e(u){const f=[];for(const m of v(u))typeof u[m]=="function"&&f.push(m);return f}n.getAllMethodNames=e;function b(u,f){const m=N=>function(){const C=Array.prototype.slice.call(arguments,0);return f(N,C)},c={};for(const N of u)c[N]=m(N);return c}n.createProxyObject=b}),Y(X[26],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function A(i){return i<0?0:i>255?255:i|0}n.toUint8=A;function D(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=D}),Y(X[27],J([0,1,26]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class D{constructor(g){const _=(0,A.toUint8)(g);this._defaultValue=_,this._asciiMap=D._createAsciiMap(_),this._map=new Map}static _createAsciiMap(g){const _=new Uint8Array(256);return _.fill(g),_}set(g,_){const l=(0,A.toUint8)(_);g>=0&&g<256?this._asciiMap[g]=l:this._map.set(g,l)}get(g){return g>=0&&g<256?this._asciiMap[g]:this._map.get(g)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=D;class i{constructor(){this._actual=new D(0)}add(g){this._actual.set(g,1)}has(g){return this._actual.get(g)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),Y(X[3],J([0,1,5]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class D{static addRange(g,_){let l=0;for(;l<_.length&&_[l].endExclusive<g.start;)l++;let o=l;for(;o<_.length&&_[o].start<=g.endExclusive;)o++;if(l===o)_.splice(l,0,g);else{const v=Math.min(g.start,_[l].start),e=Math.max(g.endExclusive,_[o-1].endExclusive);_.splice(l,o-l,new D(v,e))}}static tryCreate(g,_){if(!(g>_))return new D(g,_)}static ofLength(g){return new D(0,g)}constructor(g,_){if(this.start=g,this.endExclusive=_,g>_)throw new A.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(g){return new D(this.start+g,this.endExclusive+g)}deltaStart(g){return new D(this.start+g,this.endExclusive)}deltaEnd(g){return new D(this.start,this.endExclusive+g)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(g){return this.start===g.start&&this.endExclusive===g.endExclusive}containsRange(g){return this.start<=g.start&&g.endExclusive<=this.endExclusive}contains(g){return this.start<=g&&g<this.endExclusive}join(g){return new D(Math.min(this.start,g.start),Math.max(this.endExclusive,g.endExclusive))}intersect(g){const _=Math.max(this.start,g.start),l=Math.min(this.endExclusive,g.endExclusive);if(_<=l)return new D(_,l)}slice(g){return g.slice(this.start,this.endExclusive)}clip(g){if(this.isEmpty)throw new A.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,g))}clipCyclic(g){if(this.isEmpty)throw new A.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return g<this.start?this.endExclusive-(this.start-g)%this.length:g>=this.endExclusive?this.start+(g-this.start)%this.length:g}forEach(g){for(let _=this.start;_<this.endExclusive;_++)g(_)}}n.OffsetRange=D;class i{constructor(){this._sortedRanges=[]}addRange(g){let _=0;for(;_<this._sortedRanges.length&&this._sortedRanges[_].endExclusive<g.start;)_++;let l=_;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=g.endExclusive;)l++;if(_===l)this._sortedRanges.splice(_,0,g);else{const o=Math.min(g.start,this._sortedRanges[_].start),v=Math.max(g.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(_,l-_,new D(o,v))}}toString(){return this._sortedRanges.map(g=>g.toString()).join(", ")}intersectsStrict(g){let _=0;for(;_<this._sortedRanges.length&&this._sortedRanges[_].endExclusive<=g.start;)_++;return _<this._sortedRanges.length&&this._sortedRanges[_].start<g.endExclusive}intersectWithRange(g){const _=new i;for(const l of this._sortedRanges){const o=l.intersect(g);o&&_.addRange(o)}return _}intersectWithRangeLength(g){return this.intersectWithRange(g).length}get length(){return this._sortedRanges.reduce((g,_)=>g+_.length,0)}}n.OffsetRangeSet=i}),Y(X[4],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class A{constructor(i,h){this.lineNumber=i,this.column=h}with(i=this.lineNumber,h=this.column){return i===this.lineNumber&&h===this.column?this:new A(i,h)}delta(i=0,h=0){return this.with(this.lineNumber+i,this.column+h)}equals(i){return A.equals(this,i)}static equals(i,h){return!i&&!h?!0:!!i&&!!h&&i.lineNumber===h.lineNumber&&i.column===h.column}isBefore(i){return A.isBefore(this,i)}static isBefore(i,h){return i.lineNumber<h.lineNumber?!0:h.lineNumber<i.lineNumber?!1:i.column<h.column}isBeforeOrEqual(i){return A.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,h){return i.lineNumber<h.lineNumber?!0:h.lineNumber<i.lineNumber?!1:i.column<=h.column}static compare(i,h){const g=i.lineNumber|0,_=h.lineNumber|0;if(g===_){const l=i.column|0,o=h.column|0;return l-o}return g-_}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new A(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=A}),Y(X[2],J([0,1,4]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class D{constructor(h,g,_,l){h>_||h===_&&g>l?(this.startLineNumber=_,this.startColumn=l,this.endLineNumber=h,this.endColumn=g):(this.startLineNumber=h,this.startColumn=g,this.endLineNumber=_,this.endColumn=l)}isEmpty(){return D.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return D.containsPosition(this,h)}static containsPosition(h,g){return!(g.lineNumber<h.startLineNumber||g.lineNumber>h.endLineNumber||g.lineNumber===h.startLineNumber&&g.column<h.startColumn||g.lineNumber===h.endLineNumber&&g.column>h.endColumn)}static strictContainsPosition(h,g){return!(g.lineNumber<h.startLineNumber||g.lineNumber>h.endLineNumber||g.lineNumber===h.startLineNumber&&g.column<=h.startColumn||g.lineNumber===h.endLineNumber&&g.column>=h.endColumn)}containsRange(h){return D.containsRange(this,h)}static containsRange(h,g){return!(g.startLineNumber<h.startLineNumber||g.endLineNumber<h.startLineNumber||g.startLineNumber>h.endLineNumber||g.endLineNumber>h.endLineNumber||g.startLineNumber===h.startLineNumber&&g.startColumn<h.startColumn||g.endLineNumber===h.endLineNumber&&g.endColumn>h.endColumn)}strictContainsRange(h){return D.strictContainsRange(this,h)}static strictContainsRange(h,g){return!(g.startLineNumber<h.startLineNumber||g.endLineNumber<h.startLineNumber||g.startLineNumber>h.endLineNumber||g.endLineNumber>h.endLineNumber||g.startLineNumber===h.startLineNumber&&g.startColumn<=h.startColumn||g.endLineNumber===h.endLineNumber&&g.endColumn>=h.endColumn)}plusRange(h){return D.plusRange(this,h)}static plusRange(h,g){let _,l,o,v;return g.startLineNumber<h.startLineNumber?(_=g.startLineNumber,l=g.startColumn):g.startLineNumber===h.startLineNumber?(_=g.startLineNumber,l=Math.min(g.startColumn,h.startColumn)):(_=h.startLineNumber,l=h.startColumn),g.endLineNumber>h.endLineNumber?(o=g.endLineNumber,v=g.endColumn):g.endLineNumber===h.endLineNumber?(o=g.endLineNumber,v=Math.max(g.endColumn,h.endColumn)):(o=h.endLineNumber,v=h.endColumn),new D(_,l,o,v)}intersectRanges(h){return D.intersectRanges(this,h)}static intersectRanges(h,g){let _=h.startLineNumber,l=h.startColumn,o=h.endLineNumber,v=h.endColumn;const e=g.startLineNumber,b=g.startColumn,u=g.endLineNumber,f=g.endColumn;return _<e?(_=e,l=b):_===e&&(l=Math.max(l,b)),o>u?(o=u,v=f):o===u&&(v=Math.min(v,f)),_>o||_===o&&l>v?null:new D(_,l,o,v)}equalsRange(h){return D.equalsRange(this,h)}static equalsRange(h,g){return!h&&!g?!0:!!h&&!!g&&h.startLineNumber===g.startLineNumber&&h.startColumn===g.startColumn&&h.endLineNumber===g.endLineNumber&&h.endColumn===g.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(h){return new A.Position(h.endLineNumber,h.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(h){return new A.Position(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,g){return new D(this.startLineNumber,this.startColumn,h,g)}setStartPosition(h,g){return new D(h,g,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(h){return new D(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(h){return new D(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new D(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,g=h){return new D(h.lineNumber,h.column,g.lineNumber,g.column)}static lift(h){return h?new D(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,g){return!(h.endLineNumber<g.startLineNumber||h.endLineNumber===g.startLineNumber&&h.endColumn<g.startColumn||g.endLineNumber<h.startLineNumber||g.endLineNumber===h.startLineNumber&&g.endColumn<h.startColumn)}static areIntersecting(h,g){return!(h.endLineNumber<g.startLineNumber||h.endLineNumber===g.startLineNumber&&h.endColumn<=g.startColumn||g.endLineNumber<h.startLineNumber||g.endLineNumber===h.startLineNumber&&g.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,g){if(h&&g){const o=h.startLineNumber|0,v=g.startLineNumber|0;if(o===v){const e=h.startColumn|0,b=g.startColumn|0;if(e===b){const u=h.endLineNumber|0,f=g.endLineNumber|0;if(u===f){const m=h.endColumn|0,c=g.endColumn|0;return m-c}return u-f}return e-b}return o-v}return(h?1:0)-(g?1:0)}static compareRangesUsingEnds(h,g){return h.endLineNumber===g.endLineNumber?h.endColumn===g.endColumn?h.startLineNumber===g.startLineNumber?h.startColumn-g.startColumn:h.startLineNumber-g.startLineNumber:h.endColumn-g.endColumn:h.endLineNumber-g.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}n.Range=D}),Y(X[10],J([0,1,5,3,2,11]),function(T,n,A,D,i,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class g{static fromRange(o){return new g(o.startLineNumber,o.endLineNumber)}static joinMany(o){if(o.length===0)return[];let v=new _(o[0].slice());for(let e=1;e<o.length;e++)v=v.getUnion(new _(o[e].slice()));return v.ranges}static ofLength(o,v){return new g(o,o+v)}static deserialize(o){return new g(o[0],o[1])}constructor(o,v){if(o>v)throw new A.BugIndicatingError(`startLineNumber ${o} cannot be after endLineNumberExclusive ${v}`);this.startLineNumber=o,this.endLineNumberExclusive=v}contains(o){return this.startLineNumber<=o&&o<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(o){return new g(this.startLineNumber+o,this.endLineNumberExclusive+o)}deltaLength(o){return new g(this.startLineNumber,this.endLineNumberExclusive+o)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(o){return new g(Math.min(this.startLineNumber,o.startLineNumber),Math.max(this.endLineNumberExclusive,o.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(o){const v=Math.max(this.startLineNumber,o.startLineNumber),e=Math.min(this.endLineNumberExclusive,o.endLineNumberExclusive);if(v<=e)return new g(v,e)}intersectsStrict(o){return this.startLineNumber<o.endLineNumberExclusive&&o.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(o){return this.startLineNumber<=o.endLineNumberExclusive&&o.startLineNumber<=this.endLineNumberExclusive}equals(o){return this.startLineNumber===o.startLineNumber&&this.endLineNumberExclusive===o.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(o){const v=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)v.push(o(e));return v}forEach(o){for(let v=this.startLineNumber;v<this.endLineNumberExclusive;v++)o(v)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(o){return this.startLineNumber<=o&&o<this.endLineNumberExclusive}toOffsetRange(){return new D.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=g;class _{constructor(o=[]){this._normalizedRanges=o}get ranges(){return this._normalizedRanges}addRange(o){if(o.length===0)return;const v=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,b=>b.endLineNumberExclusive>=o.startLineNumber),e=(0,h.findLastIdxMonotonous)(this._normalizedRanges,b=>b.startLineNumber<=o.endLineNumberExclusive)+1;if(v===e)this._normalizedRanges.splice(v,0,o);else if(v===e-1){const b=this._normalizedRanges[v];this._normalizedRanges[v]=b.join(o)}else{const b=this._normalizedRanges[v].join(this._normalizedRanges[e-1]).join(o);this._normalizedRanges.splice(v,e-v,b)}}contains(o){const v=(0,h.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=o);return!!v&&v.endLineNumberExclusive>o}getUnion(o){if(this._normalizedRanges.length===0)return o;if(o._normalizedRanges.length===0)return this;const v=[];let e=0,b=0,u=null;for(;e<this._normalizedRanges.length||b<o._normalizedRanges.length;){let f=null;if(e<this._normalizedRanges.length&&b<o._normalizedRanges.length){const m=this._normalizedRanges[e],c=o._normalizedRanges[b];m.startLineNumber<c.startLineNumber?(f=m,e++):(f=c,b++)}else e<this._normalizedRanges.length?(f=this._normalizedRanges[e],e++):(f=o._normalizedRanges[b],b++);u===null?u=f:u.endLineNumberExclusive>=f.startLineNumber?u=new g(u.startLineNumber,Math.max(u.endLineNumberExclusive,f.endLineNumberExclusive)):(v.push(u),u=f)}return u!==null&&v.push(u),new _(v)}subtractFrom(o){const v=(0,h.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,f=>f.endLineNumberExclusive>=o.startLineNumber),e=(0,h.findLastIdxMonotonous)(this._normalizedRanges,f=>f.startLineNumber<=o.endLineNumberExclusive)+1;if(v===e)return new _([o]);const b=[];let u=o.startLineNumber;for(let f=v;f<e;f++){const m=this._normalizedRanges[f];m.startLineNumber>u&&b.push(new g(u,m.startLineNumber)),u=m.endLineNumberExclusive}return u<o.endLineNumberExclusive&&b.push(new g(u,o.endLineNumberExclusive)),new _(b)}toString(){return this._normalizedRanges.map(o=>o.toString()).join(", ")}getIntersection(o){const v=[];let e=0,b=0;for(;e<this._normalizedRanges.length&&b<o._normalizedRanges.length;){const u=this._normalizedRanges[e],f=o._normalizedRanges[b],m=u.intersect(f);m&&!m.isEmpty&&v.push(m),u.endLineNumberExclusive<f.endLineNumberExclusive?e++:b++}return new _(v)}getWithDelta(o){return new _(this._normalizedRanges.map(v=>v.delta(o)))}}n.LineRangeSet=_}),Y(X[41],J([0,1,4,2]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends D.Range{constructor(g,_,l,o){super(g,_,l,o),this.selectionStartLineNumber=g,this.selectionStartColumn=_,this.positionLineNumber=l,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return i.selectionsEqual(this,g)}static selectionsEqual(g,_){return g.selectionStartLineNumber===_.selectionStartLineNumber&&g.selectionStartColumn===_.selectionStartColumn&&g.positionLineNumber===_.positionLineNumber&&g.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,_){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,g,_):new i(g,_,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,_){return this.getDirection()===0?new i(g,_,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,g,_)}static fromPositions(g,_=g){return new i(g.lineNumber,g.column,_.lineNumber,_.column)}static fromRange(g,_){return _===0?new i(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new i(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new i(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,_){if(g&&!_||!g&&_)return!1;if(!g&&!_)return!0;if(g.length!==_.length)return!1;for(let l=0,o=g.length;l<o;l++)if(!this.selectionsEqual(g[l],_[l]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,_,l,o,v){return v===0?new i(g,_,l,o):new i(l,o,g,_)}}n.Selection=i}),Y(X[42],J([0,1,27]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class D extends A.CharacterClassifier{constructor(g){super(0);for(let _=0,l=g.length;_<l;_++)this.set(g.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function i(h){const g={};return _=>(g.hasOwnProperty(_)||(g[_]=h(_)),g[_])}n.getMapForWordSeparators=i(h=>new D(h))}),Y(X[28],J([0,1,21,22]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(o=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)o.indexOf(e)>=0||(v+="\\"+e);return v+="\\s]+)",new RegExp(v,"g")}n.DEFAULT_WORD_REGEXP=i();function h(o){let v=n.DEFAULT_WORD_REGEXP;if(o&&o instanceof RegExp)if(o.global)v=o;else{let e="g";o.ignoreCase&&(e+="i"),o.multiline&&(e+="m"),o.unicode&&(e+="u"),v=new RegExp(o.source,e)}return v.lastIndex=0,v}n.ensureValidWordDefinition=h;const g=new D.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function _(o,v,e,b,u){if(u||(u=A.Iterable.first(g)),e.length>u.maxLen){let C=o-u.maxLen/2;return C<0?C=0:b+=C,e=e.substring(C,o+u.maxLen/2),_(o,v,e,b,u)}const f=Date.now(),m=o-1-b;let c=-1,N=null;for(let C=1;!(Date.now()-f>=u.timeBudget);C++){const y=m-u.windowSize*C;v.lastIndex=Math.max(0,y);const p=l(v,e,m,c);if(!p&&N||(N=p,y<=0))break;c=y}if(N){const C={word:N[0],startColumn:b+1+N.index,endColumn:b+1+N.index+N[0].length};return v.lastIndex=0,C}return null}n.getWordAtText=_;function l(o,v,e,b){let u;for(;u=o.exec(v);){const f=u.index||0;if(f<=e&&o.lastIndex>=e)return u;if(b>0&&f>b)return null}return null}}),Y(X[7],J([0,1,8,5,3]),function(T,n,A,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class h{static trivial(v,e){return new h([new g(new i.OffsetRange(0,v.length),new i.OffsetRange(0,e.length))],!1)}static trivialTimedOut(v,e){return new h([new g(new i.OffsetRange(0,v.length),new i.OffsetRange(0,e.length))],!0)}constructor(v,e){this.diffs=v,this.hitTimeout=e}}n.DiffAlgorithmResult=h;class g{static invert(v,e){const b=[];return(0,A.forEachAdjacent)(v,(u,f)=>{const m=u?u.seq1Range.endExclusive:0,c=u?u.seq2Range.endExclusive:0,N=f?f.seq1Range.start:e,C=f?f.seq2Range.start:(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+e;b.push(new g(new i.OffsetRange(m,N),new i.OffsetRange(c,C)))}),b}constructor(v,e){this.seq1Range=v,this.seq2Range=e}swap(){return new g(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(v){return new g(this.seq1Range.join(v.seq1Range),this.seq2Range.join(v.seq2Range))}delta(v){return v===0?this:new g(this.seq1Range.delta(v),this.seq2Range.delta(v))}}n.SequenceDiff=g;class _{isValid(){return!0}}n.InfiniteTimeout=_,_.instance=new _;class l{constructor(v){if(this.timeout=v,this.startTime=Date.now(),this.valid=!0,v<=0)throw new D.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=l}),Y(X[29],J([0,1,3,7]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(o,v,e=D.InfiniteTimeout.instance){if(o.length===0||v.length===0)return D.DiffAlgorithmResult.trivial(o,v);const b=o,u=v;function f(s,a){for(;s<b.length&&a<u.length&&b.getElement(s)===u.getElement(a);)s++,a++;return s}let m=0;const c=new g;c.set(0,f(0,0));const N=new _;N.set(0,c.get(0)===0?null:new h(null,0,0,c.get(0)));let C=0;e:for(;;){if(m++,!e.isValid())return D.DiffAlgorithmResult.trivialTimedOut(b,u);const s=-Math.min(m,u.length+m%2),a=Math.min(m,b.length+m%2);for(C=s;C<=a;C+=2){let L=0;const d=C===a?-1:c.get(C+1),w=C===s?-1:c.get(C-1)+1;L++;const R=Math.min(Math.max(d,w),b.length),E=R-C;if(L++,R>b.length||E>u.length)continue;const M=f(R,E);c.set(C,M);const F=R===d?N.get(C+1):N.get(C-1);if(N.set(C,M!==R?new h(F,R,E,M-R):F),c.get(C)===b.length&&c.get(C)-C===u.length)break e}}let y=N.get(C);const p=[];let S=b.length,r=u.length;for(;;){const s=y?y.x+y.length:0,a=y?y.y+y.length:0;if((s!==S||a!==r)&&p.push(new D.SequenceDiff(new A.OffsetRange(s,S),new A.OffsetRange(a,r))),!y)break;S=y.x,r=y.y,y=y.prev}return p.reverse(),new D.DiffAlgorithmResult(p,!1)}}n.MyersDiffAlgorithm=i;class h{constructor(o,v,e,b){this.prev=o,this.x=v,this.y=e,this.length=b}}class g{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,v){if(o<0){if(o=-o-1,o>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[o]=v}else{if(o>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[o]=v}}}class _{constructor(){this.positiveArr=[],this.negativeArr=[]}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,v){o<0?(o=-o-1,this.negativeArr[o]=v):this.positiveArr[o]=v}}}),Y(X[43],J([0,1,3,7]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.removeVeryShortMatchingTextBetweenLongDiffs=n.removeVeryShortMatchingLinesBetweenDiffs=n.extendDiffsToEntireWordIfAppropriate=n.removeShortMatches=n.optimizeSequenceDiffs=void 0;function i(u,f,m){let c=m;return c=h(u,f,c),c=g(u,f,c),c}n.optimizeSequenceDiffs=i;function h(u,f,m){if(m.length===0)return m;const c=[];c.push(m[0]);for(let C=1;C<m.length;C++){const y=c[c.length-1];let p=m[C];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const S=p.seq1Range.start-y.seq1Range.endExclusive;let r;for(r=1;r<=S&&!(u.getElement(p.seq1Range.start-r)!==u.getElement(p.seq1Range.endExclusive-r)||f.getElement(p.seq2Range.start-r)!==f.getElement(p.seq2Range.endExclusive-r));r++);if(r--,r===S){c[c.length-1]=new D.SequenceDiff(new A.OffsetRange(y.seq1Range.start,p.seq1Range.endExclusive-S),new A.OffsetRange(y.seq2Range.start,p.seq2Range.endExclusive-S));continue}p=p.delta(-r)}c.push(p)}const N=[];for(let C=0;C<c.length-1;C++){const y=c[C+1];let p=c[C];if(p.seq1Range.isEmpty||p.seq2Range.isEmpty){const S=y.seq1Range.start-p.seq1Range.endExclusive;let r;for(r=0;r<S&&!(u.getElement(p.seq1Range.start+r)!==u.getElement(p.seq1Range.endExclusive+r)||f.getElement(p.seq2Range.start+r)!==f.getElement(p.seq2Range.endExclusive+r));r++);if(r===S){c[C+1]=new D.SequenceDiff(new A.OffsetRange(p.seq1Range.start+S,y.seq1Range.endExclusive),new A.OffsetRange(p.seq2Range.start+S,y.seq2Range.endExclusive));continue}r>0&&(p=p.delta(r))}N.push(p)}return c.length>0&&N.push(c[c.length-1]),N}function g(u,f,m){if(!u.getBoundaryScore||!f.getBoundaryScore)return m;for(let c=0;c<m.length;c++){const N=c>0?m[c-1]:void 0,C=m[c],y=c+1<m.length?m[c+1]:void 0,p=new A.OffsetRange(N?N.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:u.length),S=new A.OffsetRange(N?N.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:f.length);C.seq1Range.isEmpty?m[c]=_(C,u,f,p,S):C.seq2Range.isEmpty&&(m[c]=_(C.swap(),f,u,S,p).swap())}return m}function _(u,f,m,c,N){let y=1;for(;u.seq1Range.start-y>=c.start&&u.seq2Range.start-y>=N.start&&m.isStronglyEqual(u.seq2Range.start-y,u.seq2Range.endExclusive-y)&&y<100;)y++;y--;let p=0;for(;u.seq1Range.start+p<c.endExclusive&&u.seq2Range.endExclusive+p<N.endExclusive&&m.isStronglyEqual(u.seq2Range.start+p,u.seq2Range.endExclusive+p)&&p<100;)p++;if(y===0&&p===0)return u;let S=0,r=-1;for(let s=-y;s<=p;s++){const a=u.seq2Range.start+s,L=u.seq2Range.endExclusive+s,d=u.seq1Range.start+s,w=f.getBoundaryScore(d)+m.getBoundaryScore(a)+m.getBoundaryScore(L);w>r&&(r=w,S=s)}return u.delta(S)}function l(u,f,m){const c=[];for(const N of m){const C=c[c.length-1];if(!C){c.push(N);continue}N.seq1Range.start-C.seq1Range.endExclusive<=2||N.seq2Range.start-C.seq2Range.endExclusive<=2?c[c.length-1]=new D.SequenceDiff(C.seq1Range.join(N.seq1Range),C.seq2Range.join(N.seq2Range)):c.push(N)}return c}n.removeShortMatches=l;function o(u,f,m){const c=[];let N;function C(){if(!N)return;const p=N.s1Range.length-N.deleted,S=N.s2Range.length-N.added;Math.max(N.deleted,N.added)+(N.count-1)>p&&c.push(new D.SequenceDiff(N.s1Range,N.s2Range)),N=void 0}for(const p of m){let S=function(d,w){var R,E,M,F;if(!N||!N.s1Range.containsRange(d)||!N.s2Range.containsRange(w))if(N&&!(N.s1Range.endExclusive<d.start&&N.s2Range.endExclusive<w.start)){const U=A.OffsetRange.tryCreate(N.s1Range.endExclusive,d.start),k=A.OffsetRange.tryCreate(N.s2Range.endExclusive,w.start);N.deleted+=(R=U?.length)!==null&&R!==void 0?R:0,N.added+=(E=k?.length)!==null&&E!==void 0?E:0,N.s1Range=N.s1Range.join(d),N.s2Range=N.s2Range.join(w)}else C(),N={added:0,deleted:0,count:0,s1Range:d,s2Range:w};const B=d.intersect(p.seq1Range),I=w.intersect(p.seq2Range);N.count++,N.deleted+=(M=B?.length)!==null&&M!==void 0?M:0,N.added+=(F=I?.length)!==null&&F!==void 0?F:0};const r=u.findWordContaining(p.seq1Range.start-1),s=f.findWordContaining(p.seq2Range.start-1),a=u.findWordContaining(p.seq1Range.endExclusive),L=f.findWordContaining(p.seq2Range.endExclusive);r&&a&&s&&L&&r.equals(a)&&s.equals(L)?S(r,s):(r&&s&&S(r,s),a&&L&&S(a,L))}return C(),v(m,c)}n.extendDiffsToEntireWordIfAppropriate=o;function v(u,f){const m=[];for(;u.length>0||f.length>0;){const c=u[0],N=f[0];let C;c&&(!N||c.seq1Range.start<N.seq1Range.start)?C=u.shift():C=f.shift(),m.length>0&&m[m.length-1].seq1Range.endExclusive>=C.seq1Range.start?m[m.length-1]=m[m.length-1].join(C):m.push(C)}return m}function e(u,f,m){let c=m;if(c.length===0)return c;let N=0,C;do{C=!1;const y=[c[0]];for(let p=1;p<c.length;p++){let s=function(L,d){const w=new A.OffsetRange(r.seq1Range.endExclusive,S.seq1Range.start);return u.getText(w).replace(/\s/g,"").length<=4&&(L.seq1Range.length+L.seq2Range.length>5||d.seq1Range.length+d.seq2Range.length>5)};const S=c[p],r=y[y.length-1];s(r,S)?(C=!0,y[y.length-1]=y[y.length-1].join(S)):y.push(S)}c=y}while(N++<10&&C);return c}n.removeVeryShortMatchingLinesBetweenDiffs=e;function b(u,f,m){let c=m;if(c.length===0)return c;let N=0,C;do{C=!1;const y=[c[0]];for(let p=1;p<c.length;p++){let s=function(L,d){const w=new A.OffsetRange(r.seq1Range.endExclusive,S.seq1Range.start);if(u.countLinesIn(w)>5||w.length>500)return!1;const E=u.getText(w).trim();if(E.length>20||E.split(/\r\n|\r|\n/).length>1)return!1;const M=u.countLinesIn(L.seq1Range),F=L.seq1Range.length,B=f.countLinesIn(L.seq2Range),I=L.seq2Range.length,U=u.countLinesIn(d.seq1Range),k=d.seq1Range.length,x=f.countLinesIn(d.seq2Range),q=d.seq2Range.length,W=2*40+50;function z(G){return Math.min(G,W)}return Math.pow(Math.pow(z(M*40+F),1.5)+Math.pow(z(B*40+I),1.5),1.5)+Math.pow(Math.pow(z(U*40+k),1.5)+Math.pow(z(x*40+q),1.5),1.5)>Math.pow(Math.pow(W,1.5),1.5)*1.3};const S=c[p],r=y[y.length-1];s(r,S)?(C=!0,y[y.length-1]=y[y.length-1].join(S)):y.push(S)}c=y}while(N++<10&&C);for(let y=0;y<c.length;y++){const p=c[y];let S=p.seq1Range,r=p.seq2Range;const s=u.extendToFullLines(p.seq1Range),a=u.getText(new A.OffsetRange(s.start,p.seq1Range.start));a.length>0&&a.trim().length<=3&&p.seq1Range.length+p.seq2Range.length>100&&(S=p.seq1Range.deltaStart(-a.length),r=p.seq2Range.deltaStart(-a.length));const L=u.getText(new A.OffsetRange(p.seq1Range.endExclusive,s.endExclusive));L.length>0&&L.trim().length<=3&&p.seq1Range.length+p.seq2Range.length>150&&(S=S.deltaEnd(L.length),r=r.deltaEnd(L.length)),c[y]=new D.SequenceDiff(S,r)}return c}n.removeVeryShortMatchingTextBetweenLongDiffs=b}),Y(X[44],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class A{constructor(h,g){this.trimmedHash=h,this.lines=g}getElement(h){return this.trimmedHash[h]}get length(){return this.trimmedHash.length}getBoundaryScore(h){const g=h===0?0:D(this.lines[h-1]),_=h===this.lines.length?0:D(this.lines[h]);return 1e3-(g+_)}getText(h){return this.lines.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,g){return this.lines[h]===this.lines[g]}}n.LineSequence=A;function D(i){let h=0;for(;h<i.length&&(i.charCodeAt(h)===32||i.charCodeAt(h)===9);)h++;return h}}),Y(X[15],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.isSpace=n.Array2D=void 0;class A{constructor(g,_){this.width=g,this.height=_,this.array=[],this.array=new Array(g*_)}get(g,_){return this.array[g+_*this.width]}set(g,_,l){this.array[g+_*this.width]=l}}n.Array2D=A;function D(h){return h===32||h===9}n.isSpace=D;class i{static getKey(g){let _=this.chrKeys.get(g);return _===void 0&&(_=this.chrKeys.size,this.chrKeys.set(g,_)),_}constructor(g,_,l){this.range=g,this.lines=_,this.source=l,this.histogram=[];let o=0;for(let v=g.startLineNumber-1;v<g.endLineNumberExclusive-1;v++){const e=_[v];for(let u=0;u<e.length;u++){o++;const f=e[u],m=i.getKey(f);this.histogram[m]=(this.histogram[m]||0)+1}o++;const b=i.getKey(`
`);this.histogram[b]=(this.histogram[b]||0)+1}this.totalCount=o}computeSimilarity(g){var _,l;let o=0;const v=Math.max(this.histogram.length,g.histogram.length);for(let e=0;e<v;e++)o+=Math.abs(((_=this.histogram[e])!==null&&_!==void 0?_:0)-((l=g.histogram[e])!==null&&l!==void 0?l:0));return 1-o/(this.totalCount+g.totalCount)}}n.LineRangeFragment=i,i.chrKeys=new Map}),Y(X[45],J([0,1,3,7,15]),function(T,n,A,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class h{compute(_,l,o=D.InfiniteTimeout.instance,v){if(_.length===0||l.length===0)return D.DiffAlgorithmResult.trivial(_,l);const e=new i.Array2D(_.length,l.length),b=new i.Array2D(_.length,l.length),u=new i.Array2D(_.length,l.length);for(let p=0;p<_.length;p++)for(let S=0;S<l.length;S++){if(!o.isValid())return D.DiffAlgorithmResult.trivialTimedOut(_,l);const r=p===0?0:e.get(p-1,S),s=S===0?0:e.get(p,S-1);let a;_.getElement(p)===l.getElement(S)?(p===0||S===0?a=0:a=e.get(p-1,S-1),p>0&&S>0&&b.get(p-1,S-1)===3&&(a+=u.get(p-1,S-1)),a+=v?v(p,S):1):a=-1;const L=Math.max(r,s,a);if(L===a){const d=p>0&&S>0?u.get(p-1,S-1):0;u.set(p,S,d+1),b.set(p,S,3)}else L===r?(u.set(p,S,0),b.set(p,S,1)):L===s&&(u.set(p,S,0),b.set(p,S,2));e.set(p,S,L)}const f=[];let m=_.length,c=l.length;function N(p,S){(p+1!==m||S+1!==c)&&f.push(new D.SequenceDiff(new A.OffsetRange(p+1,m),new A.OffsetRange(S+1,c))),m=p,c=S}let C=_.length-1,y=l.length-1;for(;C>=0&&y>=0;)b.get(C,y)===3?(N(C,y),C--,y--):b.get(C,y)===1?C--:y--;return N(-1,-1),f.reverse(),new D.DiffAlgorithmResult(f,!1)}}n.DynamicProgrammingDiffing=h}),Y(X[30],J([0,1,11,3,4,2,15]),function(T,n,A,D,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class _{constructor(u,f,m){this.lines=u,this.considerWhitespaceChanges=m,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let c=!1;f.start>0&&f.endExclusive>=u.length&&(f=new D.OffsetRange(f.start-1,f.endExclusive),c=!0),this.lineRange=f,this.firstCharOffsetByLine[0]=0;for(let N=this.lineRange.start;N<this.lineRange.endExclusive;N++){let C=u[N],y=0;if(c)y=C.length,C="",c=!1;else if(!m){const p=C.trimStart();y=C.length-p.length,C=p.trimEnd()}this.additionalOffsetByLine.push(y);for(let p=0;p<C.length;p++)this.elements.push(C.charCodeAt(p));N<u.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[N-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.OffsetRange(0,this.length))}getText(u){return this.elements.slice(u.start,u.endExclusive).map(f=>String.fromCharCode(f)).join("")}getElement(u){return this.elements[u]}get length(){return this.elements.length}getBoundaryScore(u){const f=e(u>0?this.elements[u-1]:-1),m=e(u<this.elements.length?this.elements[u]:-1);if(f===6&&m===7)return 0;let c=0;return f!==m&&(c+=10,m===1&&(c+=1)),c+=v(f),c+=v(m),c}translateOffset(u){if(this.lineRange.isEmpty)return new i.Position(this.lineRange.start+1,1);const f=(0,A.findLastIdxMonotonous)(this.firstCharOffsetByLine,m=>m<=u);return new i.Position(this.lineRange.start+f+1,u-this.firstCharOffsetByLine[f]+this.additionalOffsetByLine[f]+1)}translateRange(u){return h.Range.fromPositions(this.translateOffset(u.start),this.translateOffset(u.endExclusive))}findWordContaining(u){if(u<0||u>=this.elements.length||!l(this.elements[u]))return;let f=u;for(;f>0&&l(this.elements[f-1]);)f--;let m=u;for(;m<this.elements.length&&l(this.elements[m]);)m++;return new D.OffsetRange(f,m)}countLinesIn(u){return this.translateOffset(u.endExclusive).lineNumber-this.translateOffset(u.start).lineNumber}isStronglyEqual(u,f){return this.elements[u]===this.elements[f]}extendToFullLines(u){var f,m;const c=(f=(0,A.findLastMonotonous)(this.firstCharOffsetByLine,C=>C<=u.start))!==null&&f!==void 0?f:0,N=(m=(0,A.findFirstMonotonous)(this.firstCharOffsetByLine,C=>u.endExclusive<=C))!==null&&m!==void 0?m:this.elements.length;return new D.OffsetRange(c,N)}}n.LinesSliceCharSequence=_;function l(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}const o={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function v(b){return o[b]}function e(b){return b===10?7:b===13?6:(0,g.isSpace)(b)?5:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:4}}),Y(X[31],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class A{constructor(h,g,_){this.changes=h,this.moves=g,this.hitTimeout=_}}n.LinesDiff=A;class D{constructor(h,g){this.lineRangeMapping=h,this.changes=g}}n.MovedText=D}),Y(X[16],J([0,1,10]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class D{static inverse(_,l,o){const v=[];let e=1,b=1;for(const f of _){const m=new i(new A.LineRange(e,f.original.startLineNumber),new A.LineRange(b,f.modified.startLineNumber),void 0);m.modified.isEmpty||v.push(m),e=f.original.endLineNumberExclusive,b=f.modified.endLineNumberExclusive}const u=new i(new A.LineRange(e,l+1),new A.LineRange(b,o+1),void 0);return u.modified.isEmpty||v.push(u),v}constructor(_,l){this.original=_,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new D(this.modified,this.original)}join(_){return new D(this.original.join(_.original),this.modified.join(_.modified))}}n.LineRangeMapping=D;class i extends D{constructor(_,l,o){super(_,l),this.innerChanges=o}flip(){var _;return new i(this.modified,this.original,(_=this.innerChanges)===null||_===void 0?void 0:_.map(l=>l.flip()))}}n.DetailedLineRangeMapping=i;class h{constructor(_,l){this.originalRange=_,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new h(this.modifiedRange,this.originalRange)}}n.RangeMapping=h}),Y(X[46],J([0,1,7,16,8,11,33,10,3,30,15,29]),function(T,n,A,D,i,h,g,_,l,o,v,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=void 0;function b(C,y,p,S,r,s){let{moves:a,excludedChanges:L}=u(C,y,p,s);if(!s.isValid())return[];const d=C.filter(R=>!L.has(R)),w=f(d,S,r,y,p,s);return(0,i.pushMany)(a,w),a=c(a),a=a.filter(R=>R.original.toOffsetRange().slice(y).map(M=>M.trim()).join(`
`).length>=10),a=N(C,a),a}n.computeMovedLines=b;function u(C,y,p,S){const r=[],s=C.filter(d=>d.modified.isEmpty&&d.original.length>=3).map(d=>new v.LineRangeFragment(d.original,y,d)),a=new Set(C.filter(d=>d.original.isEmpty&&d.modified.length>=3).map(d=>new v.LineRangeFragment(d.modified,p,d))),L=new Set;for(const d of s){let w=-1,R;for(const E of a){const M=d.computeSimilarity(E);M>w&&(w=M,R=E)}if(w>.9&&R&&(a.delete(R),r.push(new D.LineRangeMapping(d.range,R.range)),L.add(d.source),L.add(R.source)),!S.isValid())return{moves:r,excludedChanges:L}}return{moves:r,excludedChanges:L}}function f(C,y,p,S,r,s){const a=[],L=new g.SetMap;for(const M of C)for(let F=M.original.startLineNumber;F<M.original.endLineNumberExclusive-2;F++){const B=`${y[F-1]}:${y[F+1-1]}:${y[F+2-1]}`;L.add(B,{range:new _.LineRange(F,F+3)})}const d=[];C.sort((0,i.compareBy)(M=>M.modified.startLineNumber,i.numberComparator));for(const M of C){let F=[];for(let B=M.modified.startLineNumber;B<M.modified.endLineNumberExclusive-2;B++){const I=`${p[B-1]}:${p[B+1-1]}:${p[B+2-1]}`,U=new _.LineRange(B,B+3),k=[];L.forEach(I,({range:x})=>{for(const W of F)if(W.originalLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===U.endLineNumberExclusive){W.originalLineRange=new _.LineRange(W.originalLineRange.startLineNumber,x.endLineNumberExclusive),W.modifiedLineRange=new _.LineRange(W.modifiedLineRange.startLineNumber,U.endLineNumberExclusive),k.push(W);return}const q={modifiedLineRange:U,originalLineRange:x};d.push(q),k.push(q)}),F=k}if(!s.isValid())return[]}d.sort((0,i.reverseOrder)((0,i.compareBy)(M=>M.modifiedLineRange.length,i.numberComparator)));const w=new _.LineRangeSet,R=new _.LineRangeSet;for(const M of d){const F=M.modifiedLineRange.startLineNumber-M.originalLineRange.startLineNumber,B=w.subtractFrom(M.modifiedLineRange),I=R.subtractFrom(M.originalLineRange).getWithDelta(F),U=B.getIntersection(I);for(const k of U.ranges){if(k.length<3)continue;const x=k,q=k.delta(-F);a.push(new D.LineRangeMapping(q,x)),w.addRange(x),R.addRange(q)}}a.sort((0,i.compareBy)(M=>M.original.startLineNumber,i.numberComparator));const E=new h.MonotonousArray(C);for(let M=0;M<a.length;M++){const F=a[M],B=E.findLastMonotonous(G=>G.original.startLineNumber<=F.original.startLineNumber),I=(0,h.findLastMonotonous)(C,G=>G.modified.startLineNumber<=F.modified.startLineNumber),U=Math.max(F.original.startLineNumber-B.original.startLineNumber,F.modified.startLineNumber-I.modified.startLineNumber),k=E.findLastMonotonous(G=>G.original.startLineNumber<F.original.endLineNumberExclusive),x=(0,h.findLastMonotonous)(C,G=>G.modified.startLineNumber<F.modified.endLineNumberExclusive),q=Math.max(k.original.endLineNumberExclusive-F.original.endLineNumberExclusive,x.modified.endLineNumberExclusive-F.modified.endLineNumberExclusive);let W;for(W=0;W<U;W++){const G=F.original.startLineNumber-W-1,t=F.modified.startLineNumber-W-1;if(w.contains(t)||R.contains(G)||!m(S[G-1],r[t-1],s))break}W>0&&(R.addRange(new _.LineRange(F.original.startLineNumber-W,F.original.startLineNumber)),w.addRange(new _.LineRange(F.modified.startLineNumber-W,F.modified.startLineNumber)));let z;for(z=0;z<q;z++){const G=F.original.endLineNumberExclusive+z,t=F.modified.endLineNumberExclusive+z;if(w.contains(t)||R.contains(G)||!m(S[G-1],r[t-1],s))break}z>0&&(R.addRange(new _.LineRange(F.original.endLineNumberExclusive,F.original.endLineNumberExclusive+z)),w.addRange(new _.LineRange(F.modified.endLineNumberExclusive,F.modified.endLineNumberExclusive+z))),(W>0||z>0)&&(a[M]=new D.LineRangeMapping(new _.LineRange(F.original.startLineNumber-W,F.original.endLineNumberExclusive+z),new _.LineRange(F.modified.startLineNumber-W,F.modified.endLineNumberExclusive+z)))}return a}function m(C,y,p){if(C.trim()===y.trim())return!0;if(C.length>300&&y.length>300)return!1;const r=new e.MyersDiffAlgorithm().compute(new o.LinesSliceCharSequence([C],new l.OffsetRange(0,1),!1),new o.LinesSliceCharSequence([y],new l.OffsetRange(0,1),!1),p);let s=0;const a=A.SequenceDiff.invert(r.diffs,C.length);for(const R of a)R.seq1Range.forEach(E=>{(0,v.isSpace)(C.charCodeAt(E))||s++});function L(R){let E=0;for(let M=0;M<C.length;M++)(0,v.isSpace)(R.charCodeAt(M))||E++;return E}const d=L(C.length>y.length?C:y);return s/d>.6&&d>10}function c(C){if(C.length===0)return C;C.sort((0,i.compareBy)(p=>p.original.startLineNumber,i.numberComparator));const y=[C[0]];for(let p=1;p<C.length;p++){const S=y[y.length-1],r=C[p],s=r.original.startLineNumber-S.original.endLineNumberExclusive,a=r.modified.startLineNumber-S.modified.endLineNumberExclusive;if(s>=0&&a>=0&&s+a<=2){y[y.length-1]=S.join(r);continue}y.push(r)}return y}function N(C,y){const p=new h.MonotonousArray(C);return y=y.filter(S=>{const r=p.findLastMonotonous(d=>d.original.endLineNumberExclusive<=S.original.startLineNumber)||new D.LineRangeMapping(new _.LineRange(1,1),new _.LineRange(1,1)),s=S.modified.startLineNumber-r.modified.endLineNumberExclusive,a=S.original.startLineNumber-r.original.endLineNumberExclusive;return s!==a}),y}}),Y(X[47],J([0,1,8,12,10,3,2,7,45,29,46,43,31,16,30,44]),function(T,n,A,D,i,h,g,_,l,o,v,e,b,u,f,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.DefaultLinesDiffComputer=void 0;class c{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new o.MyersDiffAlgorithm}computeDiff(p,S,r){if(p.length<=1&&(0,A.equals)(p,S,(G,t)=>G===t))return new b.LinesDiff([],[],!1);if(p.length===1&&p[0].length===0||S.length===1&&S[0].length===0)return new b.LinesDiff([new u.DetailedLineRangeMapping(new i.LineRange(1,p.length+1),new i.LineRange(1,S.length+1),[new u.RangeMapping(new g.Range(1,1,p.length,p[0].length+1),new g.Range(1,1,S.length,S[0].length+1))])],[],!1);const s=r.maxComputationTimeMs===0?_.InfiniteTimeout.instance:new _.DateTimeout(r.maxComputationTimeMs),a=!r.ignoreTrimWhitespace,L=new Map;function d(G){let t=L.get(G);return t===void 0&&(t=L.size,L.set(G,t)),t}const w=p.map(G=>d(G.trim())),R=S.map(G=>d(G.trim())),E=new m.LineSequence(w,p),M=new m.LineSequence(R,S),F=(()=>E.length+M.length<1700?this.dynamicProgrammingDiffing.compute(E,M,s,(G,t)=>p[G]===S[t]?S[t].length===0?.1:1+Math.log(1+S[t].length):.99):this.myersDiffingAlgorithm.compute(E,M))();let B=F.diffs,I=F.hitTimeout;B=(0,e.optimizeSequenceDiffs)(E,M,B),B=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(E,M,B);const U=[],k=G=>{if(a)for(let t=0;t<G;t++){const ne=x+t,se=q+t;if(p[ne]!==S[se]){const ue=this.refineDiff(p,S,new _.SequenceDiff(new h.OffsetRange(ne,ne+1),new h.OffsetRange(se,se+1)),s,a);for(const me of ue.mappings)U.push(me);ue.hitTimeout&&(I=!0)}}};let x=0,q=0;for(const G of B){(0,D.assertFn)(()=>G.seq1Range.start-x===G.seq2Range.start-q);const t=G.seq1Range.start-x;k(t),x=G.seq1Range.endExclusive,q=G.seq2Range.endExclusive;const ne=this.refineDiff(p,S,G,s,a);ne.hitTimeout&&(I=!0);for(const se of ne.mappings)U.push(se)}k(p.length-x);const W=N(U,p,S);let z=[];return r.computeMoves&&(z=this.computeMoves(W,p,S,w,R,s,a)),(0,D.assertFn)(()=>{function G(ne,se){if(ne.lineNumber<1||ne.lineNumber>se.length)return!1;const ue=se[ne.lineNumber-1];return!(ne.column<1||ne.column>ue.length+1)}function t(ne,se){return!(ne.startLineNumber<1||ne.startLineNumber>se.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>se.length+1)}for(const ne of W){if(!ne.innerChanges)return!1;for(const se of ne.innerChanges)if(!(G(se.modifiedRange.getStartPosition(),S)&&G(se.modifiedRange.getEndPosition(),S)&&G(se.originalRange.getStartPosition(),p)&&G(se.originalRange.getEndPosition(),p)))return!1;if(!t(ne.modified,S)||!t(ne.original,p))return!1}return!0}),new b.LinesDiff(W,z,I)}computeMoves(p,S,r,s,a,L,d){return(0,v.computeMovedLines)(p,S,r,s,a,L).map(E=>{const M=this.refineDiff(S,r,new _.SequenceDiff(E.original.toOffsetRange(),E.modified.toOffsetRange()),L,d),F=N(M.mappings,S,r,!0);return new b.MovedText(E,F)})}refineDiff(p,S,r,s,a){const L=new f.LinesSliceCharSequence(p,r.seq1Range,a),d=new f.LinesSliceCharSequence(S,r.seq2Range,a),w=L.length+d.length<500?this.dynamicProgrammingDiffing.compute(L,d,s):this.myersDiffingAlgorithm.compute(L,d,s);let R=w.diffs;return R=(0,e.optimizeSequenceDiffs)(L,d,R),R=(0,e.extendDiffsToEntireWordIfAppropriate)(L,d,R),R=(0,e.removeShortMatches)(L,d,R),R=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(L,d,R),{mappings:R.map(M=>new u.RangeMapping(L.translateRange(M.seq1Range),d.translateRange(M.seq2Range))),hitTimeout:w.hitTimeout}}}n.DefaultLinesDiffComputer=c;function N(y,p,S,r=!1){const s=[];for(const a of(0,A.groupAdjacentBy)(y.map(L=>C(L,p,S)),(L,d)=>L.original.overlapOrTouch(d.original)||L.modified.overlapOrTouch(d.modified))){const L=a[0],d=a[a.length-1];s.push(new u.DetailedLineRangeMapping(L.original.join(d.original),L.modified.join(d.modified),a.map(w=>w.innerChanges[0])))}return(0,D.assertFn)(()=>!r&&s.length>0&&s[0].original.startLineNumber!==s[0].modified.startLineNumber?!1:(0,D.checkAdjacentItems)(s,(a,L)=>L.original.startLineNumber-a.original.endLineNumberExclusive===L.modified.startLineNumber-a.modified.endLineNumberExclusive&&a.original.endLineNumberExclusive<L.original.startLineNumber&&a.modified.endLineNumberExclusive<L.modified.startLineNumber)),s}n.lineRangeMappingFromRangeMappings=N;function C(y,p,S){let r=0,s=0;y.modifiedRange.endColumn===1&&y.originalRange.endColumn===1&&y.originalRange.startLineNumber+r<=y.originalRange.endLineNumber&&y.modifiedRange.startLineNumber+r<=y.modifiedRange.endLineNumber&&(s=-1),y.modifiedRange.startColumn-1>=S[y.modifiedRange.startLineNumber-1].length&&y.originalRange.startColumn-1>=p[y.originalRange.startLineNumber-1].length&&y.originalRange.startLineNumber<=y.originalRange.endLineNumber+s&&y.modifiedRange.startLineNumber<=y.modifiedRange.endLineNumber+s&&(r=1);const a=new i.LineRange(y.originalRange.startLineNumber+r,y.originalRange.endLineNumber+1+s),L=new i.LineRange(y.modifiedRange.startLineNumber+r,y.modifiedRange.endLineNumber+1+s);return new u.DetailedLineRangeMapping(a,L,[y])}n.getLineRangeMapping=C}),Y(X[48],J([0,1,24,31,16,6,2,12,10]),function(T,n,A,D,i,h,g,_,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const o=3;class v{computeDiff(r,s,a){var L;const w=new N(r,s,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let E=null;for(const M of w.changes){let F;M.originalEndLineNumber===0?F=new l.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):F=new l.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let B;M.modifiedEndLineNumber===0?B=new l.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):B=new l.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let I=new i.DetailedLineRangeMapping(F,B,(L=M.charChanges)===null||L===void 0?void 0:L.map(U=>new i.RangeMapping(new g.Range(U.originalStartLineNumber,U.originalStartColumn,U.originalEndLineNumber,U.originalEndColumn),new g.Range(U.modifiedStartLineNumber,U.modifiedStartColumn,U.modifiedEndLineNumber,U.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===I.modified.startLineNumber||E.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new i.DetailedLineRangeMapping(E.original.join(I.original),E.modified.join(I.modified),E.innerChanges&&I.innerChanges?E.innerChanges.concat(I.innerChanges):void 0),R.pop()),R.push(I),E=I}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(R,(M,F)=>F.original.startLineNumber-M.original.endLineNumberExclusive===F.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<F.original.startLineNumber&&M.modified.endLineNumberExclusive<F.modified.startLineNumber)),new D.LinesDiff(R,[],w.quitEarly)}}n.LegacyLinesDiffComputer=v;function e(S,r,s,a){return new A.LcsDiff(S,r,s).ComputeDiff(a)}class b{constructor(r){const s=[],a=[];for(let L=0,d=r.length;L<d;L++)s[L]=C(r[L],1),a[L]=y(r[L],1);this.lines=r,this._startColumns=s,this._endColumns=a}getElements(){const r=[];for(let s=0,a=this.lines.length;s<a;s++)r[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,s,a){const L=[],d=[],w=[];let R=0;for(let E=s;E<=a;E++){const M=this.lines[E],F=r?this._startColumns[E]:1,B=r?this._endColumns[E]:M.length+1;for(let I=F;I<B;I++)L[R]=M.charCodeAt(I-1),d[R]=E+1,w[R]=I,R++;!r&&E<a&&(L[R]=10,d[R]=E+1,w[R]=M.length+1,R++)}return new u(L,d,w)}}class u{constructor(r,s,a){this._charCodes=r,this._lineNumbers=s,this._columns=a}toString(){return"["+this._charCodes.map((r,s)=>(r===10?"\\n":String.fromCharCode(r))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(r,s){if(r<0||r>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(r){return r>0&&r===this._lineNumbers.length?this.getEndLineNumber(r-1):(this._assertIndex(r,this._lineNumbers),this._lineNumbers[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this._assertIndex(r,this._lineNumbers),this._charCodes[r]===10?this._lineNumbers[r]+1:this._lineNumbers[r])}getStartColumn(r){return r>0&&r===this._columns.length?this.getEndColumn(r-1):(this._assertIndex(r,this._columns),this._columns[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this._assertIndex(r,this._columns),this._charCodes[r]===10?1:this._columns[r]+1)}}class f{constructor(r,s,a,L,d,w,R,E){this.originalStartLineNumber=r,this.originalStartColumn=s,this.originalEndLineNumber=a,this.originalEndColumn=L,this.modifiedStartLineNumber=d,this.modifiedStartColumn=w,this.modifiedEndLineNumber=R,this.modifiedEndColumn=E}static createFromDiffChange(r,s,a){const L=s.getStartLineNumber(r.originalStart),d=s.getStartColumn(r.originalStart),w=s.getEndLineNumber(r.originalStart+r.originalLength-1),R=s.getEndColumn(r.originalStart+r.originalLength-1),E=a.getStartLineNumber(r.modifiedStart),M=a.getStartColumn(r.modifiedStart),F=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),B=a.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new f(L,d,w,R,E,M,F,B)}}function m(S){if(S.length<=1)return S;const r=[S[0]];let s=r[0];for(let a=1,L=S.length;a<L;a++){const d=S[a],w=d.originalStart-(s.originalStart+s.originalLength),R=d.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(w,R)<o?(s.originalLength=d.originalStart+d.originalLength-s.originalStart,s.modifiedLength=d.modifiedStart+d.modifiedLength-s.modifiedStart):(r.push(d),s=d)}return r}class c{constructor(r,s,a,L,d){this.originalStartLineNumber=r,this.originalEndLineNumber=s,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=L,this.charChanges=d}static createFromDiffResult(r,s,a,L,d,w,R){let E,M,F,B,I;if(s.originalLength===0?(E=a.getStartLineNumber(s.originalStart)-1,M=0):(E=a.getStartLineNumber(s.originalStart),M=a.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(F=L.getStartLineNumber(s.modifiedStart)-1,B=0):(F=L.getStartLineNumber(s.modifiedStart),B=L.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),w&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&d()){const U=a.createCharSequence(r,s.originalStart,s.originalStart+s.originalLength-1),k=L.createCharSequence(r,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(U.getElements().length>0&&k.getElements().length>0){let x=e(U,k,d,!0).changes;R&&(x=m(x)),I=[];for(let q=0,W=x.length;q<W;q++)I.push(f.createFromDiffChange(x[q],U,k))}}return new c(E,M,F,B,I)}}class N{constructor(r,s,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=r,this.modifiedLines=s,this.original=new b(r),this.modified=new b(s),this.continueLineDiff=p(a.maxComputationTime),this.continueCharDiff=p(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=r.changes,a=r.quitEarly;if(this.shouldIgnoreTrimWhitespace){const R=[];for(let E=0,M=s.length;E<M;E++)R.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:R}}const L=[];let d=0,w=0;for(let R=-1,E=s.length;R<E;R++){const M=R+1<E?s[R+1]:null,F=M?M.originalStart:this.originalLines.length,B=M?M.modifiedStart:this.modifiedLines.length;for(;d<F&&w<B;){const I=this.originalLines[d],U=this.modifiedLines[w];if(I!==U){{let k=C(I,1),x=C(U,1);for(;k>1&&x>1;){const q=I.charCodeAt(k-2),W=U.charCodeAt(x-2);if(q!==W)break;k--,x--}(k>1||x>1)&&this._pushTrimWhitespaceCharChange(L,d+1,1,k,w+1,1,x)}{let k=y(I,1),x=y(U,1);const q=I.length+1,W=U.length+1;for(;k<q&&x<W;){const z=I.charCodeAt(k-1),G=I.charCodeAt(x-1);if(z!==G)break;k++,x++}(k<q||x<W)&&this._pushTrimWhitespaceCharChange(L,d+1,k,q,w+1,x,W)}}d++,w++}M&&(L.push(c.createFromDiffResult(this.shouldIgnoreTrimWhitespace,M,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),d+=M.originalLength,w+=M.modifiedLength)}return{quitEarly:a,changes:L}}_pushTrimWhitespaceCharChange(r,s,a,L,d,w,R){if(this._mergeTrimWhitespaceCharChange(r,s,a,L,d,w,R))return;let E;this.shouldComputeCharChanges&&(E=[new f(s,a,s,L,d,w,d,R)]),r.push(new c(s,s,d,d,E))}_mergeTrimWhitespaceCharChange(r,s,a,L,d,w,R){const E=r.length;if(E===0)return!1;const M=r[E-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber===s&&M.modifiedEndLineNumber===d?(this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new f(s,a,s,L,d,w,d,R)),!0):M.originalEndLineNumber+1===s&&M.modifiedEndLineNumber+1===d?(M.originalEndLineNumber=s,M.modifiedEndLineNumber=d,this.shouldComputeCharChanges&&M.charChanges&&M.charChanges.push(new f(s,a,s,L,d,w,d,R)),!0):!1}}n.DiffComputer=N;function C(S,r){const s=h.firstNonWhitespaceIndex(S);return s===-1?r:s+1}function y(S,r){const s=h.lastNonWhitespaceIndex(S);return s===-1?r:s+2}function p(S){if(S===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<S}}),Y(X[49],J([0,1,48,47]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new A.LegacyLinesDiffComputer,getDefault:()=>new D.DefaultLinesDiffComputer}}),Y(X[50],J([0,1,34]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function D(b){const u=[];for(const f of b){const m=Number(f);(m||m===0&&f.replace(/\s/g,"")!=="")&&u.push(m)}return u}function i(b,u,f,m){return{red:b/255,blue:f/255,green:u/255,alpha:m}}function h(b,u){const f=u.index,m=u[0].length;if(!f)return;const c=b.positionAt(f);return{startLineNumber:c.lineNumber,startColumn:c.column,endLineNumber:c.lineNumber,endColumn:c.column+m}}function g(b,u){if(!b)return;const f=A.Color.Format.CSS.parseHex(u);if(f)return{range:b,color:i(f.rgba.r,f.rgba.g,f.rgba.b,f.rgba.a)}}function _(b,u,f){if(!b||u.length!==1)return;const c=u[0].values(),N=D(c);return{range:b,color:i(N[0],N[1],N[2],f?N[3]:1)}}function l(b,u,f){if(!b||u.length!==1)return;const c=u[0].values(),N=D(c),C=new A.Color(new A.HSLA(N[0],N[1]/100,N[2]/100,f?N[3]:1));return{range:b,color:i(C.rgba.r,C.rgba.g,C.rgba.b,C.rgba.a)}}function o(b,u){return typeof b=="string"?[...b.matchAll(u)]:b.findMatches(u)}function v(b){const u=[],m=o(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const c of m){const N=c.filter(S=>S!==void 0),C=N[1],y=N[2];if(!y)continue;let p;if(C==="rgb"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;p=_(h(b,c),o(y,S),!1)}else if(C==="rgba"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=_(h(b,c),o(y,S),!0)}else if(C==="hsl"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;p=l(h(b,c),o(y,S),!1)}else if(C==="hsla"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;p=l(h(b,c),o(y,S),!0)}else C==="#"&&(p=g(h(b,c),C+y));p&&u.push(p)}return u}function e(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:v(b)}n.computeDefaultDocumentColors=e}),Y(X[51],J([0,1,27]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class D{constructor(b,u,f){const m=new Uint8Array(b*u);for(let c=0,N=b*u;c<N;c++)m[c]=f;this._data=m,this.rows=b,this.cols=u}get(b,u){return this._data[b*this.cols+u]}set(b,u,f){this._data[b*this.cols+u]=f}}class i{constructor(b){let u=0,f=0;for(let c=0,N=b.length;c<N;c++){const[C,y,p]=b[c];y>u&&(u=y),C>f&&(f=C),p>f&&(f=p)}u++,f++;const m=new D(f,u,0);for(let c=0,N=b.length;c<N;c++){const[C,y,p]=b[c];m.set(C,y,p)}this._states=m,this._maxCharCode=u}nextState(b,u){return u<0||u>=this._maxCharCode?0:this._states.get(b,u)}}n.StateMachine=i;let h=null;function g(){return h===null&&(h=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),h}let _=null;function l(){if(_===null){_=new A.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<e.length;u++)_.set(e.charCodeAt(u),1);const b=".,;:";for(let u=0;u<b.length;u++)_.set(b.charCodeAt(u),2)}return _}class o{static _createLink(b,u,f,m,c){let N=c-1;do{const C=u.charCodeAt(N);if(b.get(C)!==2)break;N--}while(N>m);if(m>0){const C=u.charCodeAt(m-1),y=u.charCodeAt(N);(C===40&&y===41||C===91&&y===93||C===123&&y===125)&&N--}return{range:{startLineNumber:f,startColumn:m+1,endLineNumber:f,endColumn:N+2},url:u.substring(m,N+1)}}static computeLinks(b,u=g()){const f=l(),m=[];for(let c=1,N=b.getLineCount();c<=N;c++){const C=b.getLineContent(c),y=C.length;let p=0,S=0,r=0,s=1,a=!1,L=!1,d=!1,w=!1;for(;p<y;){let R=!1;const E=C.charCodeAt(p);if(s===13){let M;switch(E){case 40:a=!0,M=0;break;case 41:M=a?0:1;break;case 91:d=!0,L=!0,M=0;break;case 93:d=!1,M=L?0:1;break;case 123:w=!0,M=0;break;case 125:M=w?0:1;break;case 39:case 34:case 96:r===E?M=1:r===39||r===34||r===96?M=0:M=1;break;case 42:M=r===42?1:0;break;case 124:M=r===124?1:0;break;case 32:M=d?0:1;break;default:M=f.get(E)}M===1&&(m.push(o._createLink(f,C,c,S,p)),R=!0)}else if(s===12){let M;E===91?(L=!0,M=0):M=f.get(E),M===1?R=!0:s=13}else s=u.nextState(s,E),s===0&&(R=!0);R&&(s=1,a=!1,L=!1,w=!1,S=p+1,r=E),p++}s===13&&m.push(o._createLink(f,C,c,S,y))}return m}}n.LinkComputer=o;function v(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:o.computeLinks(e)}n.computeLinks=v}),Y(X[52],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class A{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,h,g,_,l){if(i&&h){const o=this.doNavigateValueSet(h,l);if(o)return{range:i,value:o}}if(g&&_){const o=this.doNavigateValueSet(_,l);if(o)return{range:g,value:o}}return null}doNavigateValueSet(i,h){const g=this.numberReplace(i,h);return g!==null?g:this.textReplace(i,h)}numberReplace(i,h){const g=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let _=Number(i);const l=parseFloat(i);return!isNaN(_)&&!isNaN(l)&&_===l?_===0&&!h?null:(_=Math.floor(_*g),_+=h?g:-g,String(_/g)):null}textReplace(i,h){return this.valueSetsReplace(this._defaultValueSet,i,h)}valueSetsReplace(i,h,g){let _=null;for(let l=0,o=i.length;_===null&&l<o;l++)_=this.valueSetReplace(i[l],h,g);return _}valueSetReplace(i,h,g){let _=i.indexOf(h);return _>=0?(_+=g?1:-1,_<0?_=i.length-1:_%=i.length,i[_]):null}}n.BasicInplaceReplace=A,A.INSTANCE=new A}),Y(X[53],J([0,1,14]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var D;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(D||(n.OverviewRulerLane=D={}));var i;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var h;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(h||(n.MinimapPosition=h={}));var g;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(g||(n.InjectedTextCursorStops=g={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,m.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this._indentSizeIsTabSize===m._indentSizeIsTabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}n.TextModelResolvedOptions=_;class l{constructor(m,c){this._findMatchBrand=void 0,this.range=m,this.matches=c}}n.FindMatch=l;function o(f){return f&&typeof f.read=="function"}n.isITextSnapshot=o;class v{constructor(m,c,N,C,y,p){this.identifier=m,this.range=c,this.text=N,this.forceMoveMarkers=C,this.isAutoWhitespaceEdit=y,this._isTracked=p}}n.ValidAnnotatedEditOperation=v;class e{constructor(m,c,N){this.regex=m,this.wordSeparators=c,this.simpleSearch=N}}n.SearchData=e;class b{constructor(m,c,N){this.reverseEdits=m,this.changes=c,this.trimAutoWhitespaceLineNumbers=N}}n.ApplyEditsResult=b;function u(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}n.shouldSynchronizeModel=u}),Y(X[54],J([0,1,8,26]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,o){l=(0,D.toUint32)(l);const v=this.values,e=this.prefixSum,b=o.length;return b===0?!1:(this.values=new Uint32Array(v.length+b),this.values.set(v.subarray(0,l),0),this.values.set(v.subarray(l),l+b),this.values.set(o,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,o){return l=(0,D.toUint32)(l),o=(0,D.toUint32)(o),this.values[l]===o?!1:(this.values[l]=o,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,o){l=(0,D.toUint32)(l),o=(0,D.toUint32)(o);const v=this.values,e=this.prefixSum;if(l>=v.length)return!1;const b=v.length-l;return o>=b&&(o=b),o===0?!1:(this.values=new Uint32Array(v.length-o),this.values.set(v.subarray(0,l),0),this.values.set(v.subarray(l+o),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,D.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let o=this.prefixSumValidIndex[0]+1;o===0&&(this.prefixSum[0]=this.values[0],o++),l>=this.values.length&&(l=this.values.length-1);for(let v=o;v<=l;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let o=0,v=this.values.length-1,e=0,b=0,u=0;for(;o<=v;)if(e=o+(v-o)/2|0,b=this.prefixSum[e],u=b-this.values[e],l<u)v=e-1;else if(l>=b)o=e+1;else break;return new g(e,l-u)}}n.PrefixSumComputer=i;class h{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const o=this._indexBySum[l],v=o>0?this._prefixSum[o-1]:0;return new g(o,l-v)}removeValues(l,o){this._values.splice(l,o),this._invalidate(l)}insertValues(l,o){this._values=(0,A.arrayInsert)(this._values,l,o),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,o=this._values.length;l<o;l++){const v=this._values[l],e=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=e+v;for(let b=0;b<v;b++)this._indexBySum[e+b]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,o){this._values[l]!==o&&(this._values[l]=o,this._invalidate(l))}}n.ConstantTimePrefixSumComputer=h;class g{constructor(l,o){this.index=l,this.remainder=o,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=o}}n.PrefixSumIndexOfResult=g}),Y(X[55],J([0,1,6,4,54]),function(T,n,A,D,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class h{constructor(_,l,o,v){this._uri=_,this._lines=l,this._eol=o,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const l=_.changes;for(const o of l)this._acceptDeleteRange(o.range),this._acceptInsertText(new D.Position(o.range.startLineNumber,o.range.startColumn),o.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,l=this._lines.length,o=new Uint32Array(l);for(let v=0;v<l;v++)o[v]=this._lines[v].length+_;this._lineStarts=new i.PrefixSumComputer(o)}}_setLineText(_,l){this._lines[_]=l,this._lineStarts&&this._lineStarts.setValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,l){if(l.length===0)return;const o=(0,A.splitLines)(l);if(o.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+o[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}o[o.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+o[0]);const v=new Uint32Array(o.length-1);for(let e=1;e<o.length;e++)this._lines.splice(_.lineNumber+e-1,0,o[e]),v[e-1]=o[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,v)}}n.MirrorTextModel=h}),Y(X[56],J([0,1,6,42,4,2,53]),function(T,n,A,D,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const _=999;class l{constructor(C,y,p,S){this.searchString=C,this.isRegex=y,this.matchCase=p,this.wordSeparators=S}parseSearchRequest(){if(this.searchString==="")return null;let C;this.isRegex?C=o(this.searchString):C=this.searchString.indexOf(`
`)>=0;let y=null;try{y=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:C,global:!0,unicode:!0})}catch{return null}if(!y)return null;let p=!this.isRegex&&!C;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new g.SearchData(y,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}n.SearchParams=l;function o(N){if(!N||N.length===0)return!1;for(let C=0,y=N.length;C<y;C++){const p=N.charCodeAt(C);if(p===10)return!0;if(p===92){if(C++,C>=y)break;const S=N.charCodeAt(C);if(S===110||S===114||S===87)return!0}}return!1}n.isMultilineRegexSource=o;function v(N,C,y){if(!y)return new g.FindMatch(N,null);const p=[];for(let S=0,r=C.length;S<r;S++)p[S]=C[S];return new g.FindMatch(N,p)}n.createFindMatch=v;class e{constructor(C){const y=[];let p=0;for(let S=0,r=C.length;S<r;S++)C.charCodeAt(S)===10&&(y[p++]=S);this._lineFeedsOffsets=y}findLineFeedCountBeforeOffset(C){const y=this._lineFeedsOffsets;let p=0,S=y.length-1;if(S===-1||C<=y[0])return 0;for(;p<S;){const r=p+((S-p)/2>>0);y[r]>=C?S=r-1:y[r+1]>=C?(p=r,S=r):p=r+1}return p+1}}class b{static findMatches(C,y,p,S,r){const s=y.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(C,p,new c(s.wordSeparators,s.regex),S,r):this._doFindMatchesLineByLine(C,p,s,S,r):[]}static _getMultilineMatchRange(C,y,p,S,r,s){let a,L=0;S?(L=S.findLineFeedCountBeforeOffset(r),a=y+r+L):a=y+r;let d;if(S){const M=S.findLineFeedCountBeforeOffset(r+s.length)-L;d=a+s.length+M}else d=a+s.length;const w=C.getPositionAt(a),R=C.getPositionAt(d);return new h.Range(w.lineNumber,w.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(C,y,p,S,r){const s=C.getOffsetAt(y.getStartPosition()),a=C.getValueInRange(y,1),L=C.getEOL()===`\r
`?new e(a):null,d=[];let w=0,R;for(p.reset(0);R=p.next(a);)if(d[w++]=v(this._getMultilineMatchRange(C,s,a,L,R.index,R[0]),R,S),w>=r)return d;return d}static _doFindMatchesLineByLine(C,y,p,S,r){const s=[];let a=0;if(y.startLineNumber===y.endLineNumber){const d=C.getLineContent(y.startLineNumber).substring(y.startColumn-1,y.endColumn-1);return a=this._findMatchesInLine(p,d,y.startLineNumber,y.startColumn-1,a,s,S,r),s}const L=C.getLineContent(y.startLineNumber).substring(y.startColumn-1);a=this._findMatchesInLine(p,L,y.startLineNumber,y.startColumn-1,a,s,S,r);for(let d=y.startLineNumber+1;d<y.endLineNumber&&a<r;d++)a=this._findMatchesInLine(p,C.getLineContent(d),d,0,a,s,S,r);if(a<r){const d=C.getLineContent(y.endLineNumber).substring(0,y.endColumn-1);a=this._findMatchesInLine(p,d,y.endLineNumber,0,a,s,S,r)}return s}static _findMatchesInLine(C,y,p,S,r,s,a,L){const d=C.wordSeparators;if(!a&&C.simpleSearch){const E=C.simpleSearch,M=E.length,F=y.length;let B=-M;for(;(B=y.indexOf(E,B+M))!==-1;)if((!d||m(d,y,F,B,M))&&(s[r++]=new g.FindMatch(new h.Range(p,B+1+S,p,B+1+M+S),null),r>=L))return r;return r}const w=new c(C.wordSeparators,C.regex);let R;w.reset(0);do if(R=w.next(y),R&&(s[r++]=v(new h.Range(p,R.index+1+S,p,R.index+1+R[0].length+S),R,a),r>=L))return r;while(R);return r}static findNextMatch(C,y,p,S){const r=y.parseSearchRequest();if(!r)return null;const s=new c(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(C,p,s,S):this._doFindNextMatchLineByLine(C,p,s,S)}static _doFindNextMatchMultiline(C,y,p,S){const r=new i.Position(y.lineNumber,1),s=C.getOffsetAt(r),a=C.getLineCount(),L=C.getValueInRange(new h.Range(r.lineNumber,r.column,a,C.getLineMaxColumn(a)),1),d=C.getEOL()===`\r
`?new e(L):null;p.reset(y.column-1);const w=p.next(L);return w?v(this._getMultilineMatchRange(C,s,L,d,w.index,w[0]),w,S):y.lineNumber!==1||y.column!==1?this._doFindNextMatchMultiline(C,new i.Position(1,1),p,S):null}static _doFindNextMatchLineByLine(C,y,p,S){const r=C.getLineCount(),s=y.lineNumber,a=C.getLineContent(s),L=this._findFirstMatchInLine(p,a,s,y.column,S);if(L)return L;for(let d=1;d<=r;d++){const w=(s+d-1)%r,R=C.getLineContent(w+1),E=this._findFirstMatchInLine(p,R,w+1,1,S);if(E)return E}return null}static _findFirstMatchInLine(C,y,p,S,r){C.reset(S-1);const s=C.next(y);return s?v(new h.Range(p,s.index+1,p,s.index+1+s[0].length),s,r):null}static findPreviousMatch(C,y,p,S){const r=y.parseSearchRequest();if(!r)return null;const s=new c(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(C,p,s,S):this._doFindPreviousMatchLineByLine(C,p,s,S)}static _doFindPreviousMatchMultiline(C,y,p,S){const r=this._doFindMatchesMultiline(C,new h.Range(1,1,y.lineNumber,y.column),p,S,10*_);if(r.length>0)return r[r.length-1];const s=C.getLineCount();return y.lineNumber!==s||y.column!==C.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(C,new i.Position(s,C.getLineMaxColumn(s)),p,S):null}static _doFindPreviousMatchLineByLine(C,y,p,S){const r=C.getLineCount(),s=y.lineNumber,a=C.getLineContent(s).substring(0,y.column-1),L=this._findLastMatchInLine(p,a,s,S);if(L)return L;for(let d=1;d<=r;d++){const w=(r+s-d-1)%r,R=C.getLineContent(w+1),E=this._findLastMatchInLine(p,R,w+1,S);if(E)return E}return null}static _findLastMatchInLine(C,y,p,S){let r=null,s;for(C.reset(0);s=C.next(y);)r=v(new h.Range(p,s.index+1,p,s.index+1+s[0].length),s,S);return r}}n.TextModelSearch=b;function u(N,C,y,p,S){if(p===0)return!0;const r=C.charCodeAt(p-1);if(N.get(r)!==0||r===13||r===10)return!0;if(S>0){const s=C.charCodeAt(p);if(N.get(s)!==0)return!0}return!1}function f(N,C,y,p,S){if(p+S===y)return!0;const r=C.charCodeAt(p+S);if(N.get(r)!==0||r===13||r===10)return!0;if(S>0){const s=C.charCodeAt(p+S-1);if(N.get(s)!==0)return!0}return!1}function m(N,C,y,p,S){return u(N,C,y,p,S)&&f(N,C,y,p,S)}n.isValidMatch=m;class c{constructor(C,y){this._wordSeparators=C,this._searchRegex=y,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(C){this._searchRegex.lastIndex=C,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(C){const y=C.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===y||(p=this._searchRegex.exec(C),!p))return null;const S=p.index,r=p[0].length;if(S===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){A.getNextCodePoint(C,y,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=S,this._prevMatchLength=r,!this._wordSeparators||m(this._wordSeparators,C,y,S,r))return p}while(p);return null}}n.Searcher=c}),Y(X[57],J([0,1,2,56,6,12,28]),function(T,n,A,D,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class _{static computeUnicodeHighlights(b,u,f){const m=f?f.startLineNumber:1,c=f?f.endLineNumber:b.getLineCount(),N=new o(u),C=N.getCandidateCodePoints();let y;C==="allNonBasicAscii"?y=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):y=new RegExp(`${l(Array.from(C))}`,"g");const p=new D.Searcher(null,y),S=[];let r=!1,s,a=0,L=0,d=0;e:for(let w=m,R=c;w<=R;w++){const E=b.getLineContent(w),M=E.length;p.reset(0);do if(s=p.next(E),s){let F=s.index,B=s.index+s[0].length;if(F>0){const x=E.charCodeAt(F-1);i.isHighSurrogate(x)&&F--}if(B+1<M){const x=E.charCodeAt(B-1);i.isHighSurrogate(x)&&B++}const I=E.substring(F,B);let U=(0,g.getWordAtText)(F+1,g.DEFAULT_WORD_REGEXP,E,0);U&&U.endColumn<=F+1&&(U=null);const k=N.shouldHighlightNonBasicASCII(I,U?U.word:null);if(k!==0){k===3?a++:k===2?L++:k===1?d++:(0,h.assertNever)(k);const x=1e3;if(S.length>=x){r=!0;break e}S.push(new A.Range(w,F+1,w,B+1))}}while(s)}return{ranges:S,hasMore:r,ambiguousCharacterCount:a,invisibleCharacterCount:L,nonBasicAsciiCharacterCount:d}}static computeUnicodeHighlightReason(b,u){const f=new o(u);switch(f.shouldHighlightNonBasicASCII(b,null)){case 0:return null;case 2:return{kind:1};case 3:{const c=b.codePointAt(0),N=f.ambiguousCharacters.getPrimaryConfusable(c),C=i.AmbiguousCharacters.getLocales().filter(y=>!i.AmbiguousCharacters.getInstance(new Set([...u.allowedLocales,y])).isAmbiguous(c));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:C}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=_;function l(e,b){return`[${i.escapeRegExpCharacters(e.map(f=>String.fromCodePoint(f)).join(""))}]`}class o{constructor(b){this.options=b,this.allowedCodePoints=new Set(b.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(b.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const b=new Set;if(this.options.invisibleCharacters)for(const u of i.InvisibleCharacters.codePoints)v(String.fromCodePoint(u))||b.add(u);if(this.options.ambiguousCharacters)for(const u of this.ambiguousCharacters.getConfusableCodePoints())b.add(u);for(const u of this.allowedCodePoints)b.delete(u);return b}shouldHighlightNonBasicASCII(b,u){const f=b.codePointAt(0);if(this.allowedCodePoints.has(f))return 0;if(this.options.nonBasicASCII)return 1;let m=!1,c=!1;if(u)for(const N of u){const C=N.codePointAt(0),y=i.isBasicASCII(N);m=m||y,!y&&!this.ambiguousCharacters.isAmbiguous(C)&&!i.InvisibleCharacters.isInvisibleCharacter(C)&&(c=!0)}return!m&&c?0:this.options.invisibleCharacters&&!v(b)&&i.InvisibleCharacters.isInvisibleCharacter(f)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(f)?3:0}}function v(e){return e===" "||e===`
`||e==="	"}}),Y(X[58],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var A;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(A||(n.AccessibilitySupport=A={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(D||(n.CodeActionTriggerType=D={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var h;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(h||(n.CompletionItemKind=h={}));var g;(function(t){t[t.Deprecated=1]="Deprecated"})(g||(n.CompletionItemTag=g={}));var _;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(n.CompletionTriggerKind=_={}));var l;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(l||(n.ContentWidgetPositionPreference=l={}));var o;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(o||(n.CursorChangeReason=o={}));var v;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(n.DefaultEndOfLine=v={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var b;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(b||(n.EditorAutoIndentStrategy=b={}));var u;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.letterSpacing=63]="letterSpacing",t[t.lightbulb=64]="lightbulb",t[t.lineDecorationsWidth=65]="lineDecorationsWidth",t[t.lineHeight=66]="lineHeight",t[t.lineNumbers=67]="lineNumbers",t[t.lineNumbersMinChars=68]="lineNumbersMinChars",t[t.linkedEditing=69]="linkedEditing",t[t.links=70]="links",t[t.matchBrackets=71]="matchBrackets",t[t.minimap=72]="minimap",t[t.mouseStyle=73]="mouseStyle",t[t.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=75]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",t[t.multiCursorModifier=77]="multiCursorModifier",t[t.multiCursorPaste=78]="multiCursorPaste",t[t.multiCursorLimit=79]="multiCursorLimit",t[t.occurrencesHighlight=80]="occurrencesHighlight",t[t.overviewRulerBorder=81]="overviewRulerBorder",t[t.overviewRulerLanes=82]="overviewRulerLanes",t[t.padding=83]="padding",t[t.pasteAs=84]="pasteAs",t[t.parameterHints=85]="parameterHints",t[t.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",t[t.quickSuggestions=88]="quickSuggestions",t[t.quickSuggestionsDelay=89]="quickSuggestionsDelay",t[t.readOnly=90]="readOnly",t[t.readOnlyMessage=91]="readOnlyMessage",t[t.renameOnType=92]="renameOnType",t[t.renderControlCharacters=93]="renderControlCharacters",t[t.renderFinalNewline=94]="renderFinalNewline",t[t.renderLineHighlight=95]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=97]="renderValidationDecorations",t[t.renderWhitespace=98]="renderWhitespace",t[t.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",t[t.roundedSelection=100]="roundedSelection",t[t.rulers=101]="rulers",t[t.scrollbar=102]="scrollbar",t[t.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=104]="scrollBeyondLastLine",t[t.scrollPredominantAxis=105]="scrollPredominantAxis",t[t.selectionClipboard=106]="selectionClipboard",t[t.selectionHighlight=107]="selectionHighlight",t[t.selectOnLineNumbers=108]="selectOnLineNumbers",t[t.showFoldingControls=109]="showFoldingControls",t[t.showUnused=110]="showUnused",t[t.snippetSuggestions=111]="snippetSuggestions",t[t.smartSelect=112]="smartSelect",t[t.smoothScrolling=113]="smoothScrolling",t[t.stickyScroll=114]="stickyScroll",t[t.stickyTabStops=115]="stickyTabStops",t[t.stopRenderingLineAfter=116]="stopRenderingLineAfter",t[t.suggest=117]="suggest",t[t.suggestFontSize=118]="suggestFontSize",t[t.suggestLineHeight=119]="suggestLineHeight",t[t.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",t[t.suggestSelection=121]="suggestSelection",t[t.tabCompletion=122]="tabCompletion",t[t.tabIndex=123]="tabIndex",t[t.unicodeHighlighting=124]="unicodeHighlighting",t[t.unusualLineTerminators=125]="unusualLineTerminators",t[t.useShadowDOM=126]="useShadowDOM",t[t.useTabStops=127]="useTabStops",t[t.wordBreak=128]="wordBreak",t[t.wordSeparators=129]="wordSeparators",t[t.wordWrap=130]="wordWrap",t[t.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=133]="wordWrapColumn",t[t.wordWrapOverride1=134]="wordWrapOverride1",t[t.wordWrapOverride2=135]="wordWrapOverride2",t[t.wrappingIndent=136]="wrappingIndent",t[t.wrappingStrategy=137]="wrappingStrategy",t[t.showDeprecated=138]="showDeprecated",t[t.inlayHints=139]="inlayHints",t[t.editorClassName=140]="editorClassName",t[t.pixelRatio=141]="pixelRatio",t[t.tabFocusMode=142]="tabFocusMode",t[t.layoutInfo=143]="layoutInfo",t[t.wrappingInfo=144]="wrappingInfo",t[t.defaultColorDecorators=145]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(u||(n.EditorOption=u={}));var f;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(f||(n.EndOfLinePreference=f={}));var m;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(m||(n.EndOfLineSequence=m={}));var c;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(c||(n.GlyphMarginLane=c={}));var N;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(N||(n.IndentAction=N={}));var C;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(C||(n.InjectedTextCursorStops=C={}));var y;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(y||(n.InlayHintKind=y={}));var p;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(p||(n.InlineCompletionTriggerKind=p={}));var S;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(S||(n.KeyCode=S={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s||(n.MarkerTag=s={}));var a;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(a||(n.MinimapPosition=a={}));var L;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(L||(n.MouseTargetType=L={}));var d;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(d||(n.OverlayWidgetPositionPreference=d={}));var w;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(w||(n.OverviewRulerLane=w={}));var R;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(R||(n.PositionAffinity=R={}));var E;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(E||(n.RenderLineNumbersType=E={}));var M;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(M||(n.RenderMinimap=M={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var B;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(B||(n.ScrollbarVisibility=B={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I||(n.SelectionDirection=I={}));var U;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(U||(n.SignatureHelpTriggerKind=U={}));var k;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(k||(n.SymbolKind=k={}));var x;(function(t){t[t.Deprecated=1]="Deprecated"})(x||(n.SymbolTag=x={}));var q;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(q||(n.TextEditorCursorBlinkingStyle=q={}));var W;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(W||(n.TextEditorCursorStyle=W={}));var z;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(z||(n.TrackedRangeStickiness=z={}));var G;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(G||(n.WrappingIndent=G={}))}),Y(X[59],J([0,1,9,13]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,l){return this._tokenizationSupports.set(_,l),this.handleChange([_]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(_)===l&&(this._tokenizationSupports.delete(_),this.handleChange([_]))})}get(_){return this._tokenizationSupports.get(_)||null}registerFactory(_,l){var o;(o=this._factories.get(_))===null||o===void 0||o.dispose();const v=new h(this,_,l);return this._factories.set(_,v),(0,D.toDisposable)(()=>{const e=this._factories.get(_);!e||e!==v||(this._factories.delete(_),e.dispose())})}getOrCreate(_){return le(this,void 0,void 0,function*(){const l=this.get(_);if(l)return l;const o=this._factories.get(_);return!o||o.isResolved?null:(yield o.resolve(),this.get(_))})}isResolved(_){if(this.get(_))return!0;const o=this._factories.get(_);return!!(!o||o.isResolved)}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class h extends D.Disposable{get isResolved(){return this._isResolved}constructor(_,l,o){super(),this._registry=_,this._languageId=l,this._factory=o,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return le(this,void 0,void 0,function*(){const _=yield this._factory.tokenizationSupport;this._isResolved=!0,_&&!this._isDisposed&&this._register(this._registry.register(this._languageId,_))})}}}),Y(X[60],J([19,61]),function(T,n){return T.create("vs/base/common/platform",n)}),Y(X[17],J([0,1,60]),function(T,n,A){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,h=!1,g=!1,_=!1,l=!1,o=!1,v=!1,e=!1,b=!1,u=!1,f,m=n.LANGUAGE_DEFAULT,c=n.LANGUAGE_DEFAULT,N,C;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?y=n.globals.vscode.process:typeof process<"u"&&(y=process);const p=typeof((D=y?.versions)===null||D===void 0?void 0:D.electron)=="string",S=p&&y?.type==="renderer";if(typeof navigator=="object"&&!S)C=navigator.userAgent,i=C.indexOf("Windows")>=0,h=C.indexOf("Macintosh")>=0,e=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,g=C.indexOf("Linux")>=0,u=C?.indexOf("Mobi")>=0,o=!0,f=A.getConfiguredDefaultLocale(A.localize(0,null))||n.LANGUAGE_DEFAULT,m=f,c=navigator.language;else if(typeof y=="object"){i=y.platform==="win32",h=y.platform==="darwin",g=y.platform==="linux",_=g&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,v=p,b=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=n.LANGUAGE_DEFAULT,m=n.LANGUAGE_DEFAULT;const d=y.env.VSCODE_NLS_CONFIG;if(d)try{const w=JSON.parse(d),R=w.availableLanguages["*"];f=w.locale,c=w.osLocale,m=R||n.LANGUAGE_DEFAULT,N=w._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");let r=0;h?r=1:i?r=3:g&&(r=2),n.isWindows=i,n.isMacintosh=h,n.isLinux=g,n.isNative=l,n.isWeb=o,n.isWebWorker=o&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=u,n.userAgent=C,n.language=m,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const d=[];n.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let E=0,M=d.length;E<M;E++){const F=d[E];if(F.id===R.data.vscodeScheduleAsyncWork){d.splice(E,1),F.callback();return}}});let w=0;return R=>{const E=++w;d.push({id:E,callback:R}),n.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return d=>setTimeout(d)})(),n.OS=h||e?2:i?1:3;let s=!0,a=!1;function L(){if(!a){a=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,s=new Uint16Array(d.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=L,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[62],J([0,1,17]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let D;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const i=A.globals.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=D.cwd,n.env=D.env,n.platform=D.platform}),Y(X[63],J([0,1,62]),function(T,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const D=65,i=97,h=90,g=122,_=46,l=47,o=92,v=58,e=63;class b extends Error{constructor(s,a,L){let d;typeof a=="string"&&a.indexOf("not ")===0?(d="must not be",a=a.replace(/^not /,"")):d="must be";const w=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${w} ${d} of type ${a}`;R+=`. Received type ${typeof L}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function u(r,s){if(r===null||typeof r!="object")throw new b(s,"Object",r)}function f(r,s){if(typeof r!="string")throw new b(s,"string",r)}const m=A.platform==="win32";function c(r){return r===l||r===o}function N(r){return r===l}function C(r){return r>=D&&r<=h||r>=i&&r<=g}function y(r,s,a,L){let d="",w=0,R=-1,E=0,M=0;for(let F=0;F<=r.length;++F){if(F<r.length)M=r.charCodeAt(F);else{if(L(M))break;M=l}if(L(M)){if(!(R===F-1||E===1))if(E===2){if(d.length<2||w!==2||d.charCodeAt(d.length-1)!==_||d.charCodeAt(d.length-2)!==_){if(d.length>2){const B=d.lastIndexOf(a);B===-1?(d="",w=0):(d=d.slice(0,B),w=d.length-1-d.lastIndexOf(a)),R=F,E=0;continue}else if(d.length!==0){d="",w=0,R=F,E=0;continue}}s&&(d+=d.length>0?`${a}..`:"..",w=2)}else d.length>0?d+=`${a}${r.slice(R+1,F)}`:d=r.slice(R+1,F),w=F-R-1;R=F,E=0}else M===_&&E!==-1?++E:E=-1}return d}function p(r,s){u(s,"pathObject");const a=s.dir||s.root,L=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${L}`:`${a}${r}${L}`:L}n.win32={resolve(...r){let s="",a="",L=!1;for(let d=r.length-1;d>=-1;d--){let w;if(d>=0){if(w=r[d],f(w,"path"),w.length===0)continue}else s.length===0?w=A.cwd():(w=A.env[`=${s}`]||A.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==s.toLowerCase()&&w.charCodeAt(2)===o)&&(w=`${s}\\`));const R=w.length;let E=0,M="",F=!1;const B=w.charCodeAt(0);if(R===1)c(B)&&(E=1,F=!0);else if(c(B))if(F=!0,c(w.charCodeAt(1))){let I=2,U=I;for(;I<R&&!c(w.charCodeAt(I));)I++;if(I<R&&I!==U){const k=w.slice(U,I);for(U=I;I<R&&c(w.charCodeAt(I));)I++;if(I<R&&I!==U){for(U=I;I<R&&!c(w.charCodeAt(I));)I++;(I===R||I!==U)&&(M=`\\\\${k}\\${w.slice(U,I)}`,E=I)}}}else E=1;else C(B)&&w.charCodeAt(1)===v&&(M=w.slice(0,2),E=2,R>2&&c(w.charCodeAt(2))&&(F=!0,E=3));if(M.length>0)if(s.length>0){if(M.toLowerCase()!==s.toLowerCase())continue}else s=M;if(L){if(s.length>0)break}else if(a=`${w.slice(E)}\\${a}`,L=F,F&&s.length>0)break}return a=y(a,!L,"\\",c),L?`${s}\\${a}`:`${s}${a}`||"."},normalize(r){f(r,"path");const s=r.length;if(s===0)return".";let a=0,L,d=!1;const w=r.charCodeAt(0);if(s===1)return N(w)?"\\":r;if(c(w))if(d=!0,c(r.charCodeAt(1))){let E=2,M=E;for(;E<s&&!c(r.charCodeAt(E));)E++;if(E<s&&E!==M){const F=r.slice(M,E);for(M=E;E<s&&c(r.charCodeAt(E));)E++;if(E<s&&E!==M){for(M=E;E<s&&!c(r.charCodeAt(E));)E++;if(E===s)return`\\\\${F}\\${r.slice(M)}\\`;E!==M&&(L=`\\\\${F}\\${r.slice(M,E)}`,a=E)}}}else a=1;else C(w)&&r.charCodeAt(1)===v&&(L=r.slice(0,2),a=2,s>2&&c(r.charCodeAt(2))&&(d=!0,a=3));let R=a<s?y(r.slice(a),!d,"\\",c):"";return R.length===0&&!d&&(R="."),R.length>0&&c(r.charCodeAt(s-1))&&(R+="\\"),L===void 0?d?`\\${R}`:R:d?`${L}\\${R}`:`${L}${R}`},isAbsolute(r){f(r,"path");const s=r.length;if(s===0)return!1;const a=r.charCodeAt(0);return c(a)||s>2&&C(a)&&r.charCodeAt(1)===v&&c(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,a;for(let w=0;w<r.length;++w){const R=r[w];f(R,"path"),R.length>0&&(s===void 0?s=a=R:s+=`\\${R}`)}if(s===void 0)return".";let L=!0,d=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++d;const w=a.length;w>1&&c(a.charCodeAt(1))&&(++d,w>2&&(c(a.charCodeAt(2))?++d:L=!1))}if(L){for(;d<s.length&&c(s.charCodeAt(d));)d++;d>=2&&(s=`\\${s.slice(d)}`)}return n.win32.normalize(s)},relative(r,s){if(f(r,"from"),f(s,"to"),r===s)return"";const a=n.win32.resolve(r),L=n.win32.resolve(s);if(a===L||(r=a.toLowerCase(),s=L.toLowerCase(),r===s))return"";let d=0;for(;d<r.length&&r.charCodeAt(d)===o;)d++;let w=r.length;for(;w-1>d&&r.charCodeAt(w-1)===o;)w--;const R=w-d;let E=0;for(;E<s.length&&s.charCodeAt(E)===o;)E++;let M=s.length;for(;M-1>E&&s.charCodeAt(M-1)===o;)M--;const F=M-E,B=R<F?R:F;let I=-1,U=0;for(;U<B;U++){const x=r.charCodeAt(d+U);if(x!==s.charCodeAt(E+U))break;x===o&&(I=U)}if(U!==B){if(I===-1)return L}else{if(F>B){if(s.charCodeAt(E+U)===o)return L.slice(E+U+1);if(U===2)return L.slice(E+U)}R>B&&(r.charCodeAt(d+U)===o?I=U:U===2&&(I=3)),I===-1&&(I=0)}let k="";for(U=d+I+1;U<=w;++U)(U===w||r.charCodeAt(U)===o)&&(k+=k.length===0?"..":"\\..");return E+=I,k.length>0?`${k}${L.slice(E,M)}`:(L.charCodeAt(E)===o&&++E,L.slice(E,M))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=n.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===o){if(s.charCodeAt(1)===o){const a=s.charCodeAt(2);if(a!==e&&a!==_)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(C(s.charCodeAt(0))&&s.charCodeAt(1)===v&&s.charCodeAt(2)===o)return`\\\\?\\${s}`;return r},dirname(r){f(r,"path");const s=r.length;if(s===0)return".";let a=-1,L=0;const d=r.charCodeAt(0);if(s===1)return c(d)?r:".";if(c(d)){if(a=L=1,c(r.charCodeAt(1))){let E=2,M=E;for(;E<s&&!c(r.charCodeAt(E));)E++;if(E<s&&E!==M){for(M=E;E<s&&c(r.charCodeAt(E));)E++;if(E<s&&E!==M){for(M=E;E<s&&!c(r.charCodeAt(E));)E++;if(E===s)return r;E!==M&&(a=L=E+1)}}}}else C(d)&&r.charCodeAt(1)===v&&(a=s>2&&c(r.charCodeAt(2))?3:2,L=a);let w=-1,R=!0;for(let E=s-1;E>=L;--E)if(c(r.charCodeAt(E))){if(!R){w=E;break}}else R=!1;if(w===-1){if(a===-1)return".";w=a}return r.slice(0,w)},basename(r,s){s!==void 0&&f(s,"ext"),f(r,"path");let a=0,L=-1,d=!0,w;if(r.length>=2&&C(r.charCodeAt(0))&&r.charCodeAt(1)===v&&(a=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let R=s.length-1,E=-1;for(w=r.length-1;w>=a;--w){const M=r.charCodeAt(w);if(c(M)){if(!d){a=w+1;break}}else E===-1&&(d=!1,E=w+1),R>=0&&(M===s.charCodeAt(R)?--R===-1&&(L=w):(R=-1,L=E))}return a===L?L=E:L===-1&&(L=r.length),r.slice(a,L)}for(w=r.length-1;w>=a;--w)if(c(r.charCodeAt(w))){if(!d){a=w+1;break}}else L===-1&&(d=!1,L=w+1);return L===-1?"":r.slice(a,L)},extname(r){f(r,"path");let s=0,a=-1,L=0,d=-1,w=!0,R=0;r.length>=2&&r.charCodeAt(1)===v&&C(r.charCodeAt(0))&&(s=L=2);for(let E=r.length-1;E>=s;--E){const M=r.charCodeAt(E);if(c(M)){if(!w){L=E+1;break}continue}d===-1&&(w=!1,d=E+1),M===_?a===-1?a=E:R!==1&&(R=1):a!==-1&&(R=-1)}return a===-1||d===-1||R===0||R===1&&a===d-1&&a===L+1?"":r.slice(a,d)},format:p.bind(null,"\\"),parse(r){f(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const a=r.length;let L=0,d=r.charCodeAt(0);if(a===1)return c(d)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(c(d)){if(L=1,c(r.charCodeAt(1))){let I=2,U=I;for(;I<a&&!c(r.charCodeAt(I));)I++;if(I<a&&I!==U){for(U=I;I<a&&c(r.charCodeAt(I));)I++;if(I<a&&I!==U){for(U=I;I<a&&!c(r.charCodeAt(I));)I++;I===a?L=I:I!==U&&(L=I+1)}}}}else if(C(d)&&r.charCodeAt(1)===v){if(a<=2)return s.root=s.dir=r,s;if(L=2,c(r.charCodeAt(2))){if(a===3)return s.root=s.dir=r,s;L=3}}L>0&&(s.root=r.slice(0,L));let w=-1,R=L,E=-1,M=!0,F=r.length-1,B=0;for(;F>=L;--F){if(d=r.charCodeAt(F),c(d)){if(!M){R=F+1;break}continue}E===-1&&(M=!1,E=F+1),d===_?w===-1?w=F:B!==1&&(B=1):w!==-1&&(B=-1)}return E!==-1&&(w===-1||B===0||B===1&&w===E-1&&w===R+1?s.base=s.name=r.slice(R,E):(s.name=r.slice(R,w),s.base=r.slice(R,E),s.ext=r.slice(w,E))),R>0&&R!==L?s.dir=r.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(m){const r=/\\/g;return()=>{const s=A.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>A.cwd()})();n.posix={resolve(...r){let s="",a=!1;for(let L=r.length-1;L>=-1&&!a;L--){const d=L>=0?r[L]:S();f(d,"path"),d.length!==0&&(s=`${d}/${s}`,a=d.charCodeAt(0)===l)}return s=y(s,!a,"/",N),a?`/${s}`:s.length>0?s:"."},normalize(r){if(f(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l,a=r.charCodeAt(r.length-1)===l;return r=y(r,!s,"/",N),r.length===0?s?"/":a?"./":".":(a&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return f(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let s;for(let a=0;a<r.length;++a){const L=r[a];f(L,"path"),L.length>0&&(s===void 0?s=L:s+=`/${L}`)}return s===void 0?".":n.posix.normalize(s)},relative(r,s){if(f(r,"from"),f(s,"to"),r===s||(r=n.posix.resolve(r),s=n.posix.resolve(s),r===s))return"";const a=1,L=r.length,d=L-a,w=1,R=s.length-w,E=d<R?d:R;let M=-1,F=0;for(;F<E;F++){const I=r.charCodeAt(a+F);if(I!==s.charCodeAt(w+F))break;I===l&&(M=F)}if(F===E)if(R>E){if(s.charCodeAt(w+F)===l)return s.slice(w+F+1);if(F===0)return s.slice(w+F)}else d>E&&(r.charCodeAt(a+F)===l?M=F:F===0&&(M=0));let B="";for(F=a+M+1;F<=L;++F)(F===L||r.charCodeAt(F)===l)&&(B+=B.length===0?"..":"/..");return`${B}${s.slice(w+M)}`},toNamespacedPath(r){return r},dirname(r){if(f(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l;let a=-1,L=!0;for(let d=r.length-1;d>=1;--d)if(r.charCodeAt(d)===l){if(!L){a=d;break}}else L=!1;return a===-1?s?"/":".":s&&a===1?"//":r.slice(0,a)},basename(r,s){s!==void 0&&f(s,"ext"),f(r,"path");let a=0,L=-1,d=!0,w;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let R=s.length-1,E=-1;for(w=r.length-1;w>=0;--w){const M=r.charCodeAt(w);if(M===l){if(!d){a=w+1;break}}else E===-1&&(d=!1,E=w+1),R>=0&&(M===s.charCodeAt(R)?--R===-1&&(L=w):(R=-1,L=E))}return a===L?L=E:L===-1&&(L=r.length),r.slice(a,L)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===l){if(!d){a=w+1;break}}else L===-1&&(d=!1,L=w+1);return L===-1?"":r.slice(a,L)},extname(r){f(r,"path");let s=-1,a=0,L=-1,d=!0,w=0;for(let R=r.length-1;R>=0;--R){const E=r.charCodeAt(R);if(E===l){if(!d){a=R+1;break}continue}L===-1&&(d=!1,L=R+1),E===_?s===-1?s=R:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||L===-1||w===0||w===1&&s===L-1&&s===a+1?"":r.slice(s,L)},format:p.bind(null,"/"),parse(r){f(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const a=r.charCodeAt(0)===l;let L;a?(s.root="/",L=1):L=0;let d=-1,w=0,R=-1,E=!0,M=r.length-1,F=0;for(;M>=L;--M){const B=r.charCodeAt(M);if(B===l){if(!E){w=M+1;break}continue}R===-1&&(E=!1,R=M+1),B===_?d===-1?d=M:F!==1&&(F=1):d!==-1&&(F=-1)}if(R!==-1){const B=w===0&&a?1:w;d===-1||F===0||F===1&&d===R-1&&d===w+1?s.base=s.name=r.slice(B,R):(s.name=r.slice(B,d),s.base=r.slice(B,R),s.ext=r.slice(d,R))}return w>0?s.dir=r.slice(0,w-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=m?n.win32.normalize:n.posix.normalize,n.resolve=m?n.win32.resolve:n.posix.resolve,n.relative=m?n.win32.relative:n.posix.relative,n.dirname=m?n.win32.dirname:n.posix.dirname,n.basename=m?n.win32.basename:n.posix.basename,n.extname=m?n.win32.extname:n.posix.extname,n.sep=m?n.win32.sep:n.posix.sep}),Y(X[18],J([0,1,63,17]),function(T,n,A,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,h=/^\//,g=/^\/\//;function _(a,L){if(!a.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!i.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!h.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(g.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(a,L){return!a&&!L?"file":a}function o(a,L){switch(a){case"https":case"http":case"file":L?L[0]!==e&&(L=e+L):L=e;break}return L}const v="",e="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(L){return L instanceof u?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,d,w,R,E,M=!1){typeof L=="object"?(this.scheme=L.scheme||v,this.authority=L.authority||v,this.path=L.path||v,this.query=L.query||v,this.fragment=L.fragment||v):(this.scheme=l(L,M),this.authority=d||v,this.path=o(this.scheme,w||v),this.query=R||v,this.fragment=E||v,_(this,M))}get fsPath(){return y(this,!1)}with(L){if(!L)return this;let{scheme:d,authority:w,path:R,query:E,fragment:M}=L;return d===void 0?d=this.scheme:d===null&&(d=v),w===void 0?w=this.authority:w===null&&(w=v),R===void 0?R=this.path:R===null&&(R=v),E===void 0?E=this.query:E===null&&(E=v),M===void 0?M=this.fragment:M===null&&(M=v),d===this.scheme&&w===this.authority&&R===this.path&&E===this.query&&M===this.fragment?this:new m(d,w,R,E,M)}static parse(L,d=!1){const w=b.exec(L);return w?new m(w[2]||v,s(w[4]||v),s(w[5]||v),s(w[7]||v),s(w[9]||v),d):new m(v,v,v,v,v)}static file(L){let d=v;if(D.isWindows&&(L=L.replace(/\\/g,e)),L[0]===e&&L[1]===e){const w=L.indexOf(e,2);w===-1?(d=L.substring(2),L=e):(d=L.substring(2,w),L=L.substring(w)||e)}return new m("file",d,L,v,v)}static from(L,d){return new m(L.scheme,L.authority,L.path,L.query,L.fragment,d)}static joinPath(L,...d){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return D.isWindows&&L.scheme==="file"?w=u.file(A.win32.join(y(L,!0),...d)).path:w=A.posix.join(L.path,...d),L.with({path:w})}toString(L=!1){return p(this,L)}toJSON(){return this}static revive(L){var d,w;if(L){if(L instanceof u)return L;{const R=new m(L);return R._formatted=(d=L.external)!==null&&d!==void 0?d:null,R._fsPath=L._sep===f&&(w=L.fsPath)!==null&&w!==void 0?w:null,R}}else return L}}n.URI=u;const f=D.isWindows?1:void 0;class m extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(L=!1){return L?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=f),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function N(a,L,d){let w,R=-1;for(let E=0;E<a.length;E++){const M=a.charCodeAt(E);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||L&&M===47||d&&M===91||d&&M===93||d&&M===58)R!==-1&&(w+=encodeURIComponent(a.substring(R,E)),R=-1),w!==void 0&&(w+=a.charAt(E));else{w===void 0&&(w=a.substr(0,E));const F=c[M];F!==void 0?(R!==-1&&(w+=encodeURIComponent(a.substring(R,E)),R=-1),w+=F):R===-1&&(R=E)}}return R!==-1&&(w+=encodeURIComponent(a.substring(R))),w!==void 0?w:a}function C(a){let L;for(let d=0;d<a.length;d++){const w=a.charCodeAt(d);w===35||w===63?(L===void 0&&(L=a.substr(0,d)),L+=c[w]):L!==void 0&&(L+=a[d])}return L!==void 0?L:a}function y(a,L){let d;return a.authority&&a.path.length>1&&a.scheme==="file"?d=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?L?d=a.path.substr(1):d=a.path[1].toLowerCase()+a.path.substr(2):d=a.path,D.isWindows&&(d=d.replace(/\//g,"\\")),d}n.uriToFsPath=y;function p(a,L){const d=L?C:N;let w="",{scheme:R,authority:E,path:M,query:F,fragment:B}=a;if(R&&(w+=R,w+=":"),(E||R==="file")&&(w+=e,w+=e),E){let I=E.indexOf("@");if(I!==-1){const U=E.substr(0,I);E=E.substr(I+1),I=U.lastIndexOf(":"),I===-1?w+=d(U,!1,!1):(w+=d(U.substr(0,I),!1,!1),w+=":",w+=d(U.substr(I+1),!1,!0)),w+="@"}E=E.toLowerCase(),I=E.lastIndexOf(":"),I===-1?w+=d(E,!1,!0):(w+=d(E.substr(0,I),!1,!0),w+=E.substr(I))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const I=M.charCodeAt(1);I>=65&&I<=90&&(M=`/${String.fromCharCode(I+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const I=M.charCodeAt(0);I>=65&&I<=90&&(M=`${String.fromCharCode(I+32)}:${M.substr(2)}`)}w+=d(M,!0,!1)}return F&&(w+="?",w+=d(F,!1,!1)),B&&(w+="#",w+=L?B:N(B,!1,!1)),w}function S(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+S(a.substr(3)):a}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(r)?a.replace(r,L=>S(L)):a}}),Y(X[67],J([0,1,5,9,13,14,17,6]),function(T,n,A,D,i,h,g,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const l="$initialize";let o=!1;function v(s){g.isWeb&&(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}n.logOnceWebWorkerWarning=v;class e{constructor(a,L,d,w){this.vsWorker=a,this.req=L,this.method=d,this.args=w,this.type=0}}class b{constructor(a,L,d,w){this.vsWorker=a,this.seq=L,this.res=d,this.err=w,this.type=1}}class u{constructor(a,L,d,w){this.vsWorker=a,this.req=L,this.eventName=d,this.arg=w,this.type=2}}class f{constructor(a,L,d){this.vsWorker=a,this.req=L,this.event=d,this.type=3}}class m{constructor(a,L){this.vsWorker=a,this.req=L,this.type=4}}class c{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,L){const d=String(++this._lastSentReq);return new Promise((w,R)=>{this._pendingReplies[d]={resolve:w,reject:R},this._send(new e(this._workerId,d,a,L))})}listen(a,L){let d=null;const w=new D.Emitter({onWillAddFirstListener:()=>{d=String(++this._lastSentReq),this._pendingEmitters.set(d,w),this._send(new u(this._workerId,d,a,L))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(d),this._send(new m(this._workerId,d)),d=null}});return w.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const L=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let d=a.err;a.err.$isError&&(d=new Error,d.name=a.err.name,d.message=a.err.message,d.stack=a.err.stack),L.reject(d);return}L.resolve(a.res)}_handleRequestMessage(a){const L=a.req;this._handler.handleMessage(a.method,a.args).then(w=>{this._send(new b(this._workerId,L,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,A.transformErrorForSerialization)(w.detail)),this._send(new b(this._workerId,L,void 0,(0,A.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(a){const L=a.req,d=this._handler.handleEvent(a.eventName,a.arg)(w=>{this._send(new f(this._workerId,L,w))});this._pendingEvents.set(L,d)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const L=[];if(a.type===0)for(let d=0;d<a.args.length;d++)a.args[d]instanceof ArrayBuffer&&L.push(a.args[d]);else a.type===1&&a.res instanceof ArrayBuffer&&L.push(a.res);this._handler.sendMessage(a,L)}}class N extends i.Disposable{constructor(a,L,d){super();let w=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",I=>{this._protocol.handleMessage(I)},I=>{w?.(I)})),this._protocol=new c({sendMessage:(I,U)=>{this._worker.postMessage(I,U)},handleMessage:(I,U)=>{if(typeof d[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(d[I].apply(d,U))}catch(k){return Promise.reject(k)}},handleEvent:(I,U)=>{if(y(I)){const k=d[I].call(d,U);if(typeof k!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return k}if(C(I)){const k=d[I];if(typeof k!="function")throw new Error(`Missing event ${I} on main thread host.`);return k}throw new Error(`Malformed event name ${I}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const E=globalThis.require;typeof E<"u"&&typeof E.getConfig=="function"?R=E.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const M=(0,h.getAllMethodNames)(d);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(R)),L,M]);const F=(I,U)=>this._request(I,U),B=(I,U)=>this._protocol.listen(I,U);this._lazyProxy=new Promise((I,U)=>{w=U,this._onModuleLoaded.then(k=>{I(p(k,F,B))},k=>{U(k),this._onError("Worker failed to load "+L,k)})})}getProxyObject(){return this._lazyProxy}_request(a,L){return new Promise((d,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,L).then(d,w)},w)})}_onError(a,L){console.error(a),console.info(L)}}n.SimpleWorkerClient=N;function C(s){return s[0]==="o"&&s[1]==="n"&&_.isUpperAsciiLetter(s.charCodeAt(2))}function y(s){return/^onDynamic/.test(s)&&_.isUpperAsciiLetter(s.charCodeAt(9))}function p(s,a,L){const d=E=>function(){const M=Array.prototype.slice.call(arguments,0);return a(E,M)},w=E=>function(M){return L(E,M)},R={};for(const E of s){if(y(E)){R[E]=w(E);continue}if(C(E)){R[E]=L(E,void 0);continue}R[E]=d(E)}return R}class S{constructor(a,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new c({sendMessage:(d,w)=>{a(d,w)},handleMessage:(d,w)=>this._handleMessage(d,w),handleEvent:(d,w)=>this._handleEvent(d,w)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,L){if(a===l)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,L))}catch(d){return Promise.reject(d)}}_handleEvent(a,L){if(!this._requestHandler)throw new Error("Missing requestHandler");if(y(a)){const d=this._requestHandler[a].call(this._requestHandler,L);if(typeof d!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return d}if(C(a)){const d=this._requestHandler[a];if(typeof d!="function")throw new Error(`Missing event ${a} on request handler.`);return d}throw new Error(`Malformed event name ${a}`)}initialize(a,L,d,w){this._protocol.setWorkerId(a);const M=p(w,(F,B)=>this._protocol.sendMessage(F,B),(F,B)=>this._protocol.listen(F,B));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(M),Promise.resolve((0,h.getAllMethodNames)(this._requestHandler))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((F,B)=>{(globalThis.require||T)([d],U=>{if(this._requestHandler=U.create(M),!this._requestHandler){B(new Error("No RequestHandler!"));return}F((0,h.getAllMethodNames)(this._requestHandler))},B)}))}}n.SimpleWorkerServer=S;function r(s){return new S(s,null)}n.create=r}),Y(X[64],J([19,61]),function(T,n){return T.create("vs/editor/common/languages",n)}),Y(X[65],J([0,1,40,18,2,59,64]),function(T,n,A,D,i,h,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class _{constructor(a,L,d){this.offset=a,this.type=L,this.language=d,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=_;class l{constructor(a,L){this.tokens=a,this.endState=L,this._tokenizationResultBrand=void 0}}n.TokenizationResult=l;class o{constructor(a,L){this.tokens=a,this.endState=L,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=o;var v;(function(s){const a=new Map;a.set(0,A.Codicon.symbolMethod),a.set(1,A.Codicon.symbolFunction),a.set(2,A.Codicon.symbolConstructor),a.set(3,A.Codicon.symbolField),a.set(4,A.Codicon.symbolVariable),a.set(5,A.Codicon.symbolClass),a.set(6,A.Codicon.symbolStruct),a.set(7,A.Codicon.symbolInterface),a.set(8,A.Codicon.symbolModule),a.set(9,A.Codicon.symbolProperty),a.set(10,A.Codicon.symbolEvent),a.set(11,A.Codicon.symbolOperator),a.set(12,A.Codicon.symbolUnit),a.set(13,A.Codicon.symbolValue),a.set(15,A.Codicon.symbolEnum),a.set(14,A.Codicon.symbolConstant),a.set(15,A.Codicon.symbolEnum),a.set(16,A.Codicon.symbolEnumMember),a.set(17,A.Codicon.symbolKeyword),a.set(27,A.Codicon.symbolSnippet),a.set(18,A.Codicon.symbolText),a.set(19,A.Codicon.symbolColor),a.set(20,A.Codicon.symbolFile),a.set(21,A.Codicon.symbolReference),a.set(22,A.Codicon.symbolCustomColor),a.set(23,A.Codicon.symbolFolder),a.set(24,A.Codicon.symbolTypeParameter),a.set(25,A.Codicon.account),a.set(26,A.Codicon.issues);function L(R){let E=a.get(R);return E||(console.info("No codicon found for CompletionItemKind "+R),E=A.Codicon.symbolProperty),E}s.toIcon=L;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function w(R,E){let M=d.get(R);return typeof M>"u"&&!E&&(M=9),M}s.fromString=w})(v||(n.CompletionItemKinds=v={}));var e;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class b{constructor(a,L,d,w){this.range=a,this.text=L,this.completionKind=d,this.isSnippetText=w}equals(a){return i.Range.lift(this.range).equalsRange(a.range)&&this.text===a.text&&this.completionKind===a.completionKind&&this.isSnippetText===a.isSnippetText}}n.SelectedSuggestionInfo=b;var u;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(u||(n.SignatureHelpTriggerKind=u={}));var f;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(f||(n.DocumentHighlightKind=f={}));function m(s){return s&&D.URI.isUri(s.uri)&&i.Range.isIRange(s.range)&&(i.Range.isIRange(s.originSelectionRange)||i.Range.isIRange(s.targetSelectionRange))}n.isLocationLink=m,n.symbolKindNames={[17]:(0,g.localize)(0,null),[16]:(0,g.localize)(1,null),[4]:(0,g.localize)(2,null),[13]:(0,g.localize)(3,null),[8]:(0,g.localize)(4,null),[9]:(0,g.localize)(5,null),[21]:(0,g.localize)(6,null),[23]:(0,g.localize)(7,null),[7]:(0,g.localize)(8,null),[0]:(0,g.localize)(9,null),[11]:(0,g.localize)(10,null),[10]:(0,g.localize)(11,null),[19]:(0,g.localize)(12,null),[5]:(0,g.localize)(13,null),[1]:(0,g.localize)(14,null),[2]:(0,g.localize)(15,null),[20]:(0,g.localize)(16,null),[15]:(0,g.localize)(17,null),[18]:(0,g.localize)(18,null),[24]:(0,g.localize)(19,null),[3]:(0,g.localize)(20,null),[6]:(0,g.localize)(21,null),[14]:(0,g.localize)(22,null),[22]:(0,g.localize)(23,null),[25]:(0,g.localize)(24,null),[12]:(0,g.localize)(25,null)};function c(s,a){return(0,g.localize)(26,null,s,n.symbolKindNames[a])}n.getAriaLabelForSymbol=c;var N;(function(s){const a=new Map;a.set(0,A.Codicon.symbolFile),a.set(1,A.Codicon.symbolModule),a.set(2,A.Codicon.symbolNamespace),a.set(3,A.Codicon.symbolPackage),a.set(4,A.Codicon.symbolClass),a.set(5,A.Codicon.symbolMethod),a.set(6,A.Codicon.symbolProperty),a.set(7,A.Codicon.symbolField),a.set(8,A.Codicon.symbolConstructor),a.set(9,A.Codicon.symbolEnum),a.set(10,A.Codicon.symbolInterface),a.set(11,A.Codicon.symbolFunction),a.set(12,A.Codicon.symbolVariable),a.set(13,A.Codicon.symbolConstant),a.set(14,A.Codicon.symbolString),a.set(15,A.Codicon.symbolNumber),a.set(16,A.Codicon.symbolBoolean),a.set(17,A.Codicon.symbolArray),a.set(18,A.Codicon.symbolObject),a.set(19,A.Codicon.symbolKey),a.set(20,A.Codicon.symbolNull),a.set(21,A.Codicon.symbolEnumMember),a.set(22,A.Codicon.symbolStruct),a.set(23,A.Codicon.symbolEvent),a.set(24,A.Codicon.symbolOperator),a.set(25,A.Codicon.symbolTypeParameter);function L(d){let w=a.get(d);return w||(console.info("No codicon found for SymbolKind "+d),w=A.Codicon.symbolProperty),w}s.toIcon=L})(N||(n.SymbolKinds=N={}));class C{}n.TextEdit=C;class y{static fromValue(a){switch(a){case"comment":return y.Comment;case"imports":return y.Imports;case"region":return y.Region}return new y(a)}constructor(a){this.value=a}}n.FoldingRangeKind=y,y.Comment=new y("comment"),y.Imports=new y("imports"),y.Region=new y("region");var p;(function(s){function a(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}s.is=a})(p||(n.Command=p={}));var S;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(S||(n.InlayHintKind=S={}));class r{constructor(a){this.createSupport=a,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(a=>{a&&a.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new h.TokenizationRegistry}),Y(X[66],J([0,1,38,9,36,18,4,2,41,65,58]),function(T,n,A,D,i,h,g,_,l,o,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(f,m){return(0,i.KeyChord)(f,m)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:D.Emitter,KeyCode:v.KeyCode,KeyMod:e,Position:g.Position,Range:_.Range,Selection:l.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:h.URI,Token:o.Token}}n.createMonacoBaseAPI=b}),Y(X[68],J([0,1,24,18,4,2,55,28,51,52,66,23,57,49,14,50]),function(T,n,A,D,i,h,g,_,l,o,v,e,b,u,f,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class c extends g.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(p){const S=[];for(let r=0;r<this._lines.length;r++){const s=this._lines[r],a=this.offsetAt(new i.Position(r+1,1)),L=s.matchAll(p);for(const d of L)(d.index||d.index===0)&&(d.index=d.index+a),S.push(d)}return S}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(p){return this._lines[p-1]}getWordAtPosition(p,S){const r=(0,_.getWordAtText)(p.column,(0,_.ensureValidWordDefinition)(S),this._lines[p.lineNumber-1],0);return r?new h.Range(p.lineNumber,r.startColumn,p.lineNumber,r.endColumn):null}words(p){const S=this._lines,r=this._wordenize.bind(this);let s=0,a="",L=0,d=[];return{*[Symbol.iterator](){for(;;)if(L<d.length){const w=a.substring(d[L].start,d[L].end);L+=1,yield w}else if(s<S.length)a=S[s],d=r(a,p),L=0,s+=1;else break}}}getLineWords(p,S){const r=this._lines[p-1],s=this._wordenize(r,S),a=[];for(const L of s)a.push({word:r.substring(L.start,L.end),startColumn:L.start+1,endColumn:L.end+1});return a}_wordenize(p,S){const r=[];let s;for(S.lastIndex=0;(s=S.exec(p))&&s[0].length!==0;)r.push({start:s.index,end:s.index+s[0].length});return r}getValueInRange(p){if(p=this._validateRange(p),p.startLineNumber===p.endLineNumber)return this._lines[p.startLineNumber-1].substring(p.startColumn-1,p.endColumn-1);const S=this._eol,r=p.startLineNumber-1,s=p.endLineNumber-1,a=[];a.push(this._lines[r].substring(p.startColumn-1));for(let L=r+1;L<s;L++)a.push(this._lines[L]);return a.push(this._lines[s].substring(0,p.endColumn-1)),a.join(S)}offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.lineNumber-2)+(p.column-1)}positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(p),r=this._lines[S.index].length;return{lineNumber:1+S.index,column:1+Math.min(S.remainder,r)}}_validateRange(p){const S=this._validatePosition({lineNumber:p.startLineNumber,column:p.startColumn}),r=this._validatePosition({lineNumber:p.endLineNumber,column:p.endColumn});return S.lineNumber!==p.startLineNumber||S.column!==p.startColumn||r.lineNumber!==p.endLineNumber||r.column!==p.endColumn?{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:r.lineNumber,endColumn:r.column}:p}_validatePosition(p){if(!i.Position.isIPosition(p))throw new Error("bad position");let{lineNumber:S,column:r}=p,s=!1;if(S<1)S=1,r=1,s=!0;else if(S>this._lines.length)S=this._lines.length,r=this._lines[S-1].length+1,s=!0;else{const a=this._lines[S-1].length+1;r<1?(r=1,s=!0):r>a&&(r=a,s=!0)}return s?{lineNumber:S,column:r}:p}}class N{constructor(p,S){this._host=p,this._models=Object.create(null),this._foreignModuleFactory=S,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(p){return this._models[p]}_getModels(){const p=[];return Object.keys(this._models).forEach(S=>p.push(this._models[S])),p}acceptNewModel(p){this._models[p.url]=new c(D.URI.parse(p.url),p.lines,p.EOL,p.versionId)}acceptModelChanged(p,S){if(!this._models[p])return;this._models[p].onEvents(S)}acceptRemovedModel(p){this._models[p]&&delete this._models[p]}computeUnicodeHighlights(p,S,r){return le(this,void 0,void 0,function*(){const s=this._getModel(p);return s?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(s,S,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(p,S,r,s){return le(this,void 0,void 0,function*(){const a=this._getModel(p),L=this._getModel(S);return!a||!L?null:N.computeDiff(a,L,r,s)})}static computeDiff(p,S,r,s){const a=s==="advanced"?u.linesDiffComputers.getDefault():u.linesDiffComputers.getLegacy(),L=p.getLinesContent(),d=S.getLinesContent(),w=a.computeDiff(L,d,r),R=w.changes.length>0?!1:this._modelsAreIdentical(p,S);function E(M){return M.map(F=>{var B;return[F.original.startLineNumber,F.original.endLineNumberExclusive,F.modified.startLineNumber,F.modified.endLineNumberExclusive,(B=F.innerChanges)===null||B===void 0?void 0:B.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:R,quitEarly:w.hitTimeout,changes:E(w.changes),moves:w.moves.map(M=>[M.lineRangeMapping.original.startLineNumber,M.lineRangeMapping.original.endLineNumberExclusive,M.lineRangeMapping.modified.startLineNumber,M.lineRangeMapping.modified.endLineNumberExclusive,E(M.changes)])}}static _modelsAreIdentical(p,S){const r=p.getLineCount(),s=S.getLineCount();if(r!==s)return!1;for(let a=1;a<=r;a++){const L=p.getLineContent(a),d=S.getLineContent(a);if(L!==d)return!1}return!0}computeMoreMinimalEdits(p,S,r){return le(this,void 0,void 0,function*(){const s=this._getModel(p);if(!s)return S;const a=[];let L;S=S.slice(0).sort((w,R)=>{if(w.range&&R.range)return h.Range.compareRangesUsingStarts(w.range,R.range);const E=w.range?0:1,M=R.range?0:1;return E-M});let d=0;for(let w=1;w<S.length;w++)h.Range.getEndPosition(S[d].range).equals(h.Range.getStartPosition(S[w].range))?(S[d].range=h.Range.fromPositions(h.Range.getStartPosition(S[d].range),h.Range.getEndPosition(S[w].range)),S[d].text+=S[w].text):(d++,S[d]=S[w]);S.length=d+1;for(let{range:w,text:R,eol:E}of S){if(typeof E=="number"&&(L=E),h.Range.isEmpty(w)&&!R)continue;const M=s.getValueInRange(w);if(R=R.replace(/\r\n|\n|\r/g,s.eol),M===R)continue;if(Math.max(R.length,M.length)>N._diffLimit){a.push({range:w,text:R});continue}const F=(0,A.stringDiff)(M,R,r),B=s.offsetAt(h.Range.lift(w).getStartPosition());for(const I of F){const U=s.positionAt(B+I.originalStart),k=s.positionAt(B+I.originalStart+I.originalLength),x={text:R.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:k.lineNumber,endColumn:k.column}};s.getValueInRange(x.range)!==x.text&&a.push(x)}}return typeof L=="number"&&a.push({eol:L,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(p){return le(this,void 0,void 0,function*(){const S=this._getModel(p);return S?(0,l.computeLinks)(S):null})}computeDefaultDocumentColors(p){return le(this,void 0,void 0,function*(){const S=this._getModel(p);return S?(0,m.computeDefaultDocumentColors)(S):null})}textualSuggest(p,S,r,s){return le(this,void 0,void 0,function*(){const a=new e.StopWatch,L=new RegExp(r,s),d=new Set;e:for(const w of p){const R=this._getModel(w);if(R){for(const E of R.words(L))if(!(E===S||!isNaN(Number(E)))&&(d.add(E),d.size>N._suggestionsLimit))break e}}return{words:Array.from(d),duration:a.elapsed()}})}computeWordRanges(p,S,r,s){return le(this,void 0,void 0,function*(){const a=this._getModel(p);if(!a)return Object.create(null);const L=new RegExp(r,s),d=Object.create(null);for(let w=S.startLineNumber;w<S.endLineNumber;w++){const R=a.getLineWords(w,L);for(const E of R){if(!isNaN(Number(E.word)))continue;let M=d[E.word];M||(M=[],d[E.word]=M),M.push({startLineNumber:w,startColumn:E.startColumn,endLineNumber:w,endColumn:E.endColumn})}}return d})}navigateValueSet(p,S,r,s,a){return le(this,void 0,void 0,function*(){const L=this._getModel(p);if(!L)return null;const d=new RegExp(s,a);S.startColumn===S.endColumn&&(S={startLineNumber:S.startLineNumber,startColumn:S.startColumn,endLineNumber:S.endLineNumber,endColumn:S.endColumn+1});const w=L.getValueInRange(S),R=L.getWordAtPosition({lineNumber:S.startLineNumber,column:S.startColumn},d);if(!R)return null;const E=L.getValueInRange(R);return o.BasicInplaceReplace.INSTANCE.navigateValueSet(S,w,R,E,r)})}loadForeignModule(p,S,r){const s=(d,w)=>this._host.fhr(d,w),L={host:(0,f.createProxyObject)(r,s),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(L,S),Promise.resolve((0,f.getAllMethodNames)(this._foreignModule))):new Promise((d,w)=>{T([p],R=>{this._foreignModule=R.create(L,S),d((0,f.getAllMethodNames)(this._foreignModule))},w)})}fmr(p,S){if(!this._foreignModule||typeof this._foreignModule[p]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+p));try{return Promise.resolve(this._foreignModule[p].apply(this._foreignModule,S))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=N,N._diffLimit=1e5,N._suggestionsLimit=1e4;function C(y){return new N(y,null)}n.create=C,typeof importScripts=="function"&&(globalThis.monaco=(0,v.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map